<?php

/**
 * @link http://www.yiiframework.com/
 * @copyright Copyright (c) 2008 Yii Software LLC
 * @license http://www.yiiframework.com/license/
 */

namespace app\commands;

use yii\console\Controller;
use yii;
use yii\helpers\ArrayHelper;
use app\components\purchases\ClientSiesa;

/**
 * This command echoes the first argument that you have entered.
 *
 * This command is provided as an example for you to learn how to create console commands.
 *
 * @author Qiang Xue <qiang.xue@gmail.com>
 * @since 2.0
 */
class InsertitemsController extends Controller {
    
    const TIPO_INV = 'Inventarios';
    const TIPO_VENTAS = 'Ventas';
    const TIPO_ORD_COMPRA = 'Ordenes_compra';
    const TIPO_PEDIDOS = 'Pedidos';
    
    /**
     * 
     */
    public function actionIndex() { 
        set_time_limit(3600);
		\Yii::error('InsertitemsController #######-'.date('Y-m-d H:i:s'));
        $this->_resumenInventario();
    }
    
    /**
     * Metodo para realizar el prcesamiento del inventario, 
     * realiza el calculo de ventas e inventario, organiza y realiza la
     * insercion en bade de datos
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _resumenInventario() {
        $clientSiesa = new ClientSiesa();
        $cellars = $clientSiesa->getCellars();
		/*\Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($cellars, true) . '}');*/
        if (count($cellars) > 0) {            
            $endDate = date('d-m-Y', mktime(0, 0, 0, date('m'), date('d')+1, date('Y')));
            $startDate = date('01-m-Y');             
            $eDate = date('d-m-Y');
            $endDateSales = date('t-m-Y', strtotime('-1 month'));            
            $startDateSales = date('01-m-Y', strtotime('-3 month'));
            
            foreach ($cellars as $cellar) {
                
                $arrayData = array();
                
                $result = $this->_getInventory($cellar['cellar_code'], 
                $startDate, $endDate, $eDate, $startDateSales, $endDateSales);
				if($cellar['cellar_code'] == 'MED1'){
                    //  \Yii::error(__FILE__ . ':' . __LINE__ . '{'. print_r($result, true) . '}', 'clientsiesa');
	            }
                
                $variations = $this->_getVariation($cellar['cellar_code'],$startDateSales, $endDateSales);
                $arrayVariations = ArrayHelper::index($variations, 'item', 'proveedor');
                
                if (count($result) > 0) {

                    Yii::$app->db->createCommand("DELETE FROM items WHERE cellar_id ='".$cellar['cellar_code']."'")->execute();

                    $first = $result[0];
                    $beforeReference = trim($first['item']);
                    
                    $cantVendida = 0;
                    $cantInv = 0;
                    $cantPedido = 0;
                    $cantOrdCompra = 0;
                    $desviationInv = 0;
                    $desviationSal = 0;
                    $desviationPur = 0;
                    $desviationOrd = 0;
                    $averageInv = 0;
                    $averageSal = 0;
                    $averagePur = 0;
                    $averageOrd = 0;
                    $variationInv = 0;
                    $variationSal = 0;
                    $variationPur = 0;
                    $variationOrd = 0;
                    
                    switch ($first['tipo']) {
                        case self::TIPO_VENTAS:
                            $proveedor = $first['proveedor'];
                            $item = $first['item'];
                            $cantVendida = (int) $first['cantidad'];
                            // $desviationSal = (double) $first['desviacion'];
                            // $averageSal = (double) $first['promedio'];
                            // $variationSal = (double) $first['variacion'];
                            $desviationSal = (double) isset($arrayVariations[$proveedor][$item]['desviacion'])
                                    ? $arrayVariations[$proveedor][$item]['desviacion']:0;
                            $averageSal = (double) isset($arrayVariations[$proveedor][$item]['promedio'])
                                    ? $arrayVariations[$proveedor][$item]['promedio']:0;
                            $variationSal = (double) isset($arrayVariations[$proveedor][$item]['variacion'])
                                    ? $arrayVariations[$proveedor][$item]['variacion']:0;
                            break;
                        case self::TIPO_INV:
                            $cantInv = (int) $first['cantidad'];
                            $desviationInv = (double) $first['desviacion'];
                            $averageInv = (double) $first['promedio'];
                            $variationInv = (double) $first['variacion'];
                            break;
                        case self::TIPO_PEDIDOS:
                            $cantPedido = (int) $first['cantidad'];
                            $desviationOrd = (double) $first['desviacion'];
                            $averageOrd = (double) $first['promedio'];
                            $variationOrd = (double) $first['variacion'];
                            break;
                        case self::TIPO_ORD_COMPRA:
                            $cantOrdCompra = (int) $first['cantidad'];
                            $desviationPur = (double) $first['desviacion'];
                            $averagePur = (double) $first['promedio'];
                            $variationPur = (double) $first['variacion'];
                            break;
                    }
                    
                    $data = [];
                    $data['reference'] = trim($first['item']);
                    $data['description'] = trim($first['Nombre_Item']);
                    //$data['unit_value'] = (int) $first['precio'];
                    $data['unit_value'] = trim($first['precio']);
                    $data['provider_id'] = trim($first['proveedor']);
                    $data['branch_id'] = trim($first['Sucursal_proveedor']);
                    $data['cellar_id'] = trim($first['Bodega']);
                    $data['quantity_sold'] = $cantVendida;
                    $data['quantity_inventory'] = $cantInv;
                    $data['quantity_committed'] = $cantPedido;
                    $data['quantity_transit'] = $cantOrdCompra;
                    $data['abc'] = trim($first['ABC']);
                    $data['measured_unit'] = trim($first['unidad_medida']);
                    $data['deviation_inventory'] = $desviationInv;
                    $data['deviation_sales'] = $cantVendida;
                    $data['deviation_purchases'] = $desviationPur;
                    $data['deviation_orders'] = $desviationOrd;
                    $data['average_inventory'] = $averageInv;
                    $data['average_sales'] = $averageSal;
                    $data['average_purchases'] = $averagePur;
                    $data['average_orders'] = $averageOrd;
                    $data['variation_inventory'] = $variationInv;
                    $data['variation_sales'] = $variationSal;
                    $data['variation_purchases'] = $variationPur;
                    $data['variation_orders'] = $variationOrd;
                    $beforeData = $data;

                    $arrayItems = [];
                    foreach ($result as $keyData  => $value) {
                        $arrayItems[trim($value['item'])] = trim($value['item']);
                        switch ($value['tipo']) {
                            case self::TIPO_VENTAS:
                                $cantVendida = (int) $value['cantidad'];
                                // $desviationSal = (double) $value['desviacion'];
                                // $averageSal = (double) $value['promedio'];
                                // $variationSal = (double) $value['variacion'];
                                $proveedor = $value['proveedor'];
                                $item = $value['item'];                      
                                $desviationSal = (double) isset($arrayVariations[$proveedor][$item]['desviacion'])
                                        ? $arrayVariations[$proveedor][$item]['desviacion'] : 0;
                                $averageSal = (double) isset($arrayVariations[$proveedor][$item]['promedio'])
                                        ?$arrayVariations[$proveedor][$item]['promedio']:0;
                                $variationSal = (double) isset($arrayVariations[$proveedor][$item]['variacion'])
                                        ?$arrayVariations[$proveedor][$item]['variacion']:0;
                                break;
                            case self::TIPO_INV:
                                $cantInv = (int) $value['cantidad'];
                                $desviationInv = (double) $value['desviacion'];
                                $averageInv = (double) $value['promedio'];
                                $variationInv = (double) $value['variacion'];
                                break;
                            case self::TIPO_PEDIDOS:
                                $cantPedido = (int) $value['cantidad'];
                                $desviationOrd = (double) $value['desviacion'];
                                $averageOrd = (double) $value['promedio'];
                                $variationOrd = (double) $value['variacion'];
                                break;
                            case self::TIPO_ORD_COMPRA:
                                $cantOrdCompra = (int) $value['cantidad'];
                                $desviationPur = (double) $value['desviacion'];
                                $averagePur = (double) $value['promedio'];
                                $variationPur = (double) $value['variacion'];
                                break;
                        }

                        if (trim($value['item']) != $beforeReference || (($keyData+1) === count($result)) ) {                            
                            $data = array();
                            $data['reference'] = trim($value['item']);
                            $data['description'] = trim($value['Nombre_Item']);
                            //$data['unit_value'] = (int) $value['precio'];
                            $data['unit_value'] = $value['precio'];
                            $data['provider_id'] = trim($value['proveedor']);
                            $data['branch_id'] = trim($value['Sucursal_proveedor']);
                            $data['cellar_id'] = trim($value['Bodega']);
                            $data['quantity_sold'] = $cantVendida;
                            $data['quantity_inventory'] = $cantInv;
                            $data['quantity_committed'] = $cantPedido;
                            $data['quantity_transit'] = $cantOrdCompra;
                            $data['abc'] = $value['ABC'];
                            $data['measured_unit'] = trim($value['unidad_medida']);
                            $data['deviation_inventory'] = $desviationInv;
                            $data['deviation_sales'] = $desviationSal;
                            $data['deviation_purchases'] = $desviationPur;
                            $data['deviation_orders'] = $desviationOrd;
                            $data['average_inventory'] = $averageInv;
                            $data['average_sales'] = $averageSal;
                            $data['average_purchases'] = $averagePur;
                            $data['average_orders'] = $averageOrd;
                            $data['variation_inventory'] = $variationInv;
                            $data['variation_sales'] = $variationSal;
                            $data['variation_purchases'] = $variationPur;
                            $data['variation_orders'] = $variationOrd;
                            
                            $cantVendida = 0;
                            $cantInv = 0;
                            $cantPedido = 0;
                            $cantOrdCompra = 0;
                            $desviationInv = 0;
                            $desviationSal = 0;
                            $desviationPur = 0;
                            $desviationOrd = 0;
                            $averageInv = 0;
                            $averageSal = 0;
                            $averagePur = 0;
                            $averageOrd = 0;
                            $variationInv = 0;
                            $variationSal = 0;
                            $variationPur = 0;
                            $variationOrd = 0;
                            
                            $arrayData[] = $beforeData;

                            if (($keyData+1) === count($result)) {
                                $arrayData[] = $data;                                
                            }                            
                            $beforeData = $data;
                        } else {
                            switch ($value['tipo']) {
                                case self::TIPO_VENTAS:
                                    $proveedor = $value['proveedor'];
                                    $item = $value['item'];
                                    // $beforeData['quantity_sold'] = (int) $value['cantidad'];
                                    // $beforeData['deviation_sales'] = (double) $value['desviacion'];
                                    // $beforeData['average_sales'] = (double) $value['promedio'];
                                    // $beforeData['variation_sales'] = (double) $value['variacion'];
                                    $beforeData['deviation_sales']  = (double) isset($arrayVariations[$proveedor][$item]['desviacion'])
                                            ? $arrayVariations[$proveedor][$item]['desviacion']: 0;
                                    $beforeData['average_sales'] = (double) isset($arrayVariations[$proveedor][$item]['promedio'])
                                            ? $arrayVariations[$proveedor][$item]['promedio']: 0;
                                    $beforeData['variation_sales'] = (double) isset($arrayVariations[$proveedor][$item]['variacion'])
                                            ? $arrayVariations[$proveedor][$item]['variacion'] : 0;
                                    break;
                                case self::TIPO_INV:
                                    $beforeData['quantity_inventory'] = (int) $value['cantidad'];
                                    $beforeData['deviation_inventory'] = (double) $value['desviacion'];
                                    $beforeData['average_inventory'] = (double) $value['promedio'];
                                    $beforeData['variation_inventory'] = (double) $value['variacion'];
                                    break;
                                case self::TIPO_PEDIDOS:
                                    $beforeData['quantity_committed'] = (int) $value['cantidad'];
                                    $beforeData['deviation_orders'] = (double) $value['desviacion'];
                                    $beforeData['average_orders'] = (double) $value['promedio'];
                                    $beforeData['variation_orders'] = (double) $value['variacion'];
                                    break;
                                case self::TIPO_ORD_COMPRA:
                                    $beforeData['quantity_transit'] = (int) $value['cantidad'];
                                    $beforeData['deviation_purchases'] = (double) $value['desviacion'];
                                    $beforeData['average_purchases'] = (double) $value['promedio'];
                                    $beforeData['variation_purchases'] = (double) $value['variacion'];
                                    break;                                                                                            
                            }
                            $cantVendida = 0;
                            $cantInv = 0;
                            $cantPedido = 0;
                            $cantOrdCompra = 0;
                            $desviationInv = 0;
                            $desviationSal = 0;
                            $desviationPur = 0;
                            $desviationOrd = 0;
                            $averageInv = 0;
                            $averageSal = 0;
                            $averagePur = 0;
                            $averageOrd = 0;
                            $variationInv = 0;
                            $variationSal = 0;
                            $variationPur = 0;
                            $variationOrd = 0;
                        }
                                                                       
                        $cantVendida = 0;
                        $cantInv = 0;
                        $cantPedido = 0;
                        $cantOrdCompra = 0;
                        $desviationInv = 0;
                        $desviationSal = 0;
                        $desviationPur = 0;
                        $desviationOrd = 0;
                        $averageInv = 0;
                        $averageSal = 0;
                        $averagePur = 0;
                        $averageOrd = 0;
                        $variationInv = 0;
                        $variationSal = 0;
                        $variationPur = 0;
                        $variationOrd = 0;
                        $beforeReference = trim($value['item']);
                    }
                }
                
                $this->_insertReferencia($arrayData);
            }
        }
    }

    
    
    /**
     * Metodo para la insercion en bloque de las referencias
     * segun el proveedor
     * 
     * @param array $data
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _insertReferencia($data) {
        try {
            $column = [
                'reference',
                'description',
                'unit_value',
                'provider_id',
                'branch_id',
                'cellar_id',
                'quantity_sold',
                'quantity_inventory',
                'quantity_committed',
                'quantity_transit',
                'abc',
                'measured_unit',
                'deviation_inventory',
                'deviation_sales',
                'deviation_purchases',
                'deviation_orders',
                'average_inventory',
                'average_sales',
                'average_purchases',
                'average_orders',
                'variation_inventory',
                'variation_sales',
                'variation_purchases',
                'variation_orders',
            ];
            $command = Yii::$app->db->createCommand()
                    ->batchInsert('items', $column, $data)->execute();
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($data, true) . '}', 'clientsiesa');
        }
    }

    /**
     * Metodo para obtener la informacion de inentario para todos
     * los proveedores segun la bodega y el rango de fecha 
     * 
     * @param int    $cellarId Identificador de la bodega
     * @param string $startDate  Fecha Inicial fotmato(dd-mm-YYYY)
     * @param string $endDate Fecha Final fotmato(dd-mm-YYYY)
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getInventory($cellarId, $startDate, $endDate, $eDate, 
            $startDateSales, $endDateSales) {
        $arrayResult = array();
        try {
            $sql = "
                SET NOCOUNT ON;			

                SELECT
                qry.tipo,
                RTRIM(LTRIM(qry.item)) as item,
                qry.Nombre_Item,
                qry.Bodega,
                RTRIM(LTRIM(qry_prov.proveedor)) as proveedor,
                qry_prov.razon_social,
                qry_prov.Sucursal_proveedor,
                qry_prov.precio,
                qry.cantidad,
                qry.desviacion,
                qry.promedio,
                0 as variacion,
                T132.f132_abc_rotacion_veces ABC,
                -- f131_id_unidad_medida unidad_medida
                (CASE WHEN qry.unidad_medida IS NULL THEN 'UNID' ELSE qry.unidad_medida END) unidad_medida
                FROM (
                
                --QUERY VENTAS
                SELECT
                    'Ventas' As Tipo,
                    T120.f120_referencia AS Item,
                    T120.f120_descripcion AS Nombre_Item,
                    T120.f120_id_unidad_empaque AS unidad_medida,
                    MFV.f470_rowid_item_ext as RItem,
                    T150.F150_ID As Bodega,
                    T150.F150_id_instalacion As Instalacion,
                    SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS Cantidad,
                    -- STDEV((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS desviacion,
                    -- AVG((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS promedio,
                    0 AS desviacion,
                    0 AS promedio,
                    sum(CASE WHEN MFV.F470_ID_CONCEPTO = '502' AND MFV.F470_ID_PERIODO = (YEAR('" . $endDateSales . "')*100+MONTH('" . $endDate . "'))
                    THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) AS Periodo,
                    sum(CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END)/6 AS Consumo
                FROM
                (T150_MC_BODEGAS T150 RIGHT OUTER JOIN
                    (t120_mc_items T120 RIGHT OUTER JOIN
                    (t121_mc_items_extensiones T121 RIGHT OUTER JOIN
                        (t470_cm_movto_invent MFV INNER JOIN t461_cm_docto_factura_venta FV
                        ON MFV.f470_rowid_docto_fact = FV.f461_rowid_docto
                        INNER JOIN t350_co_docto_contable DOCFAC
                        ON DOCFAC.f350_rowid = FV.f461_rowid_docto)
                    ON T121.f121_rowid = MFV.f470_rowid_item_ext)
                    ON T120.f120_rowid = T121.f121_rowid_item)
                    ON T150.F150_ROWID = MFV.F470_ROWID_BODEGA)
                WHERE (MFV.f470_id_fecha BETWEEN '" . $startDateSales . "' AND '" . $endDateSales . "' )
                    AND T150.F150_ID =('" . trim(str_replace("&amp;","&",$cellarId)) . "')
                    AND mfv.F470_ID_CIA = 1
                    AND f121_ind_estado = 1
                GROUP BY 
                    T120.f120_referencia,
                    T120.f120_descripcion, 
                    T120.f120_id_unidad_empaque,
                    mfv.F470_ROWID_ITEM_EXT, 
                    T150.F150_ID, 
                    T150.F150_id_instalacion

                UNION

                --QUERY INVENTARIOS
                Select
                'Inventarios' As Tipo,
                T120.f120_referencia As Item,
                T120.f120_descripcion AS Nombre_Item,
                T120.f120_id_unidad_empaque AS unidad_medida,
                T470.F470_ROWID_ITEM_EXT AS RItem,
                T150.F150_ID As Bodega,
                T150.F150_id_instalacion As Instalacion,
                Sum(CASE WHEN T470.F470_IND_NATURALEZA = 1 THEN T470.F470_CANT_1 ELSE T470.F470_CANT_1*-1 END) As Cantidad,
                -- STDEV(CASE WHEN T470.F470_IND_NATURALEZA = 1 THEN T470.F470_CANT_1 ELSE T470.F470_CANT_1*-1 END) As desviacion,
                -- AVG(CASE WHEN T470.F470_IND_NATURALEZA = 1 THEN T470.F470_CANT_1 ELSE T470.F470_CANT_1*-1 END) As promedio,
                0 As desviacion,
                0 As promedio,
                sum(CASE WHEN T470.F470_ID_CONCEPTO = '502' AND T470.F470_ID_PERIODO = (YEAR('" . $endDate . "')*100+MONTH('" . $endDate . "'))
                    THEN T470.f470_cant_1*-1 ELSE T470.f470_cant_1 END) AS Periodo,
                sum(CASE WHEN T470.F470_ID_CONCEPTO = '502' THEN T470.f470_cant_1*-1 ELSE T470.f470_cant_1 END)/6 AS Consumo
                From
                (T150_MC_BODEGAS T150 Right Outer Join
                (T120_MC_ITEMS T120 Right Outer Join
                    (T121_MC_ITEMS_EXTENSIONES T121 Right Outer Join T470_CM_MOVTO_INVENT T470
                    On T121.F121_ROWID = T470.F470_ROWID_ITEM_EXT)
                On T120.F120_ROWID = T121.F121_ROWID_ITEM)
                On T150.F150_ROWID = T470.F470_ROWID_BODEGA)
                Where
                T470.F470_ID_fecha <= '" . $endDate . "'
                AND T470.F470_IND_ESTADO_CM  <> '2'
                AND T120.F120_IND_TIPO_ITEM = '1'
                AND T470.F470_ID_CIA = 1
                AND T150.F150_ID =('" . trim(str_replace("&amp;","&",$cellarId)) . "')
                AND f121_ind_estado = 1
                Group By
                T120.f120_referencia,
                T120.f120_descripcion,
                T120.f120_id_unidad_empaque,
                T470.F470_ROWID_ITEM_EXT,
                T150.F150_ID,
                T150.F150_id_instalacion

                UNION

                --QUERY ORDEN DE COMPRA
                SELECT
                    'Ordenes_compra' as Tipo,
                    T120.f120_referencia AS Item,
                    T120.f120_descripcion AS Nombre_Item,
                    T120.f120_id_unidad_empaque AS unidad_medida,
                    T421.f421_rowid_item_ext AS RItem,
                    T150.f150_id AS Bodega,
                    T150.F150_id_instalacion As Instalacion,
                    SUM(T421.f421_cant_pedida) AS Cantidad,
                    0 AS desviacion,
                    0 AS promedio,
                    0 AS Periodo,
                    0 AS Consumo
                FROM t054_mm_estados C054 RIGHT OUTER JOIN
                (t150_mc_bodegas T150 RIGHT OUTER JOIN
                (t120_mc_items T120 RIGHT OUTER JOIN
                    (t121_mc_items_extensiones T121 RIGHT OUTER JOIN
                    (t420_cm_oc_docto T420 INNER JOIN t421_cm_oc_movto T421
                    ON T420.f420_id_cia = T421.f421_id_cia
                    AND T420.f420_rowid = T421.f421_rowid_oc_docto)
                    ON T121.f121_rowid = T421.f421_rowid_item_ext)
                    ON T121.f121_rowid_item = T120.f120_rowid)
                ON T150.f150_rowid = T421.f421_rowid_bodega)
                ON ( ( C054.f054_id = T420.f420_ind_estado and c054.f054_id_grupo_clase_docto= t420.f420_id_grupo_clase_docto) )
                WHERE ( T420.f420_fecha <= '" . $endDate . "' )
                    AND T420.f420_ind_estado IN(1,2)
                    AND T420.f420_id_cia = 1
                    AND T150.f150_id =('" . trim(str_replace("&amp;","&",$cellarId)) . "')
                    AND f121_ind_estado = 1
                GROUP BY T120.f120_referencia,
                    T120.f120_descripcion,
                    T120.f120_id_unidad_empaque,
                    T421.f421_rowid_item_ext,
                    T150.f150_id,
                    T150.F150_id_instalacion

                UNION

                -- QUERY PEDIDOS
                SELECT
                    'Pedidos' as Tipo,
                    T120.f120_referencia AS Item,
                    T120.f120_descripcion AS Nombre_Item,
                    T120.f120_id_unidad_empaque AS unidad_medida,
                    MPV.f431_rowid_item_ext,
                    T150.f150_id AS Bodega,
                    T150.F150_id_instalacion As Instalacion,
                    SUM(MPV.F431_CANT1_PEDIDA) AS Cantidad,
                    0 AS desviacion,
                    0 AS promedio,
                    0 AS Periodo,
                    0 AS Consumo
                FROM
                T430_CM_PV_DOCTO PV INNER JOIN T431_CM_PV_MOVTO MPV
                ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

                LEFT JOIN t121_mc_items_extensiones T121
                ON T121.f121_rowid = MPV.f431_rowid_item_ext
                AND f121_ind_estado = 1

                LEFT JOIN t120_mc_items T120
                ON T120.f120_rowid = T121.f121_rowid_item

                LEFT JOIN t150_mc_bodegas T150
                ON MPV.F431_ROWID_BODEGA = T150.f150_rowid

                Where
                    PV.f430_id_cia = 1
                    AND PV.f430_ind_estado NOT IN(4,9)
                    AND PV.f430_id_fecha BETWEEN '" . $startDate . "' AND '" . $endDate . "'
                    AND PV.f430_ind_facturado = 0
                    AND PV.f430_ind_remisionado = 0
                    AND T150.F150_ID =('" . trim(str_replace("&amp;","&",$cellarId)) . "')
                GROUP BY
                    T120.f120_referencia,
                    T120.f120_descripcion,
                    T120.f120_id_unidad_empaque,
                    MPV.f431_rowid_item_ext,
                    T150.f150_id,
                    T150.F150_id_instalacion

                ) qry

                LEFT JOIN T132_Mc_items_instalacion T132 
                On qry.RItem = T132.f132_rowid_item_ext
                and qry.Instalacion = T132.f132_id_instalacion 	
                and T132.f132_id_instalacion is not null

                LEFT JOIN t131_mc_items_barras T131 ON f131_rowid_item_ext = qry.RItem
                
                --QUERY PROVEEDORES
                INNER JOIN (
                SELECT
                    t470_comp.f470_rowid_item_ext  AS RItem, 
                    t470_comp.f470_id_fecha,
                    T200.f200_id AS Proveedor,
                    T200.f200_razon_social as razon_social, 				
                    dtocmp.f451_id_sucursal_prov AS Sucursal_proveedor, 
                    t470_comp.f470_precio_uni as precio,
                    RANK() OVER (PARTITION BY t470_comp.f470_rowid_item_ext ORDER BY t470_comp.f470_id_fecha  Desc) as RANGO

                FROM  t470_cm_movto_invent t470_comp INNER JOIN t451_cm_docto_compras dtocmp
                ON dtocmp.f451_rowid_docto = t470_comp.f470_rowid_docto

                INNER JOIN t200_mm_terceros t200 
                ON t200.f200_rowid = dtocmp.f451_rowid_tercero_prov 

                WHERE ( dtocmp.f451_id_clase_docto = 409 OR dtocmp.f451_id_clase_docto = 408)	 

                ) qry_prov
                ON qry.ritem = qry_prov.ritem
                AND qry_prov.RANGO = 1
                
                GROUP BY 
                    qry.tipo,
                    qry.item,
                    qry.Nombre_Item,
                    qry.Bodega,
                    qry_prov.proveedor,
                    qry_prov.razon_social,
                    qry_prov.Sucursal_proveedor,
                    qry_prov.precio,
                    qry.cantidad,
                    qry.desviacion,
                    qry.promedio,
                    T132.f132_abc_rotacion_veces,
                    qry.unidad_medida
                ORDER BY qry.item,qry.Bodega
           
            "; 
           
            $arrayResult = Yii::$app->dbsql->createCommand($sql)->queryAll();   
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');            
        }
        return $arrayResult;
    }
    
    /**
     * Metodo para obtener la informacion de inentario para todos
     * los proveedores segun la bodega y el rango de fecha 
     * 
     * @param int    $cellarId Identificador de la bodega
     * @param string $startDate  Fecha Inicial fotmato(dd-mm-YYYY)
     * @param string $endDate Fecha Final fotmato(dd-mm-YYYY)
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getVariation($cellarId, $startDateSales, $endDateSales) {
        $arrayResult = array();
        try {
            $sql = "
                SET NOCOUNT ON;

                SELECT
                qry.tipo,
                qry.item,
                qry.Nombre_Item,
                qry.Bodega,
                LTRIM(RTRIM(qry_prov.proveedor)) AS proveedor,
                qry_prov.razon_social,
                qry_prov.Sucursal_proveedor,
                ISNULL(STDEV(qry.cantidad),0) AS desviacion,
                AVG(qry.cantidad) AS promedio,
                ISNULL((STDEV(qry.cantidad))/nullif(AVG(qry.cantidad),0),0)*100 as variacion
                FROM (

                --QUERY VENTAS
                SELECT
                MONTH(f470_id_fecha) AS MES,
                'Ventas' As Tipo,
                RTRIM(LTRIM(T120.f120_referencia)) AS Item,
                T120.f120_descripcion AS Nombre_Item,
                T120.f120_id_unidad_empaque AS unidad_medida,
                MFV.f470_rowid_item_ext as RItem,
                T150.F150_ID As Bodega,
                T150.F150_id_instalacion As Instalacion,
                SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS Cantidad
                FROM
                (T150_MC_BODEGAS T150 RIGHT OUTER JOIN
                (t120_mc_items T120 RIGHT OUTER JOIN
                (t121_mc_items_extensiones T121 RIGHT OUTER JOIN
                (t470_cm_movto_invent MFV INNER JOIN t461_cm_docto_factura_venta FV
                ON MFV.f470_rowid_docto_fact = FV.f461_rowid_docto
                
                INNER JOIN t350_co_docto_contable DOCFAC
                ON DOCFAC.f350_rowid = FV.f461_rowid_docto)
                ON T121.f121_rowid = MFV.f470_rowid_item_ext)
                ON T120.f120_rowid = T121.f121_rowid_item)
                ON T150.F150_ROWID = MFV.F470_ROWID_BODEGA)
                
                WHERE 
                MFV.f470_id_fecha BETWEEN '" . $startDateSales . "' AND '" . $endDateSales . "'
                AND T150.F150_ID =('" . trim(str_replace("&amp;","&",$cellarId)) . "')
                AND mfv.F470_ID_CIA = 1
                AND f121_ind_estado = 1
                GROUP BY
                MONTH(f470_id_fecha),
                T120.f120_referencia,
                T120.f120_descripcion,
                T120.f120_id_unidad_empaque,
                mfv.F470_ROWID_ITEM_EXT,
                T150.F150_ID,
                T150.F150_id_instalacion

                ) qry

                -- LEFT JOIN t132_mc_items_instalacion INS ON INS.f132_rowid_item_ext = qry.RItem AND INS.f132_mf_rowid_bodega_asigna  =('1')
                LEFT JOIN T132_Mc_items_instalacion T132
                On qry.RItem = T132.f132_rowid_item_ext
                and qry.Instalacion = T132.f132_id_instalacion
                and T132.f132_id_instalacion is not null

                LEFT JOIN t131_mc_items_barras T131 ON f131_rowid_item_ext = qry.RItem

                --QUERY PROVEEDORES
                INNER JOIN (
                SELECT
                t470_comp.f470_rowid_item_ext  AS RItem,
                t470_comp.f470_id_fecha,
                T200.f200_id AS Proveedor,
                T200.f200_razon_social as razon_social,
                dtocmp.f451_id_sucursal_prov AS Sucursal_proveedor,
                RANK() OVER (PARTITION BY t470_comp.f470_rowid_item_ext ORDER BY t470_comp.f470_id_fecha  Desc) as RANGO

                FROM  t470_cm_movto_invent t470_comp INNER JOIN t451_cm_docto_compras dtocmp
                ON dtocmp.f451_rowid_docto = t470_comp.f470_rowid_docto

                INNER JOIN t200_mm_terceros t200
                ON t200.f200_rowid = dtocmp.f451_rowid_tercero_prov

                WHERE ( dtocmp.f451_id_clase_docto = 409 OR dtocmp.f451_id_clase_docto = 408)
                
                ) qry_prov
                ON qry.ritem = qry_prov.ritem
                AND qry_prov.RANGO = 1

                GROUP BY
                qry.tipo,
                qry.item,
                qry.Nombre_Item,
                qry.Bodega,
                qry_prov.proveedor,
                qry_prov.razon_social,
                qry_prov.Sucursal_proveedor
                
                ORDER BY qry.item,qry.Bodega, qry_prov.proveedor

            "; 
            $arrayResult = Yii::$app->dbsql->createCommand($sql)->queryAll();            
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');            
        }
        return $arrayResult;
    }
    
    
}
