<?php

namespace app\components;

use Yii;
use yii\base\Component;
use yii\base\InvalidConfig\Exception;
use yii\helpers\ArrayHelper;
use app\models\Items;
use yii\db\Expression;
use app\models\Fulfillmentprovision;

/**
 * ClientSiesa.php
 *
 * PHP Version 5.3.0
 * 
 * @category category
 * @package package
 * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2019 INGENEO S.A.S.
 * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version SVN: $Id$
 * @link http://www.ingeneo.com.co
 *  
 */

/**
 * ClientSiesa.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category category
 * @package package
 * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2019 INGENEO S.A.S.
 * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version Release: $Id$
 * @link http://www.ingeneo.com.co
 * 
 */
class ReportSiesa extends Component {

    protected static $_instance;

    /**
     * Constructor de la clase
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2019 INGENEO S.A.S.
     * @return    void
     * @access    public
     * 
     */
    public function __construct() {
        
    }

    /**
     * Funcion desctructora 
     *    
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.    
     * @version   Release: $Id$    
     * @access    public     
     * @return    void
     * 
     */
    public function __destruct() {
        
    }

    public static function getInstance() {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }

    /**
     * Retorna la informacion de SIESA para el reporte de cumplimiento por 
     * clientes
     * Consulta dinamica
     * 
     * @param array  $select     Columnas seleccionadas
     * @param string $andWhere   Parametros para el filtro
     * @param array  $groupBy    Agrupacion de parametros
     * @param array  $orderBy    Orden de los parametros
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function reportFulfillmentClient($select, $where, $groupBy, 
            $orderBy, $having, $dateIn, $dateEnd, $clasification = false) {
        $arrayResultQuery = [];
        try {
//            if(!$clasification){
                $query = "
                SET NOCOUNT ON;

                SELECT  TOP(1000)              
                    " . $select . "
                FROM(
                    SELECT
                        YEAR(f430_fecha_ts_cumplido) as year_order,
                        YEAR(f350_fecha) as year_invoice,
                        YEAR(f430_fecha_ts_cumplido) as year_default,
                        DATENAME(M, DATEADD(M, MONTH(f430_fecha_ts_cumplido), -1)) as month_order,
                        DATENAME(M, DATEADD(M, MONTH(f350_fecha), -1)) as month_invoice,
                        DATENAME(M, DATEADD(M, MONTH(f430_fecha_ts_cumplido), -1)) as month_default,
                        DRM.f460_id_co_docto AS operation_center, 
                        DPV.f430_id_tipo_docto AS document_type_order,	
                        DPV.f430_consec_docto AS number_order, 
                        CONVERT(DATE,MPV.f431_fecha_cumplido,103) AS date_order,
                        Docfac.f350_id_tipo_docto AS document_type_invoice,
                        Docfac.f350_consec_docto AS number_invoice, 
                        CONVERT(DATE,Docfac.f350_fecha,103)  AS date_invoice, 
                        PLN.f463_id_tipo_docto AS f463_id_tipo_docto, ------------------------------------
                        PLN.f463_consec_docto AS number_delivery,
                        CONVERT(DATE,PLN.f463_fecha,103)  AS f463_fecha,----------------------------------
                        PREL.f464_ind_estado AS status_delivery,
                        PREL.f464_notas AS reason_delivery,
                        CONVERT(DATE,PREL.f464_fecha_ts_cierre,103) as date_delivery,
                        LTRIM(RTRIM(T200.F200_NIT)) AS nit,
                        LTRIM(RTRIM(f200_razon_social)) AS business_name,
                        LTRIM(RTRIM(DFV.f461_id_sucursal_fact)) AS branch_code,
                        LTRIM(RTRIM(C201.f201_descripcion_sucursal)) AS branch_name,
                        DFV.f461_id_co_fact AS f461_id_co_fact, ----------------------------------
                        T120.f120_id AS f120_id,-------------------------------
                        COUNT(T120.f120_referencia) OVER() AS total_references,
                        SUM(CASE WHEN MPV.f431_cant1_pedida <> MPV.f431_cant1_facturada THEN 1 ELSE 0 END) AS total_ref_inc,
                        LTRIM(RTRIM(T120.f120_referencia)) AS reference,
                        LTRIM(RTRIM(T120.f120_descripcion)) AS description,
                        SUM(MPV.f431_cant1_pedida) AS quantity_order,
                        SUM(MPV.f431_precio_unitario_base) AS unit_value_order,
                        SUM(MPV.f431_cant1_facturada) AS quantity_invoice,
                        SUM(MPV.f431_vlr_bruto) AS unit_value_invoice,
                        SUM(MPV.f431_vlr_bruto) OVER() AS total_unit_value_invoice,
                        SUM(MPV.f431_cant1_pedida*MPV.f431_precio_unitario_base) as subtotal_order,
                        SUM(MPV.f431_precio_unitario_base*MPV.f431_cant1_facturada) as subtotal_invoice,
                        SUM(MPV.f431_cant1_pedida*MPV.f431_precio_unitario_base) OVER() AS total_order,
                        SUM(MPV.f431_precio_unitario_base*MPV.f431_cant1_facturada) OVER() AS total_invoice,
                        SUM(CASE WHEN DPV.f430_id_clase_docto = 508 THEN CASE WHEN f431_cant1_facturada > f431_cant1_pedida THEN 0
                        ELSE f431_cant1_pedida - f431_cant1_facturada END
                                         ELSE
                                                 CASE
                                                   WHEN f431_cant1_remisionada > f431_cant1_pedida THEN 0
                                                   ELSE f431_cant1_pedida - f431_cant1_remisionada
                                                 END
                                 END) AS cant_pendiente,
                        SUM(ISNULL(NTA.Cantidad,0)) AS cantidad_devuelta,
                        SUM(MPV.f431_cant1_pedida-(CASE WHEN DPV.f430_id_clase_docto = 508 THEN CASE WHEN f431_cant1_facturada > f431_cant1_pedida THEN 0
                        ELSE f431_cant1_pedida - f431_cant1_facturada END
                            ELSE
                               CASE
                                 WHEN f431_cant1_remisionada > f431_cant1_pedida THEN 0
                                 ELSE f431_cant1_pedida - f431_cant1_remisionada
                               END
                            END)+ISNULL(NTA.Cantidad,0)) AS quantity_delivery
                    FROM
                        t460_cm_docto_remision_venta DRM 

                    left join t430_cm_pv_docto DPV
                    On DRM.f460_rowid_pv_docto = DPV.f430_rowid

                    LEFT JOIN t431_cm_pv_movto MPV
                    ON DPV.f430_rowid = MPV.f431_rowid_pv_docto

                    LEFT JOIN t121_mc_items_extensiones T121
                    ON T121.f121_rowid = MPV.f431_rowid_item_ext

                    LEFT JOIN  t120_mc_items T120
                    ON T120.f120_rowid = T121.f121_rowid_item

                    left join t461_cm_docto_factura_venta DFV
                    On DRM.f460_rowid_docto_factura = DFV.f461_rowid_docto

                    LEFT JOIN t350_co_docto_contable DOCFAC
                    ON DOCFAC.f350_rowid = DFV.f461_rowid_docto

                    LEFT JOIN t200_mm_terceros T200
                    ON f461_rowid_tercero_fact = T200.f200_rowid

                    left JOIN T201_MM_CLIENTES C201
                    ON T200.F200_ROWID = C201.F201_ROWID_TERCERO
                    AND DFV.f461_id_sucursal_fact = C201.F201_ID_SUCURSAL

                    LEFT JOIN (
                        Select 
                            PREL.f464_rowid_docto_relacion,
                            PREL.f464_id_cia, 
                            PREL.f464_rowid_docto_planilla, 
                            PREL.f464_ind_estado,
                            PREL.f464_notas,
                            PREL.f464_fecha_ts_cierre,
                            ROW_NUMBER() OVER(PARTITION BY PREL.f464_rowid_docto_relacion ORDER BY PREL.f464_rowid_docto_planilla ASC) AS Rnum
                        From  t464_cm_docto_planilla_rel PREL
                        where PREL.f464_fecha_ts_creacion BETWEEN '$dateIn' AND '$dateEnd'
                        ) PREL 
                    ON DOCFAC.f350_rowid = PREL.f464_rowid_docto_relacion
                    and DOCFAC.f350_id_cia = PREL.f464_id_cia
                    AND PREL.Rnum = 1

                    inner join t463_cm_docto_planilla PLN
                    On f464_rowid_docto_planilla = f463_rowid 

                    LEFT JOIN (
                        Select 
                            docNc.f350_id_tipo_docto,
                            docNc.f350_consec_docto,
                            msa.f353_id_tipo_docto_cruce,
                            msa.f353_consec_docto_cruce,
                            msa.f353_id_co_cruce,
                            MFV.f470_rowid_item_ext,
                            sum((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS Cantidad
                        from 
                            t470_cm_movto_invent MFV

                        inner join t350_co_docto_contable DOCNC
                        ON MFV.f470_rowid_docto_fact = DOCNC.f350_rowid

                        left join t352_co_docto_cruce t352  
                        ON MFV.f470_rowid_docto_fact = t352.f352_rowid_docto

                        inner join t353_co_saldo_abierto MSA
                        On t352.f352_rowid_sa = msa.f353_rowid
                        And t352.f352_id_cia = msa.f353_id_cia
                        and DOCNC.f350_id_co = msa.f353_id_co_cruce

                        where DOCNC.f350_fecha BETWEEN '$dateIn' AND '$dateEnd'

                        group by 
                            docNc.f350_id_tipo_docto,
                            docNc.f350_consec_docto,
                            msa.f353_id_tipo_docto_cruce,
                            msa.f353_consec_docto_cruce,
                            msa.f353_id_co_cruce,
                            MFV.f470_rowid_item_ext

                        ) NTA
                    ON Docfac.f350_id_tipo_docto = NTA.f353_id_tipo_docto_cruce
                    AND Docfac.f350_consec_docto = NTA.f353_consec_docto_cruce
                    AND DOCFAC.f350_id_co = NTA.f353_id_co_cruce
                    AND MPV.f431_rowid_item_ext = NTA.f470_rowid_item_ext

                    " . $where ."
                    
                    GROUP BY 
                    f430_fecha_ts_cumplido, 
                    DRM.f460_id_co_docto, 
                    DPV.f430_id_tipo_docto,	
                    DPV.f430_consec_docto, 
                    f431_fecha_cumplido,
                    Docfac.f350_id_tipo_docto,
                    Docfac.f350_consec_docto, 
                    Docfac.f350_fecha, 
                    PLN.f463_id_tipo_docto,
                    PLN.f463_consec_docto,
                    PLN.f463_fecha,
                    PREL.f464_ind_estado,
                    PREL.f464_notas,
                    PREL.f464_fecha_ts_cierre,
                    T200.F200_NIT,
                    T200.f200_razon_social,
                    DFV.f461_id_sucursal_fact,
                    C201.f201_descripcion_sucursal,
                    DFV.f461_id_co_fact,
                    T120.f120_id,
                    T120.f120_referencia,
                    T120.f120_descripcion,
                    f431_cant1_pedida,
                    f431_precio_unitario_base,
                    f431_cant1_facturada,
                    MPV.f431_vlr_bruto
                ) QRY

                    " . $groupBy . "
                    " . $orderBy . "
                    " . $having . "
                    ";
//            }else{
//                $query = "
//                SET NOCOUNT ON;
//                IF OBJECT_ID('tempdb..#TABLECLI".Yii::$app->user->identity->id."') IS NOT NULL
//                DROP TABLE #TABLECLI".Yii::$app->user->identity->id.";
//                SELECT   
//                    ROW_NUMBER() OVER(" . $orderBy . ") AS Rnum,
//                    CONVERT(BIGINT,0) AS total_order,
//                    CONVERT(BIGINT,0) AS total_invoice,
//                    " . $select . "
//                INTO #TABLECLI".Yii::$app->user->identity->id."
//                FROM(
//                    SELECT
//                        DRM.f460_id_co_docto AS f460_id_co_docto, 
//                        DPV.f430_id_tipo_docto AS f430_id_tipo_docto,	
//                        DPV.f430_consec_docto AS f430_consec_docto, 
//                        CONVERT(DATE,MPV.f431_fecha_cumplido,103)  AS f431_fecha_cumplido, 
//                        Docfac.f350_id_tipo_docto AS f350_id_tipo_docto,
//                        Docfac.f350_consec_docto AS f350_consec_docto, 
//                        CONVERT(DATE,Docfac.f350_fecha,103)  AS f350_fecha, 
//                        PLN.f463_id_tipo_docto AS f463_id_tipo_docto,
//                        PLN.f463_consec_docto AS f463_consec_docto,
//                        CONVERT(DATE,PLN.f463_fecha,103)  AS f463_fecha,
//                        PREL.f464_ind_estado AS f464_ind_estado,
//                        PREL.f464_notas AS f464_notas,
//                        CONVERT(DATE,PREL.f464_fecha_ts_cierre,103) as f464_fecha_ts_cierre,
//                        T200.F200_NIT AS f200_nit,
//                        T200.f200_razon_social AS f200_razon_social,
//                        DFV.f461_id_sucursal_fact AS f461_id_sucursal_fact,
//                        C201.f201_descripcion_sucursal AS f201_descripcion_sucursal,
//                        DFV.f461_id_co_fact AS f461_id_co_fact,
//                        T120.f120_id AS f120_id,
//                        T120.f120_referencia AS f120_referencia,
//                        T120.f120_descripcion AS f120_descripcion,
//                        MPV.f431_cant1_pedida AS f431_cant1_pedida,
//                        MPV.f431_precio_unitario_base AS f431_precio_unitario_base,
//                        MPV.f431_cant1_facturada AS f431_cant1_facturada,
//                        MPV.f431_vlr_bruto AS f431_vlr_bruto,
//                        MPV.f431_cant1_pedida*MPV.f431_precio_unitario_base as subtotal_pedido,
//                        MPV.f431_precio_unitario_base*MPV.f431_cant1_facturada as subtotal_facturado,
//                        (CASE WHEN DPV.f430_id_clase_docto = 508 THEN CASE WHEN f431_cant1_facturada > f431_cant1_pedida THEN 0
//                        ELSE f431_cant1_pedida - f431_cant1_facturada END
//                                         ELSE
//                                                 CASE
//                                                   WHEN f431_cant1_remisionada > f431_cant1_pedida THEN 0
//                                                   ELSE f431_cant1_pedida - f431_cant1_remisionada
//                                                 END
//                                 END) AS cant_pendiente,
//                         ISNULL(NTA.Cantidad,0) AS cantidad_devuelta,
//                        MPV.f431_cant1_pedida-(CASE WHEN DPV.f430_id_clase_docto = 508 THEN CASE WHEN f431_cant1_facturada > f431_cant1_pedida THEN 0
//                        ELSE f431_cant1_pedida - f431_cant1_facturada END
//                                         ELSE
//                                                 CASE
//                                                   WHEN f431_cant1_remisionada > f431_cant1_pedida THEN 0
//                                                   ELSE f431_cant1_pedida - f431_cant1_remisionada
//                                                 END
//                                 END)+ISNULL(NTA.Cantidad,0) AS cantidad_entregada 
//                    FROM
//                        t460_cm_docto_remision_venta DRM 
//
//                    left join t430_cm_pv_docto DPV
//                    On DRM.f460_rowid_pv_docto = DPV.f430_rowid
//
//                    LEFT JOIN t431_cm_pv_movto MPV
//                    ON DPV.f430_rowid = MPV.f431_rowid_pv_docto
//
//                    LEFT JOIN t121_mc_items_extensiones T121
//                    ON T121.f121_rowid = MPV.f431_rowid_item_ext
//
//                    LEFT JOIN  t120_mc_items T120
//                    ON T120.f120_rowid = T121.f121_rowid_item
//
//                    left join t461_cm_docto_factura_venta DFV
//                    On DRM.f460_rowid_docto_factura = DFV.f461_rowid_docto
//
//                    LEFT JOIN t350_co_docto_contable DOCFAC
//                    ON DOCFAC.f350_rowid = DFV.f461_rowid_docto
//
//                    LEFT JOIN t200_mm_terceros T200
//                    ON f461_rowid_tercero_fact = T200.f200_rowid
//
//                    left JOIN T201_MM_CLIENTES C201
//                    ON T200.F200_ROWID = C201.F201_ROWID_TERCERO
//                    AND DFV.f461_id_sucursal_fact = C201.F201_ID_SUCURSAL
//
//                    LEFT JOIN (
//                        Select 
//                            PREL.f464_rowid_docto_relacion,
//                            PREL.f464_id_cia, 
//                            PREL.f464_rowid_docto_planilla, 
//                            PREL.f464_ind_estado,
//                            PREL.f464_notas,
//                            PREL.f464_fecha_ts_cierre,
//                            ROW_NUMBER() OVER(PARTITION BY PREL.f464_rowid_docto_relacion ORDER BY PREL.f464_rowid_docto_planilla ASC) AS Rnum
//                        From  t464_cm_docto_planilla_rel PREL
//                        -- where PREL.f464_fecha_ts_creacion BETWEEN '$dateIn' AND '$dateEnd'
//                        ) PREL 
//                    ON DOCFAC.f350_rowid = PREL.f464_rowid_docto_relacion
//                    and DOCFAC.f350_id_cia = PREL.f464_id_cia
//                    AND PREL.Rnum = 1
//
//                    inner join t463_cm_docto_planilla PLN
//                    On f464_rowid_docto_planilla = f463_rowid 
//                    and f464_id_cia = f463_id_cia
//
//                    LEFT JOIN (
//                        Select 
//                            docNc.f350_id_tipo_docto,
//                            docNc.f350_consec_docto,
//                            msa.f353_id_tipo_docto_cruce,
//                            msa.f353_consec_docto_cruce,
//                            msa.f353_id_co_cruce,
//                            MFV.f470_rowid_item_ext,
//                            sum((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS Cantidad
//                        from 
//                            t470_cm_movto_invent MFV
//
//                        inner join t350_co_docto_contable DOCNC
//                        ON MFV.f470_rowid_docto_fact = DOCNC.f350_rowid
//
//                        left join t352_co_docto_cruce t352  
//                        ON MFV.f470_rowid_docto_fact = t352.f352_rowid_docto
//
//                        inner join t353_co_saldo_abierto MSA
//                        On t352.f352_rowid_sa = msa.f353_rowid
//                        And t352.f352_id_cia = msa.f353_id_cia
//                        and DOCNC.f350_id_co = msa.f353_id_co_cruce
//
//                        -- where DOCNC.f350_fecha BETWEEN '$dateIn' AND '$dateEnd'
//
//                        group by 
//                            docNc.f350_id_tipo_docto,
//                            docNc.f350_consec_docto,
//                            msa.f353_id_tipo_docto_cruce,
//                            msa.f353_consec_docto_cruce,
//                            msa.f353_id_co_cruce,
//                            MFV.f470_rowid_item_ext
//
//                        ) NTA
//                    ON Docfac.f350_id_tipo_docto = NTA.f353_id_tipo_docto_cruce
//                    AND Docfac.f350_consec_docto = NTA.f353_consec_docto_cruce
//                    AND DOCFAC.f350_id_co = NTA.f353_id_co_cruce
//                    AND MPV.f431_rowid_item_ext = NTA.f470_rowid_item_ext
//
//                        " . $where ."
//                ) QRY
//
//                    " . $groupBy . "
//                    " . $orderBy . "
//                    " . $having . "
//                
//                DECLARE @Rnum INT
//                  , @subtotal_order FLOAT
//                  , @subtotal_invoice FLOAT
//                  , @total_order FLOAT = 0
//                  , @total_invoice FLOAT = 0
//
//                DECLARE vendor2 CURSOR FOR   
//                SELECT Rnum, subtotal_order, subtotal_invoice  
//                FROM #TABLECLI".Yii::$app->user->identity->id."
//
//                OPEN vendor2
//
//                FETCH NEXT FROM vendor2 
//                INTO @Rnum,@subtotal_order ,@subtotal_invoice
//
//                WHILE @@FETCH_STATUS = 0  
//                BEGIN  
//                        SET @total_order = @total_order + @subtotal_order
//                        SET @total_invoice = @total_invoice + @subtotal_invoice
//                        FETCH NEXT FROM vendor2  
//                        INTO @Rnum,@subtotal_order, @subtotal_invoice
//                END
//
//                UPDATE #TABLECLI".Yii::$app->user->identity->id."
//                    SET total_order = @total_order, total_invoice = @total_invoice;   
//                CLOSE vendor2;  
//                DEALLOCATE vendor2; 
//                
//                SELECT * FROM #TABLECLI".Yii::$app->user->identity->id.";
//
//                    ";
//            }
            
            $arrayResultQuery = Yii::$app->dbsqlexpress->createCommand($query)->queryAll();     
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                        . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
        }
        return $arrayResultQuery;
    }
    
    /**
     * Retorna la informacion de SIESA para el reporte de cumplimiento por 
     * proveedores
     * Consulta dinamica
     * 
     * @param array  $select     Columnas seleccionadas
     * @param string $andWhere   Parametros para el filtro
     * @param array  $groupBy    Agrupacion de parametros
     * @param array  $orderBy    Orden de los parametros
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function reportFulfillmentProvider($select, $where, $groupBy, 
            $orderBy, $having, $clasification = false) {
        //Insertamos los tiempos de entrega por proveedro en tabla de timepos 
        if(!self::tableDeliveryProvider()){
            return [];
        }
        $arrayResultQuery = [];
        try {
//            if(!$clasification){
                $query = "
                SET NOCOUNT ON;
                -- SET LANGUAGE Spanish;
                SELECT                
                    " . $select . "
                FROM(
                    SELECT
                        YEAR(f420_fecha) as year_purchase,
                        YEAR(f350_fecha) as year_entry,
                        DATENAME(M, DATEADD(M, MONTH(f420_fecha), -1)) as month_purchase,
                        DATENAME(M, DATEADD(M, MONTH(f350_fecha), -1)) as month_entry,
                        T420.f420_id_tipo_docto AS document_type_purchase,
                        t350_t1.f350_id_tipo_docto AS document_type_entry,
                        T420.f420_consec_docto AS number_purchase,
                        T420.f420_fecha AS date_purchase,
                        t350_t1.f350_consec_docto AS number_entry,
                        t350_t1.f350_fecha AS date_entry,
                        T420.f420_ind_estado AS status_purchase,
                        PROVEEDOR.f200_id AS nit,
                        TimeDelivery.time_delivery,
                        LTRIM(RTRIM(PROVEEDOR.f200_razon_social)) AS business_name,
                        LTRIM(RTRIM(T420.f420_id_sucursal_prov)) AS branch_code,
                        f201_descripcion_sucursal AS branch_name,
                        LTRIM(RTRIM(T120.f120_referencia)) AS reference,
                        COUNT(f120_referencia) OVER() AS total_references,
                        SUM(CASE WHEN f421_cant_pedida <> f421_cant_entrada THEN 1 ELSE 0 END) AS total_ref_inc,
                        LTRIM(RTRIM(T120.f120_descripcion)) AS description,
                        SUM(T421.f421_cant_pedida) AS quantity_purchase,
                        SUM(t421.f421_precio_unitario) AS unit_value_purchase,
                        SUM(T421.f421_cant_entrada) AS quantity_entry,
                        SUM(t421.f421_precio_unitario) AS unit_value_entry,
                        SUM(f421_vlr_bruto) OVER() AS total_unit_value_purchase,
                        SUM(f421_cant_pedida * f421_precio_unitario) AS subtotal_purchase,
                        SUM(f421_precio_unitario * f421_cant_entrada) AS subtotal_entry,
                        SUM(f421_cant_pedida * f421_precio_unitario) OVER() AS total_purchase,
                        SUM(f421_precio_unitario * f421_cant_entrada) OVER() AS total_entry,
                        T420.f420_id_co as operation_center
                    FROM
                        (t157_mc_instalaciones T157 RIGHT OUTER JOIN
                        (t150_mc_bodegas T150 RIGHT OUTER JOIN
                         (t200_mm_terceros PROVEEDOR RIGHT OUTER JOIN
                          (t120_mc_items T120 RIGHT OUTER JOIN
                               (t121_mc_items_extensiones T121 RIGHT OUTER JOIN
                                (t420_cm_oc_docto T420 INNER JOIN t421_cm_oc_movto T421 
                                 ON T420.f420_id_cia = T421.f421_id_cia
                                 AND T420.f420_rowid = T421.f421_rowid_oc_docto)
                                ON T121.f121_rowid = T421.f421_rowid_item_ext)
                               ON T121.f121_rowid_item = T120.f120_rowid)
                          ON PROVEEDOR.f200_rowid = T420.f420_rowid_tercero_prov)
                         ON T150.f150_rowid = T421.f421_rowid_bodega)
                        ON T157.f157_id = T150.f150_id_instalacion
                        AND T157.f157_id_cia = T150.f150_id_cia)

                    left JOIN T201_MM_CLIENTES C201
                        ON PROVEEDOR.F200_ROWID = C201.F201_ROWID_TERCERO
                        AND T420.f420_id_sucursal_prov = C201.F201_ID_SUCURSAL  

                    LEFT JOIN TimeDelivery 
                        ON TimeDelivery.nit = f200_nit AND f420_id_co = TimeDelivery.co

                    Left Join t451_cm_docto_compras T451
                        ON t420.f420_rowid = t451.f451_rowid_oc_docto

                    Left Join t350_co_docto_contable t350_t1 
                        ON t451.f451_rowid_docto = t350_t1.f350_rowid 

                    INNER JOIN t054_mm_estados estado_co 
                        ON t420.f420_id_grupo_clase_docto = estado_co.f054_id_grupo_clase_docto
                        AND T420.f420_ind_estado = estado_co.f054_id

                    " . $where ."
                    GROUP BY
                        f420_fecha,
                        f350_fecha,
                        T420.f420_id_tipo_docto,
                        t350_t1.f350_id_tipo_docto,
                        T420.f420_consec_docto,
                        T420.f420_fecha,
                        t350_t1.f350_consec_docto,
                        t350_t1.f350_fecha,
                        T420.f420_ind_estado,
                        PROVEEDOR.f200_id,
                        PROVEEDOR.f200_razon_social,
                        T420.f420_id_sucursal_prov,
                        f201_descripcion_sucursal,
                        T120.f120_referencia,
                        T120.f120_descripcion,
                        T420.f420_id_co,
                        f421_cant_pedida,
                        f421_cant_entrada,
                        f421_precio_unitario,
                        f421_vlr_bruto,
                        TimeDelivery.time_delivery
                    ) qry
                    " . $groupBy . "
                    " . $orderBy . "
                    " . $having . "
                    ";
//            }else{
//                $query = "
//                SET NOCOUNT ON;
//                IF OBJECT_ID('tempdb..#TABLEPROV-".Yii::$app->user->identity->username."') IS NOT NULL
//                DROP TABLE #TABLEPROV-".Yii::$app->user->identity->username."
//                SELECT 
//                    ROW_NUMBER() OVER(" . $orderBy . ") AS Rnum,
//                    CONVERT(BIGINT,0) AS total_purchase,
//                    CONVERT(BIGINT,0) AS total_entry,
//                    " . $select . "
//                INTO #TABLEPROV-".Yii::$app->user->identity->username."         
//                FROM
//                    (t157_mc_instalaciones T157 RIGHT OUTER JOIN
//                    (t150_mc_bodegas T150 RIGHT OUTER JOIN
//                     (t200_mm_terceros PROVEEDOR RIGHT OUTER JOIN
//                      (t120_mc_items T120 RIGHT OUTER JOIN
//                           (t121_mc_items_extensiones T121 RIGHT OUTER JOIN
//                            (t420_cm_oc_docto T420 INNER JOIN t421_cm_oc_movto T421 
//                             ON T420.f420_id_cia = T421.f421_id_cia
//                             AND T420.f420_rowid = T421.f421_rowid_oc_docto)
//                            ON T121.f121_rowid = T421.f421_rowid_item_ext)
//                           ON T121.f121_rowid_item = T120.f120_rowid)
//                      ON PROVEEDOR.f200_rowid = T420.f420_rowid_tercero_prov)
//                     ON T150.f150_rowid = T421.f421_rowid_bodega)
//                    ON T157.f157_id = T150.f150_id_instalacion
//                    AND T157.f157_id_cia = T150.f150_id_cia)
//
//                left JOIN T201_MM_CLIENTES C201
//                ON PROVEEDOR.F200_ROWID = C201.F201_ROWID_TERCERO
//                AND T420.f420_id_sucursal_prov = C201.F201_ID_SUCURSAL   
//                
//                LEFT JOIN TimeDelivery ON TimeDelivery.nit = f200_nit
//
//                Left Join t451_cm_docto_compras T451
//                ON t420.f420_rowid = t451.f451_rowid_oc_docto
//
//                Left Join t350_co_docto_contable t350_t1 
//                ON t451.f451_rowid_docto = t350_t1.f350_rowid 
//
//                INNER JOIN t054_mm_estados estado_co 
//                ON t420.f420_id_grupo_clase_docto = estado_co.f054_id_grupo_clase_docto
//                AND T420.f420_ind_estado = estado_co.f054_id
//
//                    " . $where ."
//                    " . $groupBy . "
//                    " . $orderBy . "
//                    " . $having . "
//                
//                DECLARE @Rnum INT
//                  , @subtotal_purchase FLOAT
//                  , @subtotal_entry FLOAT
//                  , @total_entry FLOAT = 0
//                  , @total_purchase FLOAT = 0
//
//                DECLARE vendor1 CURSOR FOR   
//                SELECT Rnum, subtotal_purchase, subtotal_entry   
//                FROM #TABLEPROV-".Yii::$app->user->identity->username."  
//
//                OPEN vendor1  
//
//                FETCH NEXT FROM vendor1   
//                INTO @Rnum,@subtotal_purchase ,@subtotal_entry 
//
//                WHILE @@FETCH_STATUS = 0  
//                BEGIN  
//                        SET @total_purchase = @total_purchase + @subtotal_purchase
//                        SET @total_entry = @total_entry + @subtotal_entry
//                        FETCH NEXT FROM vendor1   
//                        INTO @Rnum,@subtotal_purchase, @subtotal_entry
//                END
//
//                UPDATE #TABLEPROV-".Yii::$app->user->identity->username."
//                    SET total_purchase = @total_purchase, total_entry = @total_entry;  ;   
//                CLOSE vendor1;  
//                DEALLOCATE vendor1; 
//                
//                SELECT * FROM #TABLEPROV-".Yii::$app->user->identity->username.";
//                    "; 
//            }	
            $arrayResultQuery = Yii::$app->dbsqlexpress->createCommand($query)->queryAll();              
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                        . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
        }
        return $arrayResultQuery;
    }
    
    /**
     * Retorna la informacion de SIESA para el reporte de cumplimiento por 
     * abastecimiento
     * Consulta dinamica
     * 
     * @param array  $select     Columnas seleccionadas
     * @param string $andWhere   Parametros para el filtro
     * @param array  $groupBy    Agrupacion de parametros
     * @param array  $orderBy    Orden de los parametros
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function reportFulfillmentProvision($select, $where, $groupBy, 
            $orderBy, $having, $dateIn, $dateEnd, $type = false) {
        //meter cantidas remisionada para validar 
        
        if($type){
           $tmpQuery = "
            SELECT 
                3 as idtype,
                '".Fulfillmentprovision::PENDINGS."' as type,
                f431_fecha_cumplido as date,
                f430_id_co as operation_center,
                SUM(f431_cant1_pedida) AS total_unit,
                -- count(T120.f120_referencia) as referencia,
                SUM(CASE WHEN f431_cant1_facturada > 0 THEN f431_cant1_pedida - f431_cant1_facturada ELSE f431_cant1_pedida - f431_cant1_remisionada END) AS value_fulfillment_unit,
                (SUM((CASE WHEN f431_cant1_facturada > 0 THEN f431_cant1_pedida - f431_cant1_facturada ELSE f431_cant1_pedida - f431_cant1_remisionada END)*(f431_vlr_bruto/f431_cant1_pedida))) AS value_fulfillment_money,
                SUM(f431_vlr_bruto) AS total_money,
                0 AS value_fulfillment_order,
                0 as total_order,
                0 AS value_fulfillment_references,
                0 AS total_references
            FROM
            T430_CM_PV_DOCTO PV 
            
            LEFT JOIN T431_CM_PV_MOVTO MPV
            ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO
            
            LEFT JOIN t121_mc_items_extensiones T121
            ON T121.f121_rowid = MPV.f431_rowid_item_ext

            LEFT JOIN t120_mc_items T120
            ON T120.f120_rowid = T121.f121_rowid_item
            
            Where
                f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                AND PV.f430_ind_estado = 4
            GROUP BY 
             f430_consec_docto, f431_fecha_cumplido, f430_id_co
             
             UNION
             
             -- QUERY VENTAS
            SELECT
                2 as idtype,
                '".Fulfillmentprovision::BILLS."' as type,
                f431_fecha_cumplido as date,
                f430_id_co as operation_center,
                SUM(f431_cant1_pedida) AS total_unit,
                SUM(CASE WHEN f431_cant1_facturada > 0 THEN f431_cant1_facturada ELSE f431_cant1_remisionada END) AS value_fulfillment_unit,
                SUM((CASE WHEN f431_cant1_facturada > 0 THEN f431_cant1_facturada ELSE f431_cant1_remisionada END) *(f431_vlr_bruto/f431_cant1_pedida)) AS value_fulfillment_money,
                SUM(f431_vlr_bruto) AS total_money,
                0 AS value_fulfillment_order,
                0 as total_order,
                0 AS value_fulfillment_references,
                0 AS total_references
            FROM
            T430_CM_PV_DOCTO PV 
            left JOIN T431_CM_PV_MOVTO MPV
            ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

            Where
                f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                AND PV.f430_ind_estado in (3,4)
            GROUP BY 
             f431_fecha_cumplido, f430_id_co
             
             UNION -- --------------------------------------------------------------------------------------

            -- QUERY PEDIDOS
            SELECT
                1 as idtype,
                '".Fulfillmentprovision::ORDERS."' as type,
                f431_fecha_cumplido as date,
                f430_id_co as operation_center,
                SUM(f431_cant1_pedida) AS total_unit,
                SUM(f431_cant1_pedida) AS value_fulfillment_unit,
                SUM(f431_vlr_bruto) AS value_fulfillment_money,
                SUM(f431_vlr_bruto) AS total_money,
                0 AS value_fulfillment_order,
                0 as total_order,
                0 AS value_fulfillment_references,
                0 AS total_references
            FROM
            T430_CM_PV_DOCTO PV 
            left JOIN T431_CM_PV_MOVTO MPV
            	ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO
            Where
                f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                AND PV.f430_ind_estado in (3,4)
            GROUP BY 
             	f431_fecha_cumplido,f430_id_co
             	
            UNION
             	
            SELECT 
                4 as idtype,
                '".Fulfillmentprovision::ORDERS_PENDINGS."' as type,
                f431_fecha_cumplido as date,
                f430_id_co as operation_center,
                0 AS total_unit,
                0 AS value_fulfillment_unit,
                0 AS value_fulfillment_money,
                0 AS total_money,
                SUM(CASE WHEN pedido != facturado OR pedido != remisionado THEN 1 ELSE 0 END) AS value_fulfillment_order,
                COUNT(f430_consec_docto) AS total_order,
                SUM(referencias_incompletas) AS value_fulfillment_references,
                SUM(referencias) AS total_references
                FROM (
                    SELECT
                        f430_consec_docto,
                        f431_fecha_cumplido,
                        f430_id_co,
                        count(f430_consec_docto) as total_pedidos,
                        count(T120.f120_referencia) as referencias,
                        sum(CASE WHEN f431_cant1_pedida != f431_cant1_facturada OR f431_cant1_pedida != f431_cant1_remisionada THEN 1 ELSE 0 END) as referencias_incompletas,
                        sum(f431_cant1_pedida) as pedido,
                        sum(f431_cant1_facturada) as facturado,
                        sum(f431_cant1_remisionada) as remisionado
                    FROM
                    T430_CM_PV_DOCTO PV 
                    
                    left JOIN T431_CM_PV_MOVTO MPV
                    ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

                    LEFT JOIN t121_mc_items_extensiones T121
                    ON T121.f121_rowid = MPV.f431_rowid_item_ext

                    LEFT JOIN t120_mc_items T120
                    ON T120.f120_rowid = T121.f121_rowid_item

                    Where
                        f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                        AND PV.f430_ind_estado in (3,4)
                    group by 
                        f430_consec_docto,f431_fecha_cumplido,f430_id_co
            	) AS pnd
            	group by
                    f431_fecha_cumplido,f430_id_co
            		
            	UNION
            	
            	SELECT 
                    5 as idtype,
                    '".Fulfillmentprovision::ORDERS_FULL."' as type,
                    f431_fecha_cumplido as date,
                    f430_id_co as operation_center,
                    0 AS total_unit,
                    0 AS value_fulfillment_unit,
                    0 AS value_fulfillment_money,
                    0 AS total_money,
                    SUM(CASE WHEN pedido = facturado AND pedido = remisionado THEN 1 ELSE 0 END) AS value_fulfillment_order,
                    COUNT(f430_consec_docto) AS total_order,
                    SUM(referencias_incompletas) AS value_fulfillment_references,
                    SUM(referencias) AS total_references
                    FROM (
                        SELECT
                            f430_consec_docto,
                            f431_fecha_cumplido,
                            f430_id_co,
                            count(f430_consec_docto) as total_pedidos,
                            count(T120.f120_referencia) as referencias,
                            sum(CASE WHEN (f431_cant1_pedida = f431_cant1_facturada AND f431_cant1_remisionada = f431_cant1_pedida) THEN 1 ELSE 0 END) as referencias_incompletas,
                            sum(f431_cant1_pedida) as pedido,
                            sum(f431_cant1_facturada) as facturado,
                            SUM(f431_cant1_remisionada) AS remisionado
                        FROM
                        T430_CM_PV_DOCTO PV 
                        left JOIN T431_CM_PV_MOVTO MPV
                        ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

                        LEFT JOIN t121_mc_items_extensiones T121
                        ON T121.f121_rowid = MPV.f431_rowid_item_ext

                        LEFT JOIN t120_mc_items T120
                        ON T120.f120_rowid = T121.f121_rowid_item

                        Where
                            f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                            AND PV.f430_ind_estado in (3,4)
                        group by 
                            f430_consec_docto,f431_fecha_cumplido,f430_id_co
            	) AS pnd
            	group by
                    f431_fecha_cumplido,f430_id_co
            		
            UNION
            
            SELECT 
                6 as idtype,
                '".Fulfillmentprovision::ORDERS_TOTAL."' as type,
                f431_fecha_cumplido as date,
                f430_id_co as operation_center,
                0 AS total_unit,
                0 AS value_fulfillment_unit,
                0 AS value_fulfillment_money,
                0 AS total_money,
                COUNT(f430_consec_docto) AS value_fulfillment_order,
                COUNT(f430_consec_docto) AS total_order,
                SUM(referencias) AS value_fulfillment_references,
                SUM(referencias) AS total_references
                FROM (
                    SELECT
                        f430_consec_docto,
                        f431_fecha_cumplido,
                        f430_id_co,
                        count(T120.f120_referencia) as referencias,
                        sum(f431_cant1_pedida) as pedido
                    FROM
                    T430_CM_PV_DOCTO PV 
                    
                    left JOIN T431_CM_PV_MOVTO MPV
                    ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

                    LEFT JOIN t121_mc_items_extensiones T121
                    ON T121.f121_rowid = MPV.f431_rowid_item_ext

                    LEFT JOIN t120_mc_items T120
                    ON T120.f120_rowid = T121.f121_rowid_item

                    Where
                        f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                        AND PV.f430_ind_estado in (3,4)
                    group by 
                        f430_consec_docto,f431_fecha_cumplido,f430_id_co
            	) AS pnd
            	group by
                    f431_fecha_cumplido, f430_id_co
            ";
        }else{
            $tmpQuery = "
                -- QUERY VENTAS
               SELECT
                   2 as idtype,
                   '".Fulfillmentprovision::BILLS."' as type,
                   f431_fecha_cumplido as date,
                   f430_id_co as operation_center,
                   SUM(f431_cant1_pedida) AS total_unit,
                   SUM(CASE WHEN f431_cant1_facturada > 0 THEN f431_cant1_facturada ELSE f431_cant1_remisionada END) AS value_fulfillment_unit,
                   SUM((CASE WHEN f431_cant1_facturada > 0 THEN f431_cant1_facturada ELSE f431_cant1_remisionada END) *(f431_vlr_bruto/f431_cant1_pedida)) AS value_fulfillment_money,
                   SUM(f431_vlr_bruto) AS total_money,
                   0 AS value_fulfillment_order,
                   0 as total_order,
                   0 AS value_fulfillment_references,
                   0 AS total_references
               FROM
               T430_CM_PV_DOCTO PV 
               left JOIN T431_CM_PV_MOVTO MPV
               ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

               Where
                   f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                   AND PV.f430_ind_estado in (3,4)
               GROUP BY 
                f431_fecha_cumplido, f430_id_co  

                UNION
            	
            	SELECT 
                    5 as idtype,
                    '".Fulfillmentprovision::ORDERS_FULL."' as type,
                    f431_fecha_cumplido as date,
                    f430_id_co as operation_center,
                    0 AS total_unit,
                    0 AS value_fulfillment_unit,
                    0 AS value_fulfillment_money,
                    0 AS total_money,
                    SUM(CASE WHEN pedido = facturado AND pedido = remisionado THEN 1 ELSE 0 END) AS value_fulfillment_order,
                    COUNT(f430_consec_docto) AS total_order,
                    SUM(referencias_incompletas) AS value_fulfillment_references,
                    SUM(referencias) AS total_references
                    FROM (
                        SELECT
                            f430_consec_docto,
                            f431_fecha_cumplido,
                            f430_id_co,
                            count(f430_consec_docto) as total_pedidos,
                            count(T120.f120_referencia) as referencias,
                            sum(CASE WHEN (f431_cant1_pedida = f431_cant1_facturada AND f431_cant1_remisionada = f431_cant1_pedida) THEN 1 ELSE 0 END) as referencias_incompletas,
                            sum(f431_cant1_pedida) as pedido,
                            sum(f431_cant1_facturada) as facturado,
                            SUM(f431_cant1_remisionada) AS remisionado
                        FROM
                        T430_CM_PV_DOCTO PV 
                        left JOIN T431_CM_PV_MOVTO MPV
                        ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

                        LEFT JOIN t121_mc_items_extensiones T121
                        ON T121.f121_rowid = MPV.f431_rowid_item_ext

                        LEFT JOIN t120_mc_items T120
                        ON T120.f120_rowid = T121.f121_rowid_item

                        Where
                            f431_fecha_cumplido BETWEEN '$dateIn' AND '$dateEnd'
                            AND PV.f430_ind_estado in (3,4)
                        group by 
                            f430_consec_docto,f431_fecha_cumplido,f430_id_co
            	) AS pnd
            	group by
                    f431_fecha_cumplido,f430_id_co
            	
            ";
        }
        
        $arrayResultQuery = [];
        //$dateEnd = '29-10-2019'; // dato de pruebas ----------------------------------------------
        try {
            $query = "
            SET NOCOUNT ON;			

            SELECT
                " . $select . "
            FROM (
                " . $tmpQuery . "
             ) qry
            " . $where . "
            " . $groupBy . "
            " . $orderBy . "
            " . $having . "
                ";
            $arrayResultQuery = Yii::$app->dbsqlexpress->createCommand($query)->queryAll();              
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                        . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
        }
        return $arrayResultQuery;
    }
    
    /**
     * Retorna la informacion de SIESA para el reporte de cumplimiento por 
     * clientes
     * Consulta dinamica
     * 
     * @param array  $select     Columnas seleccionadas
     * @param string $andWhere   Parametros para el filtro
     * @param array  $groupBy    Agrupacion de parametros
     * @param array  $orderBy    Orden de los parametros
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function getPendings($where) {
        $arrayResultQuery = [];
        try {
            $query = "
                SELECT
                    LTRIM(RTRIM(T120.f120_referencia)) AS reference,
                    LTRIM(RTRIM(T120.f120_descripcion)) AS description,
                    sum(f431_cant1_pedida * MPV.$payroll) - sum(f431_cant1_facturada * MPV.f431_precio_unitario_base) AS total_cost,
                    sum(f431_cant1_pedida) as quantity_order,
                    sum(f431_cant1_facturada) as quantity_invoiced,
                    sum(f431_cant1_pedida) - sum(f431_cant1_facturada) as pending
                 FROM
                 T430_CM_PV_DOCTO PV 
                                    left JOIN T431_CM_PV_MOVTO MPV
                 ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

                 LEFT JOIN t121_mc_items_extensiones T121
                 ON T121.f121_rowid = MPV.f431_rowid_item_ext

                 LEFT JOIN t120_mc_items T120
                 ON T120.f120_rowid = T121.f121_rowid_item

                 Where
                    PV.f430_ind_estado = 4
                    " . $where . "
                 group by 
                    T120.f120_referencia, T120.f120_descripcion
                 having 
                    (sum(f431_cant1_pedida) - sum(f431_cant1_facturada)) > 0
                ";
            $arrayResultQuery = Yii::$app->dbsql->createCommand($query)->queryAll();              
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                        . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
        }
        return $arrayResultQuery;
    }
    
    /**
     * Crea la tabla con lso tiempos de entrega por cada proveedor
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function tableDeliveryProvider(){
        $query = "IF OBJECT_ID('TimeDelivery') IS NOT NULL
                DROP TABLE TimeDelivery;
                
                CREATE TABLE TimeDelivery (
                    id INT IDENTITY PRIMARY KEY,
                    nit VARCHAR(50),
                    co VARCHAR(10),
                    time_delivery INT,
                );
                
                CREATE INDEX idx_TimeDelivery
                ON TimeDelivery(nit);
                "; 
        $timeDelivery = \app\models\Timesdelivery::find()->asArray()->all();
        $tmpsql = '';
        if(count($timeDelivery)>0){
            foreach ($timeDelivery as $data) {
                $query .= "INSERT INTO TimeDelivery (nit, co, time_delivery)
                VALUES ('".$data['nit']."', '".$data['oc_code']."', '".$data['time_delivery']."'); ";
            }
        }
        try {
            Yii::$app->dbsqlexpress->createCommand($query)->execute();
            return true;
        } catch (\Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                        . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
            return false;
        }
    }
}

?>
