<?php

/**
 * WsSiesa.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * WsSiesa.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class WsSiesa
{

    /**
     * Constructor de la clase
     * 
     * @return void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S.     
     * @access public     
     */
    public function __construct()
    {
        
    }

    /**
     * Funcion desctructora 
     * 
     * @return void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S. 
     * @access public     
     */
    public function __destruct()
    {
        
    }

    /**
     * Funccion para enviar el 
     * pedido al ARP de Siesa utilizando 
     * el consumo de servicio web
     * 
     * @param Order $model Modelo del pedido
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function sendOrderSiesa($model)
    {
        try {
            if(!empty($model) && is_object($model)) {
                $factoryOrder = new FactoryOrder();
                $xml = $factoryOrder->createOrder($model->ord_id, $model, $assignPrice);				
                if($xml) {
                    $webServices = new WebServices;
                    $method = 'ImportarXML';
                    $url = Yii::app()->params['paramsWs']['urlWs'];
                    $params = array('pvstrDatos' => $xml, 'printTipoError' => 0);
                    if($webServices->executeMethodWs($method, $url, $params)) {
                        $response = $webServices->response;
                        if(isset($response->printTipoError)
                            && $response->printTipoError === 0) {
							//--------------------------------------------------
                            Yii::log(__FILE__ . ':' . __LINE__ . ':'
                                . __FUNCTION__ . ':'
                                . ' { ' . $xml . '}', CLogger::LEVEL_ERROR,
                                'b2b.ws');
                            //--------------------------------------------------
                            return true;
                        } else {
                            //--------------------------------------------------
                            Yii::log(__FILE__ . ':' . __LINE__ . ':'
                                . __FUNCTION__ . ':'
                                . ' { ' . $xml . '}', CLogger::LEVEL_ERROR,
                                'b2b.ws');
                            //--------------------------------------------------
                            $error = $response->ImportarXMLResult->any;
                            //--------------------------------------------------
                            Yii::log(__FILE__ . ':' . __LINE__ . ':'
                                . __FUNCTION__ . ':'
                                . ' { ' . $error . '}', CLogger::LEVEL_ERROR,
                                'b2b.ws');
                            //--------------------------------------------------
                        }
                    }
                }
            }
            return false;
        } catch(\Exception $exc) {
            //----------------------------------------------------
            Yii::log(__FILE__ . ':' . __LINE__ . ':' . __FUNCTION__ . ':'
                . ' { ' . $exc->getMessage() . '}', CLogger::LEVEL_ERROR,
                'b2b.ws');
            //---------------------------------------------------
            return false;
        }
    }

}

?>
