<?php

namespace app\components\purchases;

use Yii;
use yii\base\Component;
use yii\base\InvalidConfig\Exception;
use yii\helpers\ArrayHelper;
use app\models\Items;
use yii\db\Expression;

/**
 * ClientSiesa.php
 *
 * PHP Version 5.3.0
 * 
 * @category category
 * @package package
 * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2019 INGENEO S.A.S.
 * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version SVN: $Id$
 * @link http://www.ingeneo.com.co
 *  
 */

/**
 * ClientSiesa.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category category
 * @package package
 * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2019 INGENEO S.A.S.
 * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version Release: $Id$
 * @link http://www.ingeneo.com.co
 * 
 */
class ClientSiesa extends Component {

    protected static $_instance;

    /**
     * Constructor de la clase
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2019 INGENEO S.A.S.
     * @return    void
     * @access    public
     * 
     */
    public function __construct() {
        
    }

    /**
     * Funcion desctructora 
     *    
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.    
     * @version   Release: $Id$    
     * @access    public     
     * @return    void
     * 
     */
    public function __destruct() {
        
    }

    public static function getInstance() {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }

    /**
     * Metodo para retornar el listado de proveedores
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getProviders($strProvider = null) {
        $arrayProviders = [];
        try {
            if(is_null($strProvider)){
                $sql = "SELECT 
                    f200_nit as nit, 
                    f200_nit+' - '+f200_razon_social as business_name
                FROM t200_mm_terceros
                WHERE f200_nit IS NOT NULL AND f200_ind_estado = 1 
                    AND f200_ind_proveedor = 1 
                    AND f200_ind_empleado = 0
                ORDER BY f200_razon_social ASC";
            }else{
                $sql = "SELECT 
                    f200_nit as nit, 
                    f200_nit+' - '+f200_razon_social as business_name
                FROM t200_mm_terceros
                WHERE f200_nit IS NOT NULL AND f200_ind_estado = 1 
                    AND f200_ind_proveedor = 1 AND (f200_nit  LIKE '%" . $strProvider . "%'
                    OR f200_razon_social LIKE '%" . $strProvider . "%')
                    AND f200_ind_empleado = 0
                ORDER BY f200_razon_social ASC";
            }
            
            $arrayProviders = Yii::$app->dbsql->createCommand($sql)->queryAll();
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                        . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
        }
        return $arrayProviders;
    }

    /**
     * Retorna el listado de sucursales del proveedor
     * 
     * @param int $nit Nit del proveedor
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getBranches($nit) {
        $arrayBranches = [];
        try {
            if (!empty($nit) && is_numeric($nit)) {
                $sql = "SELECT 
                    f202_id_sucursal as branch_code, 
                    f202_id_sucursal+' - '+f202_descripcion_sucursal as branch_name                              
                FROM t202_mm_proveedores
                JOIN t200_mm_terceros AS suc ON f200_rowid = f202_rowid_tercero
                WHERE f200_nit ='" . $nit . "' "
                        . "ORDER BY f202_descripcion_sucursal ASC";
                $arrayBranches = Yii::$app->dbsql->createCommand($sql)->queryAll();
            }
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');
        }
        return $arrayBranches;
    }

    /**
     * Retorna la informacion de la sucursal y el contacto asociado
     * 
     * @param int    $nit        Nit del proveedor
     * @param string $branchId Id de la sucursal
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getInfoBranch($nit, $branchId) {
        $result = null;
        try {
            if (!empty($nit) && is_numeric($nit) && !empty($nit)) {
                $sql = "SELECT 
                    f200_nit AS nit,
                    f200_razon_social AS razon_social, 
                    f202_id_sucursal AS id_sucursal, 
                    f202_descripcion_sucursal as nombre_sucursal,
                    f202_id_cond_pago as conPago,
                    f015_contacto AS contacto,
                    f015_telefono as telefono_contacto,
                    f015_email as email_contacto
                FROM t202_mm_proveedores
                JOIN t200_mm_terceros AS suc ON f200_rowid = f202_rowid_tercero
                LEFT JOIN t015_mm_contactos ON f015_rowid = f202_rowid_contacto
                WHERE f200_nit ='" . $nit . "' AND f202_id_sucursal = '"
                        . $branchId . "'";
                $result = Yii::$app->dbsql->createCommand($sql)->queryOne();
            }
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');           
        }
        return $result;
    }

    /**
     * Metodo para retornar el listado de bodegas
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getCellars() {
        $cellars = [];
        try {
            $sql = "SELECT LTRIM(RTRIM(f150_id)) as cellar_code, 
                LTRIM(RTRIM(f150_id))+' - '+f150_descripcion as cellar_name
            FROM t150_mc_bodegas
            WHERE f150_ind_estado = 1             
            ORDER BY f150_id, f150_descripcion ASC";
            $cellars = Yii::$app->dbsql->createCommand($sql)->queryAll();
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');             
        }
        return $cellars;
    }

    /**
     * Metodo retorna la informacion de la bodega
     * 
     * @param string $cellarId Id de la bodega
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getInfoCellar($cellarId) {
        $infoCellar = [];
        try {
            if (!empty($cellarId))
                $sql = "SELECT f150_id, f150_descripcion, f150_id_co
            FROM t150_mc_bodegas
            WHERE f150_ind_estado = 1             
            AND f150_id = '" . $cellarId . "'";
            $infoCellar = Yii::$app->dbsql->createCommand($sql)->queryOne();
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');              
        }
        return $infoCellar;
    }
    
    /**
     * Metodo para retornar el listado de centros de operacion
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getListOC() {
        $cellars = [];
        try {
            $sql = "SELECT LTRIM(RTRIM(f285_id)) as oc_code, 
                LTRIM(RTRIM(f285_id))+' - '+f285_descripcion as oc_name
            FROM t285_co_centro_op
            WHERE f285_ind_estado = 1             
            ORDER BY f285_id, f285_descripcion ASC";
            $cellars = Yii::$app->dbsql->createCommand($sql)->queryAll();
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');             
        }
        return $cellars;
    }

    /**
     * Metodo para consultar el listado de referencias
     * 
     * @param int $providerId  Id del proveedor
     * @param int $cellarId     Id bodega
     * @param int $dateDiff    Numero de dias atras
     * @param int $diasAdelante Numero de dias adelante
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getListReferencias($providerId, $branchId, $cellarId, $dateDiff, $diasAdelante) {
        $referencias = Items::find()->where([
            'provider_id'=>$providerId,
            'branch_id'=>$branchId,
            'cellar_id'=>str_replace("&amp;","&",$cellarId),
        ])->orderBy('descripcion ASC')->all();
        
        $objectResult = array();
        $listSugeridos = $this->_getVentasAtras($providerId, $branchId, $cellarId, $dateDiff);        
        if (count($referencias) > 0) {
            foreach ($referencias as $referencia) {
                $referencia->reference = trim($referencia->ref_referencia);
                $referencia->ref_cobertura = 0;
                $cantVentas = (isset($listSugeridos[$referencia->ref_referencia])) ? $listSugeridos[$referencia->ref_referencia] : 0;
                if ($cantVentas > 0) {                    
                    $referencia->ref_cobertura = $referencia->ref_cant_inventario / ($cantVentas/$dateDiff);
                    $referencia->ref_cant_sugerida = round((($diasAdelante * $cantVentas) / $dateDiff), 0);
                } elseif ($referencia->quantity_sold > 0) {
                    $referencia->ref_cant_sugerida = round((($diasAdelante * $referencia->ref_cant_vendida) / $dateDiff), 0);
                } else {
                    $referencia->ref_cant_sugerida = 0;
                }
                $objectResult[] = $referencia;
            }
        }
        return $objectResult;
    }
    
    /**
     * Metodo para consultar el listado de referencias por rango de fechas
     * 
     * @param string $providerId
     * @param string $branchId
     * @param string $cellarId
     * @param string $startDate
     * @param string $endDate
     * @param integer $dateDiff
     * @param integer $projectionDay
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getItems($providerId, $branchId, $cellarId, 
            $startDate, $endDate, $dateDiff, $projectionDay) {
        
        $objectResult = [];
        $itemNames = [];
        $listSuggested = $this->_getSales($providerId, $branchId, 
                $cellarId, $dateDiff, $startDate, $endDate);

        $listOrdes = $this->_getOrders($providerId, $branchId, 
                $cellarId, $dateDiff, $startDate, $endDate);
        
        $arrayNet = ArrayHelper::map($listSuggested, 'item','valor_neto');
        $sumNeto = array_sum($arrayNet);
        
        $orderByNet = array_keys($arrayNet);
        if(count($orderByNet)>0){
            $tempOrder = new Expression("IF(FIELD(reference,". implode(",", $orderByNet)
                .")=0,1,0) ASC,FIELD(reference,". implode(",", $orderByNet).")");
        }else{
            $tempOrder = 'description';
        }
        
        $items = Items::find()->where([
            'provider_id'=>$providerId,
            'branch_id'=>$branchId,
            'cellar_id'=>str_replace("&amp;","&",$cellarId),
        ])->orderBy($tempOrder)->all();

        // \Yii::error(__FILE__ . ':' . __LINE__ . '{'. print_r($items, true) . '}', 'clientsiesa');

        if (count($items) > 0) { 
            
            $accumulated = 0;
            foreach ($items as $item) {

                $configCellarId = \Yii::$app->params['configCellarId'];
                $cellarId = str_replace("&amp;","&",$cellarId);
                if(isset($configCellarId[$cellarId])){
                    $oldCellarId = $configCellarId[$cellarId];
                    $itemOldCellar = Items::find()->where([
                        'provider_id'=>$providerId,
                        'branch_id'=>$branchId,
                        'cellar_id'=> $oldCellarId,
                        'reference' => $item->reference
                    ])->one();
                    if(isset($itemOldCellar)){
                        $item->quantity_transit += $itemOldCellar->quantity_transit;
                    }
                }

                $tempProjectionDay = 0;
                $item->reference = trim($item->reference);
                $item->name_reference = trim($item->description);
                $quantSold = (isset($listSuggested[$item->reference]['cantidad'])) 
                        ? $listSuggested[$item->reference]['cantidad'] : 0;
                $item->quantity_sold = $quantSold;
                $item->consumption = (isset($listSuggested[$item->reference]['consumo']))
                        ? $listSuggested[$item->reference]['consumo'] : 0;
                $item->net = (isset($listSuggested[$item->reference]['valor_neto'])) 
                        ? $listSuggested[$item->reference]['valor_neto'] : 0;
                $item->per_partipipation = (isset($listSuggested[$item->reference]['valor_neto'])) 
                        ? $listSuggested[$item->reference]['valor_neto']/$sumNeto : 0;
                $accumulated = $accumulated + $item->per_partipipation;
                $quantityOrder = (isset($listOrdes[$item->reference]['cantidad'])) 
                        ? $listOrdes[$item->reference]['cantidad'] : 0;
                $item->accumulated = $accumulated * 100;
                $item->abc = ($item->accumulated <= 80 )?'A':(($item->accumulated <= 95)?'B':'C');
                $lostSale = $quantityOrder - $quantSold;
                $item->lost_sale = ($lostSale < 0)? 0 : $lostSale;
                $item->coverage = 0;
                # --------------------------------------------------------------
                switch ($item->abc) {
                    case Items::CAT_A:
                        $tempProjectionDay = $projectionDay;
                        break;
                    case Items::CAT_B:
                        $tempProjectionDay = $projectionDay + 2;
                        break;
                    case Items::CAT_C:
                        $tempProjectionDay = $projectionDay + 5;                        
                        break;
                    default:
                        $tempProjectionDay = $projectionDay;
                        break;
                }
                #---------------------------------------------------------------                                              
                if ($quantSold > 0) {
                    $item->coverage = round($item->quantity_inventory / ($quantSold/$dateDiff));
                    //$result = ((($quantSold * $projectionDay) - $item->quantity_inventory) - ($item->quantity_committed + $item->quantity_transit));
                    $result = ((($quantSold/$dateDiff)*$tempProjectionDay) - $item->quantity_inventory + $item->quantity_committed - $item->quantity_transit);
                    if ($result > 0) {
                        $item->quantity_subjected = round($result, 0);
                        //$item->quantity_subjected = $result;
                    } else {
                        $item->quantity_subjected = 0;
                    }
                } else {
                    $item->quantity_subjected = 0;
                    if($item->quantity_inventory > 0){
                        $item->coverage = round($item->quantity_inventory / $dateDiff);
                    }
                }
                
                if(trim($item->measured_unit) != Items::UNID){                
                    $undMed = preg_replace('/[^0-9]+/', '', $item->measured_unit);
                    if($undMed > 0){
                        $round = round(($item->quantity_subjected / $undMed));                        
						$item->quantity_subjected = $round;
                    }                                        
                }
                $objectResult[] = $item;
                $itemNames[] = $item->name_reference;
            }

            // Ordenar alfabéticamente
            array_multisort($itemNames, SORT_ASC, $objectResult);
        }

        return $objectResult;
    }
    
    /**
     * Metodo para consultar el listado de referencias por rango de fechas (NO SE USA)
     * 
     * @param string $providerId
     * @param string $branchId
     * @param string $cellarId
     * @param string $startDate
     * @param string $endDate
     * @param integer $dateDiff
     * @param integer $projectionDay
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getItemsDiff($providerId, $branchId, $cellarId, 
            $startDate, $endDate, $dateDiff, $projectionDay) {
        
        $objectResult = [];
        $listSuggested = $this->_getSales($providerId, $branchId, 
                $cellarId, $dateDiff, $startDate, $endDate);	
        $listOrdes = $this->_getOrders($providerId, $branchId, 
                $cellarId, $dateDiff, $startDate, $endDate);
        
        $arrayNet = ArrayHelper::map($listSuggested, 'item','valor_neto');
        $sumNeto = array_sum($arrayNet);
        
        $orderByNet = array_keys($arrayNet);
        if(count($orderByNet)>0){
            $tempOrder = new Expression("IF(FIELD(reference,". implode(",", $orderByNet)
                .")=0,1,0) ASC,FIELD(reference,". implode(",", $orderByNet).")");
        }else{
            $tempOrder = 'description';
        }
        
        $items = Items::find()->where([
            'provider_id'=>$providerId,
            'branch_id'=>$branchId,
            'cellar_id'=>str_replace("&amp;","&",$cellarId),
        ])->orderBy($tempOrder)->all();
        
        if (count($items) > 0) { 
            
            $accumulated = 0;
            foreach ($items as $item) {
                $tempProjectionDay = 0;
                $item->reference = trim($item->reference);
                $quantSold = (isset($listSuggested[$item->reference]['cantidad'])) 
                        ? $listSuggested[$item->reference]['cantidad'] : 0;
                $item->quantity_sold = $quantSold;
                $item->consumption = (isset($listSuggested[$item->reference]['consumo'])) 
                        ? $listSuggested[$item->reference]['consumo'] : 0;
                $item->net = (isset($listSuggested[$item->reference]['valor_neto'])) 
                        ? $listSuggested[$item->reference]['valor_neto'] : 0;
                $item->per_partipipation = (isset($listSuggested[$item->reference]['valor_neto'])) 
                        ? $listSuggested[$item->reference]['valor_neto']/$sumNeto : 0;
                $accumulated = $accumulated + $item->per_partipipation;
                $quantityOrder = (isset($listOrdes[$item->reference]['cantidad'])) 
                        ? $listOrdes[$item->reference]['cantidad'] : 0;
                $item->accumulated = $accumulated * 100;
                $item->abc = ($item->accumulated <= 80 )?'A':(($item->accumulated <= 95)?'B':'C');
                $lostSale = $quantityOrder - $quantSold;
                $item->lost_sale = ($lostSale < 0)? 0 : $lostSale;
                $item->coverage = 0;
                # --------------------------------------------------------------
                switch ($item->abc) {
                    case Items::CAT_A:
                        $tempProjectionDay = $projectionDay;
                        break;
                    case Items::CAT_B:
                        $tempProjectionDay = $projectionDay + 2;
                        break;
                    case Items::CAT_C:
                        $tempProjectionDay = $projectionDay + 5;                        
                        break;
                    default:
                        $tempProjectionDay = $projectionDay;
                        break;
                }
                #---------------------------------------------------------------                                              
                if ($quantSold > 0) {
                    $item->coverage = round($item->quantity_inventory / ($quantSold/$dateDiff));
                    //$result = ((($quantSold * $projectionDay) - $item->quantity_inventory) - ($item->quantity_committed + $item->quantity_transit));
                    $result = ((($quantSold/$dateDiff)*$tempProjectionDay) - $item->quantity_inventory + $item->quantity_committed - $item->quantity_transit);
                    if ($result > 0) {
                        $item->quantity_subjected = round($result, 0);
                        //$item->quantity_subjected = $result;
                    } else {
                        $item->quantity_subjected = 0;
                    }
                } else {
                    $item->quantity_subjected = 0;
                    if($item->quantity_inventory > 0){
                        $item->coverage = round($item->quantity_inventory / $dateDiff);
                    }
                }
                
                if(trim($item->measured_unit) != Items::UNID){                
                    $undMed = preg_replace('/[^0-9]+/', '', $item->measured_unit);                                        
                    if($undMed > 0){
                        $round = round($item->quantity_subjected / $undMed);                        
                        $item->quantity_subjected = $round * $undMed;
                    }                                        
                }
                $objectResult[] = $item;
            }
        }
        return $objectResult;
    }

    /**
     * Metodo para obtener la unidad de medida del item
     * 
     * @param int $reference Referencia del item
     * 
     * @return boolean
     * @throws Exception
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getmeasuredUnit($reference) {
        try {
            if (!empty($reference) && is_numeric($reference)) {
                $sql = "
                SELECT f131_id_unidad_medida
                FROM t131_mc_items_barras
                JOIN t121_mc_items_extensiones ON f121_rowid = f131_rowid_item_ext
                JOIN t120_mc_items ON f121_rowid_item = f120_rowid
                WHERE f120_referencia = '" . $reference . "'";
                $result = Yii::$app->dbsql->createCommand($sql)->queryOne();
                if (isset($result['f131_id_unidad_medida']) && !empty($result['f131_id_unidad_medida'])) {
                    return $result['f131_id_unidad_medida'];
                }else{
                    return 'UNID';
                }
            }
        } catch (Exception $exc) {
            throw new Exception($exc);
        }
        return false;
    }

    /**
     * Retorna la unidad de negocio e informacion de la suscusal y el proveedor
     * 
     * @param int    $nit        Nit del proveedor
     * @param string $branchId Id de la sucursal
     * 
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getBusinessUnit($nit, $branchId) {
        $result = null;
        try {
            if (!empty($nit) && is_numeric($nit) && !empty($nit)) {
                $sql = "SELECT 
                    f200_nit AS nit,
                    f202_id_sucursal AS id_sucursal, 
                    f277_id_un as unidad_negocio
                FROM t202_mm_proveedores
                JOIN t200_mm_terceros AS suc ON f200_rowid = f202_rowid_tercero
                JOIN t277_co_tipo_prov ON f277_id = f202_id_tipo_prov
                WHERE f200_nit ='" . $nit . "' AND f202_id_sucursal = '"
                        . $branchId . "'";
                $result = Yii::$app->dbsql->createCommand($sql)->queryOne();
            }
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');             
        }
        return $result;
    }

    /**
     * Consulta la cantidad de unidades vendidas
     * desde la fecha
     * 
     * @param int $providerId  Id del proveedor
     * @param int $cellarId     Id bodega
     * @param int $dateDiff    Numero de dias atras
     * @param int $diasAdelante Numero de dias adelante
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getVentasAtras($providerId, $branchId, $cellarId, $dateDiff) {

        $arrayData = array();
        try {
            $sql = "
            Declare @Nit_Proveedor char(13), @Id_Sucursal char(3), @Id_Cia int, @Id_bodega Char(3), @Dias int, @Fecha_F Datetime, @Periodo_F char(6)

            set @Nit_proveedor ='" . $providerId . "'
            set @Id_Sucursal = '" . $branchId . "'
            set @Id_Cia = 1
            Set @Id_bodega = '" . str_replace("&amp;","&",$cellarId) . "'
            Set @Fecha_F = GETDATE()
            Set @Dias = " . $dateDiff . "

            SELECT
            qry.item,
            qry.Nombre_Item,
            qry.Bodega,
            qry_prov.proveedor,
            qry_prov.Sucursal_proveedor,
            qry.cantidad,
            qry.Valor_neto,
            (qry.Valor_neto/@dias)*30 Promedio_Neto_Mes
            from (
            SELECT 
            T120.f120_referencia AS Item,
            T120.f120_descripcion AS Nombre_Item,
            MFV.f470_rowid_item_ext as RItem,
            T150.F150_ID As Bodega,
            SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS Cantidad,
            SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN (MFV.f470_vlr_neto-MFV.f470_vlr_imp-MFV.f470_vlr_dscto_linea)*-1 ELSE MFV.f470_vlr_neto-MFV.f470_vlr_imp-MFV.f470_vlr_dscto_linea END)) AS Valor_neto
            FROM 
               (T150_MC_BODEGAS T150 RIGHT OUTER JOIN
                (t120_mc_items T120 RIGHT OUTER JOIN
                 (t121_mc_items_extensiones T121 RIGHT OUTER JOIN
                  (t350_co_docto_contable DOCPV RIGHT OUTER JOIN
                   (t460_cm_docto_remision_venta T460 RIGHT OUTER JOIN
                    (t470_cm_movto_invent MFV INNER JOIN t461_cm_docto_factura_venta FV
                     ON MFV.f470_rowid_docto_fact = FV.f461_rowid_docto
                     INNER JOIN t350_co_docto_contable DOCFAC
                     ON DOCFAC.f350_rowid = FV.f461_rowid_docto)
                    ON T460.f460_rowid_docto_factura = FV.f461_rowid_docto)
                   ON T460.f460_rowid_pv_docto = DOCPV.f350_rowid)
                  ON T121.f121_rowid = MFV.f470_rowid_item_ext)
                 ON T120.f120_rowid = T121.f121_rowid_item)
                ON T150.F150_ROWID = MFV.F470_ROWID_BODEGA) 
            WHERE ( DOCFAC.f350_fecha BETWEEN DATEADD(day, -1*(@Dias),@Fecha_F) AND @Fecha_F ) 
            AND T150.F150_ID =(@Id_bodega) 
            AND mfv.F470_ID_CIA = @Id_Cia
            GROUP BY T120.f120_referencia,T120.f120_descripcion, mfv.F470_ROWID_ITEM_EXT, T150.F150_ID
            ) qry

            --QUERY PROVEEDORES 
            INNER JOIN (
            SELECT 
            t470_comp.f470_rowid_item_ext AS RItem,
            T200.f200_id AS Proveedor,
            dtocmp.f451_id_sucursal_prov AS Sucursal_proveedor,
            RANK() OVER (PARTITION BY t470_comp.f470_rowid_item_ext ORDER BY SUM(CASE WHEN t470_comp.f470_ind_naturaleza = 2 THEN (-t470_comp.f470_cant_1) ELSE t470_comp.f470_cant_1 END) DESC) as Rango
            FROM 
            t470_cm_movto_invent t470_comp INNER JOIN t451_cm_docto_compras dtocmp
            ON dtocmp.f451_rowid_docto = t470_comp.f470_rowid_docto

            INNER JOIN t350_co_docto_contable t350_t1 
            ON t350_t1.f350_rowid = t470_comp.f470_rowid_docto

            LEFT JOIN t200_mm_terceros T200
            ON dtocmp.f451_rowid_tercero_prov = T200.f200_rowid

            WHERE 
            t350_t1.f350_id_clase_docto IN (408, 409, 410, 411, 412, 413, 414, 417, 420)
            AND (t470_comp.f470_id_fecha BETWEEN DATEADD(month, -3,@Fecha_F) AND @Fecha_F )
            AND T200.f200_id = @Nit_proveedor
            AND dtocmp.f451_id_sucursal_prov = @id_sucursal 

            GROUP BY 
            t470_comp.f470_rowid_item_ext, 
            T200.f200_id, 
            dtocmp.f451_id_sucursal_prov
            ) qry_prov
            ON qry.ritem = qry_prov.ritem
            AND qry_prov.RANGO = 1

            ORDER BY qry.item,qry.Bodega
            ";
            $raw = Yii::$app->dbsql->createCommand($sql)->queryAll();
            if (count($raw) > 0) {
                foreach ($raw as $value) {
                    $arrayData[trim($value['item'])] = (int) $value['cantidad'];
                }
            }
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');              
        }
        return $arrayData;
    }

    /**
     * Consulta la cantidad de unidades vendidas
     * por rango de fechas 
     * 
     * @param int $providerId  Id del proveedor
     * @param int $cellarId     Id bodega
     * @param int $dateDiff    Numero de dias atras
     * @param int $diasAdelante Numero de dias adelante
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getSales($providerId, $branchId, $cellarId, $dateDiff, $startDate, $endDate) {

        $arrayData = array();
        try {
            $endDate = date("d-m-Y", strtotime($endDate));
            $startDate = date("d-m-Y", strtotime($startDate));
            
            $cellars = "";
            $configCellarId = \Yii::$app->params['configCellarId'];
            $cellarId = str_replace("&amp;","&",$cellarId);
            if(isset($configCellarId[$cellarId])){
                $cellars = "'" . $cellarId  . "', " . "'" . $configCellarId[$cellarId]  ."'";
            }else{
                $cellars = "'" . $cellarId  . "'";
            }

            $sql = "
			
			SET NOCOUNT ON;
            SELECT
            LTRIM(RTRIM(qry.item)) as item,
            LTRIM(RTRIM(qry.Nombre_Item)) as Nombre_Item,
            LTRIM(RTRIM(qry_prov.proveedor)) as proveedor,
            LTRIM(RTRIM(qry_prov.razon_social)) as razon_social,
            LTRIM(RTRIM(qry_prov.Sucursal_proveedor)) as Sucursal_proveedor,
            qry_prov.precio,
            qry.cantidad,
            qry.valor_neto,
            (qry.Valor_neto/" . $dateDiff . ")*30 Promedio_Neto_Mes
            
            FROM (

                SELECT
                    T120.f120_referencia AS Item,
                    T120.f120_descripcion AS Nombre_Item,
                    MFV.f470_rowid_item_ext as RItem,
                    SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) ) AS Cantidad,
                    SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN (MFV.f470_vlr_neto-MFV.f470_vlr_imp-MFV.f470_vlr_dscto_linea)*-1 ELSE MFV.f470_vlr_neto-MFV.f470_vlr_imp-MFV.f470_vlr_dscto_linea END)) AS Valor_neto
                FROM
                   (T150_MC_BODEGAS T150 RIGHT OUTER JOIN
                    (t120_mc_items T120 RIGHT OUTER JOIN
                     (t121_mc_items_extensiones T121 RIGHT OUTER JOIN
                        (t470_cm_movto_invent MFV INNER JOIN t461_cm_docto_factura_venta FV
                         ON MFV.f470_rowid_docto_fact = FV.f461_rowid_docto
                         INNER JOIN t350_co_docto_contable DOCFAC
                         ON DOCFAC.f350_rowid = FV.f461_rowid_docto)
                      ON T121.f121_rowid = MFV.f470_rowid_item_ext)
                     ON T120.f120_rowid = T121.f121_rowid_item)
                    ON T150.F150_ROWID = MFV.F470_ROWID_BODEGA)
                WHERE (MFV.f470_id_fecha BETWEEN '" . $startDate . "' AND '" . $endDate . "' )
					AND T150.F150_ID IN (" . $cellars . ")
					AND mfv.F470_ID_CIA = 1
                GROUP BY 
					T120.f120_referencia,T120.f120_descripcion, mfv.F470_ROWID_ITEM_EXT

            )qry

            INNER JOIN (
                SELECT
                    t470_comp.f470_rowid_item_ext AS RItem,
                    T200.f200_id AS Proveedor,
                    T200.f200_razon_social as razon_social,
                    dtocmp.f451_id_sucursal_prov AS Sucursal_proveedor,
                    MAX(CASE WHEN t470_comp.f470_cant_base <> 0 THEN t470_comp.f470_vlr_bruto/t470_comp.f470_cant_base ELSE t470_comp.f470_precio_uni END) as precio,
                    RANK() OVER (PARTITION BY t470_comp.f470_rowid_item_ext ORDER BY SUM(CASE WHEN t470_comp.f470_ind_naturaleza = 2 THEN (-t470_comp.f470_cant_1) ELSE t470_comp.f470_cant_1 END) DESC) as Rango
                    
                FROM
                    t470_cm_movto_invent t470_comp INNER JOIN t451_cm_docto_compras dtocmp
                    ON dtocmp.f451_rowid_docto = t470_comp.f470_rowid_docto

                    INNER JOIN t350_co_docto_contable t350_t1
                    ON t350_t1.f350_rowid = t470_comp.f470_rowid_docto

                    LEFT JOIN t200_mm_terceros T200
                    ON dtocmp.f451_rowid_tercero_prov = T200.f200_rowid

                WHERE
                    t350_t1.f350_id_clase_docto IN (408, 409, 410, 411, 412, 413, 414, 417,420)
                    AND (t470_comp.f470_id_fecha <= '" . $endDate . "')
                    AND t470_comp.f470_cant_base <> 0
                    AND T200.f200_id = '" . $providerId . "'
                    AND dtocmp.f451_id_sucursal_prov = '" . $branchId . "' 

                GROUP BY
                    t470_comp.f470_rowid_item_ext,
                    T200.f200_id,
                    T200.f200_razon_social,
                    dtocmp.f451_id_sucursal_prov
            ) qry_prov

            ON qry.ritem = qry_prov.ritem
            AND qry_prov.RANGO = 1

            ORDER BY qry.valor_neto DESC
            ";

            // \Yii::error(__FILE__ . ':' . __LINE__ . '{'. print_r($sql, true) . '}', 'clientsiesa');

            $raw = Yii::$app->dbsql->createCommand($sql)->queryAll();
            
            // \Yii::error(__FILE__ . ':' . __LINE__ . '{'. print_r($raw, true) . '}', 'clientsiesa');

            if (count($raw) > 0) {
                foreach ($raw as $value) {
                    $arrayData[$value['item']] = $value;
                }
            }
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');              
        }
        return $arrayData;
    }
    
    /**
     * Consulta la cantidad de unidades pedidas
     * por rango de fechas 
     * 
     * @param int $providerId  Id del proveedor
     * @param int $cellarId     Id bodega
     * @param int $dateDiff    Numero de dias atras
     * @param int $diasAdelante Numero de dias adelante
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getOrders($providerId, $branchId, $cellarId, $dateDiff, $startDate, $endDate) {

        $arrayData = array();
        try {
            $endDate = date("d-m-Y", strtotime($endDate));
            $startDate = date("d-m-Y", strtotime($startDate));

            $cellars = "";
            $configCellarId = \Yii::$app->params['configCellarId'];
            $cellarId = str_replace("&amp;","&",$cellarId);
            if(isset($configCellarId[$cellarId])){
                $cellars = "'" . $cellarId  . "', " . "'" . $configCellarId[$cellarId]  ."'";
            }else{
                $cellars = "'" . $cellarId  . "'";
            }

            $sql = "
            SET NOCOUNT ON;
            SELECT
                LTRIM(RTRIM(qry.item)) as item,
                LTRIM(RTRIM(qry.Nombre_Item)) as Nombre_Item,
                LTRIM(RTRIM(qry_prov.proveedor)) as proveedor,
                LTRIM(RTRIM(qry_prov.razon_social)) as razon_social,
                LTRIM(RTRIM(qry_prov.Sucursal_proveedor)) as Sucursal_proveedor,
                qry.cantidad
            
            FROM (
                SELECT
                    T120.f120_referencia AS Item,
                    T120.f120_descripcion AS Nombre_Item,
                    MPV.f431_rowid_item_ext AS RItem,
                    SUM(MPV.F431_CANT1_PEDIDA) AS Cantidad
                FROM
                T430_CM_PV_DOCTO PV INNER JOIN T431_CM_PV_MOVTO MPV
                ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

                LEFT JOIN t121_mc_items_extensiones T121
                ON T121.f121_rowid = MPV.f431_rowid_item_ext
                AND f121_ind_estado = 1

                LEFT JOIN t120_mc_items T120
                ON T120.f120_rowid = T121.f121_rowid_item

                LEFT JOIN t150_mc_bodegas T150
                ON MPV.F431_ROWID_BODEGA = T150.f150_rowid

                Where
                    PV.f430_id_cia = 1
                    AND PV.f430_ind_estado IN(3,4)
                    AND f431_fecha_cumplido BETWEEN '" . $startDate . "' AND '" . $endDate . "'
                    AND T150.F150_ID IN (" . $cellars . ")
                GROUP BY
                    T120.f120_referencia,
                    T120.f120_descripcion,
                    MPV.f431_rowid_item_ext
            )qry

            INNER JOIN (
                SELECT
                t470_comp.f470_rowid_item_ext AS RItem,
                T200.f200_id AS Proveedor,
                T200.f200_razon_social as razon_social,
                dtocmp.f451_id_sucursal_prov AS Sucursal_proveedor,
                RANK() OVER (PARTITION BY t470_comp.f470_rowid_item_ext ORDER BY SUM(CASE WHEN t470_comp.f470_ind_naturaleza = 2 THEN (-t470_comp.f470_cant_1) ELSE t470_comp.f470_cant_1 END) DESC) as Rango
                FROM
                t470_cm_movto_invent t470_comp INNER JOIN t451_cm_docto_compras dtocmp
                ON dtocmp.f451_rowid_docto = t470_comp.f470_rowid_docto

                INNER JOIN t350_co_docto_contable t350_t1
                ON t350_t1.f350_rowid = t470_comp.f470_rowid_docto

                LEFT JOIN t200_mm_terceros T200
                ON dtocmp.f451_rowid_tercero_prov = T200.f200_rowid

                WHERE
                t350_t1.f350_id_clase_docto IN (408, 409, 410, 411, 412, 413, 414, 417,420)
                AND (t470_comp.f470_id_fecha <= '" . $endDate . "' ) and t470_comp.f470_cant_base <> 0
                AND T200.f200_id = '" . $providerId . "'
                AND dtocmp.f451_id_sucursal_prov = '" . $branchId . "' 

                GROUP BY
                t470_comp.f470_rowid_item_ext,
                T200.f200_id,
                T200.f200_razon_social,
                dtocmp.f451_id_sucursal_prov) qry_prov
            ON qry.ritem = qry_prov.ritem
            AND qry_prov.RANGO = 1

            ";  

            // \Yii::error(__FILE__ . ':' . __LINE__ . '{'. print_r($sql, true) . '}', 'clientsiesa');

            $raw = Yii::$app->dbsql->createCommand($sql)->queryAll();
            if (count($raw) > 0) {
                foreach ($raw as $value) {
                    $arrayData[$value['item']] = $value;
                }
            }
		
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'clientsiesa');              
        }
        return $arrayData;
    }

}

?>
