<?php

namespace app\components\purchases;

use Yii;
use yii\base\Component;
use yii\base\InvalidConfig\Exception;
use yii\helpers\ArrayHelper;
use app\models\Purchases;
use app\models\Itemspurchase;
use yii\db\Expression;
use app\components\purchases\ClientSiesa;

/**
 * HeaderOrder.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * HeaderOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class HeaderOrder extends Component
{

    /**
     * Numero de registro
     * @var int 
     */
    public $numeroReg;

    /**
     * Tipo de registro
     * @var int 
     */
    public $tipoReg;

    /**
     * Subtipo de registro
     * @var int 
     */
    public $subTipoReg;

    /**
     * version del tipo de registro
     * @var int 
     */
    public $versionReg;

    /**
     * Compañia
     * @var int 
     */
    public $cia;

    /**
     * Indicador para liquidar impuestos
     * @var int 
     */
    public $liquidaImpuesto;

    /**
     * Indica si el numero consecutivo de docto es manual o automático
     * @var int 
     */
    public $consecAutoReg;    

    /**
     * Centro de operación del documento
     * @var string
     */
    public $idCo;

    /**
     * Tipo de documento
     * @var string
     */
    public $idTipoDocto;

    /**
     * Numero de documento
     * @var int 
     */
    public $consecDocto;

    /**
     * Fecha del documento
     * @var string
     */
    public $idFecha;
    
    /**
     * Concepto
     * @var int
     */
    public $idConcepto;
    
    /**
     * Grupo clase documento
     * @var int
     */
    public $idGrupoClaseDocto;

    /**
     * Clase interna del documento
     * @var int 
     */
    public $idClaseDocto;

    /**
     * Estado del documento
     * @var int 
     */
    public $indEstado;
    
    /**
     * Estado de impresión del documento
     * @var int 
     */
    public $indImpresion;
    
    /**
     * Tercero comprador
     * @var string
     */
    public $idTerceroSolComp;
    
    /**
     * Tercero proveedor
     * @var string
     */
    public $idTerceroProv;
    
    /**
     * Sucursal proveedor
     * @var string
     */
    public $idSucursalProv;
    
    /**
     * Condicion de pago
     * @var string
     */
    public $idConPago;
    
    /**
     * Indicador de tasa
     * @var int
     */
    public $indTasa;
    
    /**
     * Codigo de moneda del documento
     * @var string
     */
    public $idMonedaDocto;

    /**
     * Moneda base de conversión
     * @var string
     */
    public $idMonedaConv;

    /**
     * Tasa de conversión
     * @var int 
     */
    public $tasaConv;

    /**
     * Moneda local
     * @var string
     */
    public $idMonedaLocal;

    /**
     * Tasa local 
     * @var int
     */
    public $tasaLocal;
    
    /**
     * Descento global 1
     * @var int
     */
    public $tasaDsctoGlobal1;
    
    /**
     * descuento global 2
     * @var int 
     */
    public $tasaDsctoGlobal2;
    
    /**
     * Observaciones del documento
     * @var string
     */
    public $notas;
    
    /**
     * Indicador de contacto
     * @var int
     */
    public $indContacto;
    
    /**
     * Contacto
     * @var string
     */
    public $contacto;
    
    /**
     * Direccion 1
     * @var string
     */
    public $direccion1;

    /**
     * Direccion 2
     * @var string
     */
    public $direccion2;

    /**
     * Direccion 3
     * @var string
     */
    public $direccion3;

    /**
     * Pais
     * @var string
     */
    public $idPais;

    /**
     * Departamento/estado
     * @var string
     */
    public $idDepto;

    /**
     * Ciudad
     * @var string
     */
    public $idCiudad;

    /**
     * Barrio
     * @var string
     */
    public $idBarrio;

    /**
     * Telefono
     * @var string
     */
    public $telefono;

    /**
     * Fax
     * @var string
     */
    public $fax;
    
    /**
     * Codigo postal
     * @var string
     */
    public $codPostal;

    /**
     * E-mail
     * @var string
     */
    public $email;
    
    /**
     * Orden de compra del Documento
     * @var string
     */
    public $numDoctoReferencia;
    
    /**
     * Mandato
     * @var string
     */
    public $idMandato;
    

    /**
     * Listado de las variables de tipo Int con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2013 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsInt()
    {
        return array(
            'numeroReg' => 7,
            'tipoReg' => 4,
            'subTipoReg' => 2,
            'versionReg' => 2,
            'cia' => 3,
            'liquidaImpuesto' => 1,
            'consecAutoReg' => 1,
            'consecDocto' => 8,
            'idConcepto'=>3,
            'idGrupoClaseDocto'=>3,
            'idClaseDocto' => 3,
            'indEstado' => 1,
            'indImpresion' => 1,
            'indTasa' => 1,
            'tasaConv' => 13,
            'tasaLocal' => 13,
            'tasaDsctoGlobal1'=>8,
            'tasaDsctoGlobal2'=>8,            
            'indContacto' => 1            
        );
    }

    /**
     * Listado de las variables de tipo String con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2013 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsString()
    {
        return array(
            'idCo' => 3,
            'idTipoDocto' => 3,
            'idFecha' => 8,   
            'idTerceroSolComp' => 15,            
            'idTerceroProv' => 15,  
            'idSucursalProv' => 3,    
            'idConPago' => 3,
            'idMonedaDocto' => 3,            
            'idMonedaConv' => 3,
            'idMonedaLocal' => 3,
            'notas' => 255, 
            'contacto' => 50,
            'direccion1' => 40,            
            'direccion2' => 40,            
            'direccion3' => 40,            
            'idPais' => 3,            
            'idDepto' => 2,            
            'idCiudad' => 3,            
            'idBarrio' => 40,            
            'telefono' => 20,            
            'fax' => 20,            
            'codPostal' => 10,            
            'email' => 50,
            'numDoctoReferencia' => 15,
            'idMandato' => 15
        );
    }

}

?>
