<?php
namespace app\components\purchases;

use Yii;
use yii\base\Component;
use yii\base\InvalidConfig\Exception;
use yii\helpers\ArrayHelper;
use app\models\Purchases;
use app\models\Itemspurchase;
use yii\db\Expression;
use app\components\purchases\ClientSiesa;

/**
 * ItemOrderOrde.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2019 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * ItemOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2019 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class ItemOrder extends Component 
{
    
    /**
     * Numero de registro
     * @var int
     */
    public $numeroReg;

    /**
     * Tipo de registro
     * @var int 
     */
    public $tipoReg;

    /**
     * Subtipo de registro
     * @var int 
     */
    public $subtipoReg;

    /**
     * Version del tipo de registro
     * @var int 
     */
    public $versionReg;

    /**
     * Compañía
     * @var int 
     */
    public $cia;

    /**
     * Centro de operación
     * @var string 
     */
    public $idCo;

    /**
     * Tipo de documento 
     * @var string
     */
    public $idTipoDocto;

    /**
     * Consecutivo de documento 
     * @var int 
     */
    public $consecDocto;

    /**
     * Numero de registro
     * @var int 
     */
    public $nroRegistro;
    
    /**
     * Campo vacio 1
     * @var string 
     */
    public $fCampo_1;    
    
    /**
     * Bodega
     * @var string
     */
    public $idBodega;

    /**
     * Concepto
     * @var int 
     */
    public $idConcepto;

    /**
     * Motivo
     * @var string
     */
    public $idMotivo;
    
    /**
     * Indicador de obsequio
     * @var int 
     */
    public $indObsequio;

    /**
     * Centro de operación movimiento
     * @var string
     */
    public $idCoMovto;
    
    /**
     * Campo vacio 2
     * @var string 
     */
    public $fCampo_2;
    
    /**
     * Centro de costo movimiento
     * @var string
     */
    public $idCcostoMovto;

    /**
     * Proyecto
     * @var string
     */
    public $idProyecto;
    
    /**
     * Unidad de medida
     * @var string
     */
    public $idUnidadMedida;

    /**
     * Cantidad base
     * @var int 
     */
    public $cantPedidaBase;
    
    /**
     * Fecha entrega del pedido
     * @var string
     */
    public $fechaEntrega;
    
    /**
     * Item del proveedor
     * @var string
     */
    public $codItemProv;
    
    /**
     * Precio unitario
     * @var int 
     */
    public $precioUnitario;
    
    /**
     * Notas
     * @var string
     */
    public $notas;

    /**
     * Descripcion
     * @var string
     */
    public $detalle;
    
    /**
     * Descripcion del item
     * @var string
     */
    public $fDescItem;
    
    /**
     * Unidad de medida del inventario del item
     * @var string
     */
    public $fIdUmInventario;
              
    /**
     * ItemOrder
     * @var int 
     */
    public $idItem;
    
    /**
     * Referencia item
     * @var string
     */
    public $referenciaItem;
                    
    /**
     * Codigo de barras
     * @var string
     */
    public $codigoBarras;

    /**
     * Extension 1
     * @var string
     */
    public $idExt1Detalle;

    /**
     * Extension 2
     * @var string
     */
    public $idExt2Detalle;        

    /**
     * Unidad de negocio movimiento
     * @var string
     */
    public $idUnMovto;
    
    /**
     * Tasa de descuento condicionado
     * @var int
     */
    public $tasaDsctoCondicionado;
   
    
    /**
     * Listado de las variables de tipo Int con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsInt()
    {
        return array(
            //Parametros para los items ----------------------------------------
            'numeroReg' => 7,
            'tipoReg' => 4,
            'subtipoReg' => 2,
            'versionReg' => 2,
            'cia' => 3,
            'consecDocto' => 8,
            'nroRegistro' => 10,
            'idConcepto' => 3,
            'indObsequio' => 1,
            'cantPedidaBase' => 20,
            'precioUnitario' => 20,            
            'idItem' => 7,
            'tasaDsctoCondicionado' => 8,                                                          
        );
    }

    /**
     * Listado de las variables de tipo String con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsString()
    {
        return array(
            'idCo' => 3,
            'idTipoDocto' => 3,
            'fCampo_1' => 55,
            'idBodega' => 5,
            'idMotivo' => 2,
            'idCoMovto' => 3,
            'fCampo_2' => 2,
            'idCcostoMovto' => 15,
            'idProyecto' => 15,
            'idUnidadMedida' => 4,
            'fechaEntrega' => 8,
            'codItemProv' => 15,
            'notas' => 255,
            'detalle' => 2000,
            'fDescItem' => 40,
            'fIdUmInventario' => 4,
            'referenciaItem' => 50,
            'codigoBarras' => 20,            
            'idExt1Detalle' => 20,
            'idExt2Detalle' => 20,            
            'idUnMovto' => 20,            
        );
    }

}

?>
