<?php

namespace app\controllers;

use Yii;
use app\models\Pending;
use app\models\PendingSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\models\Reasonresponsable;
use  yii\web\Session;

/**
 * PendingController implements the CRUD actions for Pending model.
 */
class PendingController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Pending models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new PendingSearch();
        $model = new Pending();
		$cookies = Yii::$app->response->cookies;
		
		$filter = '';
		
		$all = false;
        foreach ($_REQUEST as $key => $value) {
            if (strpos($key, '_tog') !== false) {
                if ($value == 'all') {
                    $all = true;
                }
            }
        }
		
        //Gaurdar datos --------------------------------------------------------
        if ($model->load(Yii::$app->request->post())) {       
			$filter = Yii::$app->request->post();
			$cookies->add(new \yii\web\Cookie([
				'name' => 'parmas_export_pending',
				'value' => $filter,
			]));
            $dataProvider = $searchModel->search(Yii::$app->request->post());
            $dataGraph = $searchModel->searchGraph(Yii::$app->request->post());
            if(isset($model->reasonId) && !empty($model->reasonId)){
                $reason = Reasonresponsable::findOne($model->reasonId);
                if(!empty($reason)){
                    if(!is_null(Yii::$app->request->post('selection'))
                        && is_array(Yii::$app->request->post('selection')) 
                        && (count(Yii::$app->request->post('selection'))>0)){
                        $selection = Yii::$app->request->post('selection');
                        foreach ($selection as $id) {
                            Pending::updateAll(['reason' => $reason->reason, 
                                'responsable' => $reason->responsable], ['id'=>$id]);
                        }
                    }else{
                        $model->addError('reasonId', Yii::t('app', 'pending no selected'));
                    }
                }else{
                    $model->addError('reasonId', Yii::t('app', 'incorrect reasonId'));
                }
                $selected = Yii::$app->request->post();
            }
        }elseif(!isset($_REQUEST['exportar'])){
			if(!$all){
				$filter = Yii::$app->request->queryParams;
				$cookies->add(new \yii\web\Cookie([
					'name' => 'parmas_export_pending',
					'value' => $filter,
				]));
				$queryParams = Yii::$app->request->queryParams;
			}else{
				$cookies1 = Yii::$app->request->cookies;
				$queryParams = $cookies1->getValue('parmas_export_pending');
			}
			
			$dataProvider = $searchModel->search(Yii::$app->request->queryParams);
			$dataGraph = $searchModel->searchGraph(Yii::$app->request->queryParams);
		}		
        
        //Campos editables -----------------------------------------------------
        if (isset($_POST['hasEditable']) && $_POST['hasEditable'] == 1) {
            \Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
            $pendingId = Yii::$app->request->post('editableKey');
            $modelAjax = Pending::findOne($pendingId);
            $posted = current($_POST['Pending']);
            $post = ['Pending' => $posted];
            if ($modelAjax->load($post)) {
                $modelAjax->save();
                return ['output'=>'', 'message'=>''];
            } else {
                return ['output'=>'', 'message'=>'Erorr'];
            }
        }
  
		
  
        if(isset($_REQUEST['exportar'])){

			$cookies1 = Yii::$app->request->cookies;
			$queryParams = $cookies1->getValue('parmas_export_pending');
			$dataProvider = $searchModel->searchExport($queryParams);
            return $this->render('_exportGrid', [
                'searchModel' => $searchModel,
                'dataProvider' => $dataProvider,
                'model' => $model,
            ]);
        }else{
			if($all == true){

				$cookies1 = Yii::$app->request->cookies;
				$queryParams = $cookies1->getValue('parmas_export_pending');
				$dataProvider = $searchModel->search($queryParams);
				$dataGraph = $searchModel->searchGraph($queryParams);
				return $this->render('index', [
					'searchModel' => $searchModel,
					'dataProvider' => $dataProvider,
					'model' => $model,
					'dataGraph' => $dataGraph,
				]);
			}else{
				return $this->render('index', [
					'searchModel' => $searchModel,
					'dataProvider' => $dataProvider,
					'model' => $model,
					'dataGraph' => $dataGraph,
				]);
			}
            
		} 
    }

    /**
     * Displays a single Pending model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Pending model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Pending();
        
        if ($model->load(Yii::$app->request->post())) {
            return $this->redirect(['view', 'id' => $model->id]);
        }
        
        return $this->render('_formProducts', [
            'model' => $model,
            'listProduct' => $model->getPendings(),
        ]);
    }

    /**
     * Updates an existing Pending model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Pending model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Pending model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Pending the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Pending::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException(Yii::t('app', 'The requested page does not exist.'));
    }
    
    /**
     * Retorna el listado de productos 
     * 
     * @return json
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version SVN: $Id$
     * @link http://www.ingeneo.com.co
     */
    public function actionGetitems() {       
        $model = new Purchases();
        if (Yii::$app->request->isAjax && $model->load(Yii::$app->request->post())) {
            $withPage = HtmlPurifier::process($_POST['withPage']);
            $listProduct = $model->getItems();
            return $this->renderAjax('_formProducts', [
                        'model' => $model,
                        'listProduct' => $listProduct,
                        'withPage' => $withPage,
            ]); 
        }     
    }
}
