<?php

namespace app\models;

use Yii;
use yii\db\ActiveRecord;
use yii\db\Expression;
use yii\behaviors\BlameableBehavior;

/**
 * This is the model class for table "classification_abc".
 *
 * @property integer $id
 * @property string $abc_cost
 * @property string $abc_margin
 * @property string $abc_result
 * @property string $abc_classification
 * @property string $created
 * @property string $created_by
 * @property string $updated
 * @property string $updated_by
 */
class Classificationabc extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'classification_abc';
    }
    
    public function behaviors() {
        return [
            'timestamp' => [
                'class' => 'yii\behaviors\TimestampBehavior',
                'attributes' => [
                    ActiveRecord::EVENT_BEFORE_INSERT => ['created', 'updated'],
                    ActiveRecord::EVENT_BEFORE_UPDATE => ['updated'],
                ],
                'value' => new Expression('NOW()'),
            ],
            'blameable' => [
                'class' => BlameableBehavior::className(),
                'attributes' => [
                    ActiveRecord::EVENT_BEFORE_INSERT => ['created_by', 'updated_by'],
                    ActiveRecord::EVENT_BEFORE_UPDATE => ['updated_by'],
                ],
                'value' => isset(Yii::$app->user->identity->username) ?
                Yii::$app->user->identity->username : '',
            ],
        ];
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['abc_cost', 'abc_margin', 'abc_result', 'abc_classification'], 'required'],
            [['created', 'updated'], 'safe'],
            [['abc_cost', 'abc_margin'], 'string', 'max' => 1],
            [['abc_result', 'abc_classification'], 'string', 'max' => 45],
            [['created_by', 'updated_by'], 'string', 'max' => 150],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'abc_cost' => Yii::t('app', 'Abc Cost'),
            'abc_margin' => Yii::t('app', 'Abc Margin'),
            'abc_result' => Yii::t('app', 'Abc Result'),
            'abc_classification' => Yii::t('app', 'Abc Classification'),
            'created' => Yii::t('app', 'Created'),
            'created_by' => Yii::t('app', 'Created By'),
            'updated' => Yii::t('app', 'Updated'),
            'updated_by' => Yii::t('app', 'Updated By'),
        ];
    }
}
