<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "cmp_user".
 *
 * @property int $usr_user_ID
 * @property string $usr_username Usuario
 * @property string $usr_password Contraseña
 * @property string $usr_email Correo
 * @property string $usr_status Estado n:nuevo, e:enable(activo), d:disable(inactivo)
 * @property string $usr_cedula
 */
class Cmpuser extends \yii\db\ActiveRecord
{
    const STATUS_ENABLED = 'e';
    const STATUS_DISABLED = 'd';
    const STATUS_NEW = 'n';
    const SUPER_ADMIN = 'Superadmin';
    const ADMIN = 'Administrador';  
    const GENERAL = 'General';  
    
    public $usr_password_repeat;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'cmp_user';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['usr_username', 'usr_password', 'usr_email', 'usr_password_repeat', 
                'usr_status', 'usr_cedula'], 'required', 'on' => ['crearuUs']],            
            //EDITAR USUARIO
            [['usr_username', 'usr_email', 'usr_cedula', 
                'usr_status'], 'required', 'on' => ['updateUs']],
            ['usr_password', 'compare', 'on' => ['updateUs', 'crearuUs']],
            ['usr_email', 'email'], 
            [['usr_status'], 'string'],
            [['usr_username'], 'string', 'max' => 45],
            [['usr_password'], 'string', 'max' => 200],
            [['usr_email'], 'string', 'max' => 120],
            [['usr_cedula'], 'integer'],
        ];
    }
    
    /**
     * 
     * @return string
     */
    public function scenarios()
    {
        $scenarios = parent::scenarios();        
        $scenarios['crearuUs'] = ['usr_username', 'usr_password', 'usr_email', 
            'usr_password_repeat', 'usr_status', 'usr_cedula'];        
        $scenarios['updateUs'] = ['usr_username', 'usr_email', 'usr_password', 
            'usr_password_repeat', 'usr_cedula', 'usr_status'];        
        return $scenarios;
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'usr_user_ID' => Yii::t('app', 'Usr User ID'),
            'usr_username' => Yii::t('app', 'Usr Username'),
            'usr_password' => Yii::t('app', 'Usr Password'),
            'usr_password_repeat' => Yii::t('app', 'Usr Password Repeat'),
            'usr_email' => Yii::t('app', 'Usr Email'),
            'usr_status' => Yii::t('app', 'Usr Status'),
            'usr_cedula' => Yii::t('app', 'Usr Cedula'),
        ];
    }
    
    /**
     * 
     * @param type $id
     * 
     * @return type
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function findIdentity($id) {
        return self::findOne($id);
    }
    
    /**
     * Retorna el strig segun el estado 
     * 
     * @param string $id
     * 
     * @return string
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function getStringStatus($status) {
        switch ($status) {
            case self::STATUS_NEW:
                return Yii::t('app', 'New');
                break;
            case self::STATUS_ENABLED:
                return Yii::t('app', 'Enable');
                break;
            default:
                return Yii::t('app', 'Disable');
                break;
        }
    }
}
