<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Cmpuser;

/**
 * CmpuserSearch represents the model behind the search form of `app\models\Cmpuser`.
 */
class CmpuserSearch extends Cmpuser
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['usr_user_ID'], 'integer'],
            [['usr_username', 'usr_password', 'usr_email', 'usr_status', 'usr_cedula'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Cmpuser::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'usr_user_ID' => $this->usr_user_ID,
        ]);

        $query->andFilterWhere(['like', 'usr_username', $this->usr_username])
            ->andFilterWhere(['like', 'usr_password', $this->usr_password])
            ->andFilterWhere(['like', 'usr_email', $this->usr_email])
            ->andFilterWhere(['like', 'usr_status', $this->usr_status])
            ->andFilterWhere(['like', 'usr_cedula', $this->usr_cedula]);

        return $dataProvider;
    }
}
