<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "data_fulfillment_provision".
 *
 * @property int $id
 * @property int $idtype
 * @property string $type
 * @property string $date
 * @property string $operation_center
 * @property int $value_fulfillment_unit
 * @property int $total_unit
 * @property int $value_fulfillment_money
 * @property int $total_money
 * @property int $value_fulfillment_order
 * @property int $total_order
 * @property int $value_fulfillment_references
 * @property int $total_references
 * @property string $created_at
 */
class DataFulfillmentProvision extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'data_fulfillment_provision';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['idtype', 'value_fulfillment_unit', 'total_unit', 'value_fulfillment_money', 'total_money', 'value_fulfillment_order', 'total_order', 'value_fulfillment_references', 'total_references'], 'integer'],
            [['created_at'], 'safe'],
            [['type'], 'string', 'max' => 20],
            [['date', 'operation_center'], 'string', 'max' => 45],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'idtype' => Yii::t('app', 'Idtype'),
            'type' => Yii::t('app', 'Type'),
            'date' => Yii::t('app', 'Date'),
            'operation_center' => Yii::t('app', 'Operation Center'),
            'value_fulfillment_unit' => Yii::t('app', 'Value Fulfillment Unit'),
            'total_unit' => Yii::t('app', 'Total Unit'),
            'value_fulfillment_money' => Yii::t('app', 'Value Fulfillment Money'),
            'total_money' => Yii::t('app', 'Total Money'),
            'value_fulfillment_order' => Yii::t('app', 'Value Fulfillment Order'),
            'total_order' => Yii::t('app', 'Total Order'),
            'value_fulfillment_references' => Yii::t('app', 'Value Fulfillment References'),
            'total_references' => Yii::t('app', 'Total References'),
            'created_at' => Yii::t('app', 'Created At'),
        ];
    }
    
    /**
     * Retorna la data dinamica 
     * 
     * @param type $select
     * @param type $where
     * @param type $groupBy
     * @param type $orderBy
     * @param type $having
     * @param type $dateIn
     * @param type $dateEnd
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2021 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function getData($select, $where, $groupBy, 
            $orderBy, $having, $dateIn, $dateEnd){
        $query = "SELECT " . $select 
                . " FROM data_fulfillment_provision"
                . $where ." "
                . $groupBy . " " 
                . $orderBy . " " 
                . $having;
        return Yii::$app->db->createCommand($query)->queryAll(); 
    }
}
