<?php

namespace app\models;

use Yii;
use yii\helpers\ArrayHelper;
use app\components\ReportSiesa;
use yii\data\ArrayDataProvider;
use app\components\HelperReport;
use kartik\grid\GridView;
use kartik\select2\Select2;
use app\models\BeforeModel;

/**
 * This is the model class for table "report_fulfillment_client".
 *
 * @property integer $id
 * @property string $name
 * @property string $paramsAdd
 * @property string $paramsDefault
 * @property string $filter
 * @property string $ejex
 * @property string $ejey
 * @property string $type
 * @property string $created
 * @property string $created_by
 * @property string $updated
 * @property string $updated_by
 * @property integer $user_id
 *
 * @property CmpUser $user
 */
class Fulfillmentclient extends BeforeModel
{
    public $document_type_order;
    public $document_type_invoice;
    public $number_order;
    public $date_order;
    public $number_invoice;
    public $date_invoice;
    public $number_delivery;
    public $status_delivery;
    public $reason_delivery;
    public $date_delivery;
    public $nit;
    public $business_name;
    public $branch_code;
    public $branch_name;
    public $reference;
    public $description;
    public $quantity_order;
    public $unit_value_order;
    public $quantity_invoice;
    public $unit_value_invoice;
    public $quantity_delivery;
    public $subtotal_order;
    public $subtotal_invoice;
    public $operation_center;
    public $fulfillment_unit;
    public $fulfillment_references;
    public $fulfillment_time;
    public $fulfillment_order;
    public $fulfillment_money;
    public $fulfillment_total;
    public $classification_order;
    public $accumulated_order;
    public $participation_order;
    public $classification_invoice;
    public $accumulated_invoice;
    public $participation_invoice;
    public $classification_general;
    public $classification_management;
    public $month;
    public $year;
    
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'report_fulfillment_client';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['name', 'user_id'], 'required', 'on' => ['create', 'update']],
            [['user_id'], 'required', 'on' => ['preview']],
            [['paramsAdd', 'paramsDefault', 'filter', 'ejex', 'ejey'], 'string'],
            //[['created', 'updated'], 'safe'],
            [['user_id'], 'integer'],
            [['name', 'created_by', 'updated_by'], 'string', 'max' => 150],
            [['type'], 'string', 'max' => 50],
            [['user_id'], 'exist', 'skipOnError' => true, 'targetClass' => Cmpuser::className(), 'targetAttribute' => ['user_id' => 'usr_user_ID']],
            [['document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice', 'classification_management',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order','date_delivery',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice','participation_invoice',
                'classification_general','month','year'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'paramsAdd' => Yii::t('app', 'Params Add'),
            'paramsDefault' => Yii::t('app', 'Params Default'),
            'filter' => Yii::t('app', 'Filter'),
            'ejex' => Yii::t('app', 'Ejex'),
            'ejey' => Yii::t('app', 'Ejey'),
            'type' => Yii::t('app', 'Type'),
            'created' => Yii::t('app', 'Created'),
            'created_by' => Yii::t('app', 'Created By'),
            'updated' => Yii::t('app', 'Updated'),
            'updated_by' => Yii::t('app', 'Updated By'),
            'user_id' => Yii::t('app', 'User ID'),
        ];
    }
    
    public function scenarios()
    {
        $scenarios = parent::scenarios();        
        $scenarios['create'] = ['name', 'paramsDefault', 'user_id',
                'document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice','date_delivery',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice',
                'participation_invoice','classification_general','month','year',
                'classification_management'];        
        $scenarios['update'] = ['name', 'paramsDefault', 'user_id',
                'document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice','date_delivery',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice',
                'participation_invoice','classification_general','month','year',
                'classification_management'];        
        $scenarios['preview'] = ['user_id',
                'document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice','date_delivery',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice','participation_invoice',
                'classification_general','month','year','classification_management'];        
        return $scenarios;
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUser()
    {
        return $this->hasOne(Cmpuser::className(), ['usr_user_ID' => 'user_id']);
    }
    
    /**
     * Listado de los parametros por defecto sin espacios
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsDefault() {
        $list = 'nit,business_name,branch_code,branch_name,reference,description';
        return str_replace(' ', '', $list);
    }

    /**
     * Listado de los parametros adicionales sin espacios
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsAdd() {
        $list = 'document_type_order,number_order,date_order,number_invoice,'
                . 'date_invoice,number_delivery,status_delivery,date_delivery,'
                . 'reason_delivery,quantity_order,unit_value_order,'
                . 'quantity_invoice,unit_value_invoice,quantity_delivery,'
                . 'subtotal_order,subtotal_invoice,operation_center,'
                . 'fulfillment_unit,fulfillment_references,fulfillment_time,'
                . 'fulfillment_order,fulfillment_money,fulfillment_total,'
                . 'classification_order,accumulated_order,'
                . 'participation_order,classification_invoice,'
                . 'accumulated_invoice,participation_invoice,classification_general,'
                . 'month,year,classification_management';
        return str_replace(' ', '', $list);
    }
    
    
    /**
     * Lisrados de parametros configurables en el reporte
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParams() {
        return [
            'document_type_order' => ['content' => Yii::t('app', 'Document Type Order')],
            'document_type_invoice' => ['content' => Yii::t('app', 'Document Type Invoice')],
            'number_order' => ['content' => Yii::t('app', 'Number Order')],
            'date_order' => ['content' => Yii::t('app', 'Date Order')],
            'number_invoice' => ['content' => Yii::t('app', 'Number Invoice')],
            'date_invoice' => ['content' => Yii::t('app', 'Date Invoice')],
            'date_delivery' => ['content' => Yii::t('app', 'Date Delivery')],
            'number_delivery' => ['content' => Yii::t('app', 'Number Delivery')],
            'status_delivery' => ['content' => Yii::t('app', 'Status Delivery')],
            'reason_delivery' => ['content' => Yii::t('app', 'Reason Delivery')],
            'nit' => ['content' => Yii::t('app', 'Nit')],
            'business_name' => ['content' => Yii::t('app', 'Business Name')],
            'branch_code' => ['content' => Yii::t('app', 'Branch Code')],
            'branch_name' => ['content' => Yii::t('app', 'Branch Name')],
            'reference' => ['content' => Yii::t('app', 'Reference')],
            'description' => ['content' => Yii::t('app', 'Description')],
            'quantity_order' => ['content' => Yii::t('app', 'Quantity Order')],
            'quantity_invoice' => ['content' => Yii::t('app', 'Quantity Invoice')],
            'quantity_delivery' => ['content' => Yii::t('app', 'Quantity Delivery')],
            'unit_value_order' => ['content' => Yii::t('app', 'Unit Value Order')],
            'unit_value_invoice' => ['content' => Yii::t('app', 'Unit Value Invoice')],
            'subtotal_order' => ['content' => Yii::t('app', 'Subtotal Order')],
            'subtotal_invoice' => ['content' => Yii::t('app', 'Subtotal Invoice')],
            'operation_center' => ['content' => Yii::t('app', 'Operation Center')],
            'fulfillment_unit' => ['content' => Yii::t('app', 'Fulfillment Unit')],
            'fulfillment_references' => ['content' => Yii::t('app', 'Fulfillment References')],
            'fulfillment_time' => ['content' => Yii::t('app', 'Fulfillment Time')],
            'fulfillment_order' => ['content' => Yii::t('app', 'Fulfillment Order')],
            'fulfillment_money' => ['content' => Yii::t('app', 'Fulfillment Money')],
            'fulfillment_total' => ['content' => Yii::t('app', 'Fulfillment Total')],
            'participation_order' => ['content' => Yii::t('app', 'Participation Order')],
            'accumulated_order' => ['content' => Yii::t('app', 'Accumulated Order')],
            'classification_order' => ['content' => Yii::t('app', 'Classification Order')],
            'participation_invoice' => ['content' => Yii::t('app', 'Participation Invoice')],
            'accumulated_invoice' => ['content' => Yii::t('app', 'Accumulated Invoice')],
            'classification_invoice' => ['content' => Yii::t('app', 'Classification Invoice')],
            'classification_general' => ['content' => Yii::t('app', 'Classification General')],
            'classification_management' => ['content' => Yii::t('app', 'Classification Managment')],
            'month' => ['content' => Yii::t('app', 'Month')],
            'year' => ['content' => Yii::t('app', 'Year')],
            'date' => ['content' => Yii::t('app', 'Date')],
        ];
    }
    
    /**
     * Metodo que retorna el listado de las columnas para el grid
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsGrid() {
        # Traemos todos los meses para el filtro -------------------------------
        $months = [1=>'Enero', 2=>'Febrero', 3=>'Marzo', 4=>'Abril', 5=>'Mayo', 
			6=>'Junio', 7=>'Julio', 8=>'Agosto', 9=>'Septiembre', 10=>'Octubre', 
			11=>'Noviembre', 12=>'Diciembre'];
  
        return [
            'document_type_order' => [
                'attribute' => 'document_type_order',
                'label' => Yii::t('app', 'Document Type Order'),
            ],            
            'document_type_invoice' => [
                'attribute' => 'document_type_invoice',
                'label' => Yii::t('app', 'Document Type Invoice'),
            ],            
            'number_order' => [
                'attribute' => 'number_order',
                'label' => Yii::t('app', 'Number Order'),
            ], 
            'date_order' => [
                'attribute' => 'date_order',
                'label' => Yii::t('app', 'Date Order'),
                'filterType' => GridView::FILTER_DATE_RANGE,
                'filterWidgetOptions' => [
                    'options' => ['placeholder' => 'Rango Fechas', 'readonly'=>true],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'locale'=>[                            
                            'format' => 'DD-MM-YYYY',
                            'separator'=>' - ',
                        ],                        
                    ],
                ],                
                'width' => '200px',
            ],
            'number_invoice' => [
                'attribute' => 'number_invoice',
                'label' => Yii::t('app', 'Number Invoice'),
            ], 
            'date_invoice' => [
                'attribute' => 'date_invoice',
                'label' => Yii::t('app', 'Date Invoice'),
                'filterType' => GridView::FILTER_DATE_RANGE,
                'filterWidgetOptions' => [
                    'options' => ['placeholder' => 'Rango Fechas', 'readonly'=>true],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'locale'=>[                            
                            'format' => 'DD-MM-YYYY',
                            'separator'=>' - ',
                        ],                        
                    ],
                ],                
                'width' => '200px',
            ],
            'date_delivery' => [
                'attribute' => 'date_delivery',
                'label' => Yii::t('app', 'Date Delivery'),
                'filterType' => GridView::FILTER_DATE_RANGE,
                'filterWidgetOptions' => [
                    'options' => ['placeholder' => 'Rango Fechas', 'readonly'=>true],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'locale'=>[                            
                            'format' => 'DD-MM-YYYY',
                            'separator'=>' - ',
                        ],                        
                    ],
                ],                
                'width' => '200px',
            ],
            'number_delivery' => [
                'attribute' => 'number_delivery',
                'label' => Yii::t('app', 'Number Delivery'),
            ],            
            'status_delivery' => [
                'attribute' => 'status_delivery',
                'label' => Yii::t('app', 'Status Delivery'),
            ],            
            'reason_delivery' => [
                'attribute' => 'reason_delivery',
                'label' => Yii::t('app', 'Reason Delivery'),
            ],                     
            'nit' => [
                'attribute' => 'nit',
                'label' => Yii::t('app', 'Nit'),
            ],            
            'business_name' => [
                'attribute' => 'business_name',
                'label' => Yii::t('app', 'Business Name'),
            ],            
            'branch_code' => [
                'attribute' => 'branch_code',
                'label' => Yii::t('app', 'Branch Code'),
            ],            
            'branch_name' => [
                'attribute' => 'branch_name',
                'label' => Yii::t('app', 'Branch Name'),
            ],            
            'reference' => [
                'attribute' => 'reference',
                'label' => Yii::t('app', 'Reference'),
            ],
            'description' => [
                'attribute' => 'description',
                'label' => Yii::t('app', 'Description'),
            ],
            'quantity_order' => [
                'attribute' => 'quantity_order',
                'label' => Yii::t('app', 'Quantity Order'),
                'value' => function($data){
                    return number_format($data['quantity_order']);
                }
            ],
            'unit_value_order' => [
                'attribute' => 'unit_value_order',
                'label' => Yii::t('app', 'Unit Value Order'),
                'value' => function($data){
                    return '$ '.number_format($data['unit_value_order']);
                }
            ],
            'quantity_invoice' => [
                'attribute' => 'quantity_invoice',
                'label' => Yii::t('app', 'Quantity Invoice'),
                'value' => function($data){
                    return number_format($data['quantity_invoice']);
                }
            ],
            'unit_value_invoice' => [
                'attribute' => 'unit_value_invoice',
                'label' => Yii::t('app', 'Unit Value Invoice'),
                'value' => function($data){
                    return '$ '.number_format($data['unit_value_invoice']);
                }
            ],
            'quantity_delivery' => [
                'attribute' => 'quantity_delivery',
                'label' => Yii::t('app', 'Quantity Delivery'),
                'value' => function($data){
                    return number_format($data['quantity_delivery']);
                }
            ],
            'subtotal_order' => [
                'attribute' => 'subtotal_order',
                'label' => Yii::t('app', 'Subtotal Order'),
                'value' => function($data){
                    return '$ '.number_format($data['subtotal_order']);
                }
            ],
            'subtotal_invoice' => [
                'attribute' => 'subtotal_invoice',
                'label' => Yii::t('app', 'Subtotal Invoice'),
                'value' => function($data){
                    return '$ '.number_format($data['subtotal_invoice']);
                }
            ],
            'operation_center' => [
                'attribute' => 'operation_center',
                'label' => Yii::t('app', 'Operation Center'),
            ],
            'fulfillment_unit' => [
                'attribute' => 'fulfillment_unit',
                'label' => Yii::t('app', 'Fulfillment Unit'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_unit'], 2);
                }
            ],
            'fulfillment_references' => [
                'attribute' => 'fulfillment_references',
                'label' => Yii::t('app', 'Fulfillment References'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_references'], 2);
                }
            ],
            'fulfillment_time' => [
                'attribute' => 'fulfillment_time',
                'label' => Yii::t('app', 'Fulfillment Time'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_time'], 2);
                }
            ],
            'fulfillment_order' => [
                'attribute' => 'fulfillment_order',
                'label' => Yii::t('app', 'Fulfillment Order'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_order'], 2);
                },
            ],
            'fulfillment_money' => [
                'attribute' => 'fulfillment_money',
                'label' => Yii::t('app', 'Fulfillment Money'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_money'], 2);
                },
            ],
            'fulfillment_total' => [
                'attribute' => 'fulfillment_total',
                'label' => Yii::t('app', 'Fulfillment Total'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_total'], 2);
                },
            ],
            'classification_management' => [
                'attribute' => 'classification_management',
                'label' => Yii::t('app', 'Classification Managment'),
                'filter'=>false,
                'value' => function($data){
                    return ($data['fulfillment_total'] >= 90 )
                            ? Yii::t('app', 'Trustworthy') : Yii::t('app', 'No Trustworthy');
                },
            ],
            'classification_general' => [
                'attribute' => 'classification_general',
                'filter' => false,
                'label' => Yii::t('app', 'Classification General'),
                'value' => function($data) use (&$genAccClassOrder, 
                        &$genAccClassInvoice){
                    $genAccClassOrder = ($data['subtotal_order']/$data['total_order'])*100+ $genAccClassOrder;
                    $classOrder = ($genAccClassOrder <= 80 )?'A':(($genAccClassOrder <= 95)?'B':'C');
                    
                    $genAccClassInvoice = ($data['subtotal_invoice']/$data['total_invoice'])*100+ $genAccClassInvoice;
                    $classInvoice = ($genAccClassInvoice <= 80 )?'A':(($genAccClassInvoice <= 95)?'B':'C');
                    
                    $classAbc = Classificationabc::findOne(['abc_cost'=>$classOrder, 'abc_margin'=>$classInvoice]);
                    return (isset($classAbc->abc_classification)? $classAbc->abc_classification : null);
                    
                },
            ],
            'classification_order' => [
                'attribute' => 'classification_order',
                'filter' => false,
                'label' => Yii::t('app', 'Classification Order'),
                'value' => function($data) use (&$accClassOrder){
                    $accClassOrder = ($data['subtotal_order']/$data['total_order'])*100+ $accClassOrder;
                    return ($accClassOrder <= 80 )?'A':(($accClassOrder <= 95)?'B':'C');
                },
            ],
            'accumulated_order' => [
                'attribute' => 'accumulated_order',
                'filter' => false,
                'label' => Yii::t('app', 'Accumulated Order'),
                'value' => function($data) use (&$accOrder){
                    $accOrder = ($data['subtotal_order']/$data['total_order'])*100+ $accOrder;
                    return number_format($accOrder,2);
                },
            ],
            'participation_order' => [
                'attribute' => 'participation_order',
                'filter' => false,
                'label' => Yii::t('app', 'Participation Order'),
                'value' => function($data){
                    return number_format(($data['subtotal_order']/$data['total_order'])*100,2);
                },
            ],
            'classification_invoice' => [
                'attribute' => 'classification_invoice',
                'filter' => false,
                'label' => Yii::t('app', 'Classification Invoice'),
                'value' => function($data) use (&$accClassInvoice){
                    $accClassInvoice = ($data['subtotal_invoice']/$data['total_invoice'])*100+ $accClassInvoice;
                    return ($accClassInvoice <= 80 )?'A':(($accClassInvoice <= 95)?'B':'C');
                },
            ],
            'accumulated_invoice' => [
                'attribute' => 'accumulated_invoice',
                'filter' => false,
                'label' => Yii::t('app', 'Accumulated Invoice'),
                'value' => function($data) use (&$accInvoice){
                    $accInvoice = ($data['subtotal_invoice']/$data['total_invoice'])*100+ $accInvoice;
                    return number_format($accInvoice,2);
                },
            ],
            'participation_invoice' => [
                'attribute' => 'participation_invoice',
                'filter' => false,
                'label' => Yii::t('app', 'Participation Invoice'),
                'value' => function($data){
                    return number_format(($data['subtotal_invoice']/$data['total_invoice'])*100,2);
                },
            ],
            'month' =>
            [                
                'attribute' => 'month',
                'label' => Yii::t('app', 'Month'),
                'width' => '150px',
                'filter'=>$months, 
                'filterType'=>  GridView::FILTER_SELECT2,
                'filterWidgetOptions'=>[
                    'options' => ['multiple' => false],
                    'theme' => Select2::THEME_BOOTSTRAP,
                    'pluginOptions'=>['allowClear'=>true,'tags' => true,],
                ],
//                'value' => function($model) use($months){            
//                    return isset($months[$model['month']-1]) ? $months[$model['month']-1] : null;
//                },                                
                'group'=>true, 
                'groupedRow'=>false,
                'subGroupOf'=>'year',
            ],
            'year' => [                
                'attribute' => 'year',
                'label' => Yii::t('app', 'Year'),
                'value' => 'year',                                
                'group'=>true, 
                'groupedRow'=>false,
                'filter'=>array_combine(range(date('Y'), date('Y')-5),range(date('Y'), date('Y')-5))                
            ],
        ];
    }
    
    /**
     * Retorna los parametrso que van en el select del B2BiSiesa
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsSelect($params) {  
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = "month_order as month";
                $selectYear = 'year_order as year';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = "month_invoice as month";
                $selectYear = 'year_invoice as year';
                break;
            default:
                $selectMonth = "month_default as month";
                $selectYear = 'year_default as year';
                break;
        }  
        $fulfillment_unit = "IFNULL(((SUM(quantity_delivery)/IFNULL(SUM(quantity_order),0))*100),0)";
//        $fulfillment_unit = "(CASE  
//                    WHEN ($fulfillment_unit) > 100  THEN 100
//                    WHEN ($fulfillment_unit) < 0 THEN 0
//                    ELSE ($fulfillment_unit) END)";
//        $fulfillment_references = "IFNULL((100 - (CAST(SUM(CASE WHEN f464_ind_estado = '2' THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN f464_ind_estado != '2' THEN 1 ELSE 0 END) AS DECIMAL(15,2)),0))*100),0)";
        $fulfillment_references = "(CASE WHEN (SUM(CASE WHEN quantity_order <> quantity_delivery THEN 1 ELSE 0 END) = SUM(total_ref_inc) AND SUM(quantity_delivery) = 0) THEN 0 ELSE IFNULL(100-(CAST(SUM(CASE WHEN quantity_order <> quantity_delivery THEN 1 ELSE 0 END)AS DECIMAL(15,2)) / total_references)*100,0) END)";
//        $fulfillment_references = "(CASE  
//                    WHEN $fulfillment_references > 100 THEN 100
//                    WHEN $fulfillment_references < 0 THEN 0
//                    ELSE $fulfillment_references END)";
//        $fulfillment_time = "IFNULL(((CAST(SUM(CASE WHEN date_delivery = date_invoice OR DATE_ADD(date_invoice, INTERVAL 1 DAY) = date_delivery THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN date_delivery = date_invoice OR DATE_ADD(date_invoice, INTERVAL 1 DAY) = date_delivery THEN 1 ELSE 0 END) + SUM(CASE WHEN date_delivery > DATE_ADD(date_invoice, INTERVAL 1 DAY) THEN 1 ELSE 0 END)  AS DECIMAL(15,2)),0))*100),0)";
        $fulfillment_time = 'IFNULL(((CAST(SUM(CASE WHEN date_delivery <= DATE_ADD(date_invoice, INTERVAL 1 DAY) THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN date_delivery <= DATE_ADD(date_invoice, INTERVAL 1 DAY) THEN 1 ELSE 0 END) +  SUM(CASE WHEN date_delivery > DATE_ADD(date_invoice, INTERVAL 1 DAY)  THEN 1 ELSE 0 END)   AS DECIMAL(15,2)),0))*100),0)';
//        $fulfillment_time = "(CASE  
//                    WHEN $fulfillment_time > 100  THEN 100
//                    WHEN $fulfillment_time < 0 THEN 0
//                    ELSE $fulfillment_time END)";
        $fulfillment_order = "IFNULL((100 - (CAST(SUM(CASE WHEN quantity_delivery < quantity_order THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN quantity_delivery = quantity_order THEN 1 ELSE 0 END) AS DECIMAL(15,2)),0))*100),0)";
//        $fulfillment_order = "(CASE  
//                    WHEN $fulfillment_order > 100  THEN 100
//                    WHEN $fulfillment_order < 0 THEN 0
//                    ELSE $fulfillment_order END)";
        $fulfillment_money = "IFNULL(((SUM(unit_value_order*quantity_invoice)/IFNULL(SUM(quantity_delivery*unit_value_order),0))*100),0)";
//        $fulfillment_money = "(CASE  
//                    WHEN $fulfillment_money > 100  THEN 100
//                    WHEN $fulfillment_money < 0 THEN 0
//                    ELSE $fulfillment_money END)";
        $fulfillment_total = '(('.$fulfillment_time.' + '.$fulfillment_references.')*0.3)'
                    .'+(('.$fulfillment_unit.'+'.$fulfillment_money.')*0.15)'
                    .'+('.$fulfillment_order.'*0.1)';
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'document_type_order',
            'document_type_invoice' => 'document_type_invoice',
            'number_order' => 'number_order',
            'date_order' => 'date_order',
            'number_invoice' => 'number_invoice',
            'date_invoice' => 'date_invoice',
            'date_delivery' => 'date_delivery',
            'number_delivery' => 'number_delivery',
            'status_delivery' => 'status_delivery',
            'reason_delivery' => 'reason_delivery',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'quantity_order' => 'quantity_order',
            'unit_value_order' => 'unit_value_order',
            'quantity_invoice' => 'quantity_invoice',
            'unit_value_invoice' => 'unit_value_invoice',
            'quantity_delivery' => 'quantity_delivery',
            'subtotal_order' => 'subtotal_order',
            'subtotal_invoice' => 'subtotal_invoice',
            'operation_center' => 'operation_center',
            'fulfillment_unit' => "$fulfillment_unit AS fulfillment_unit",
            'fulfillment_references' => "$fulfillment_references AS fulfillment_references",
            'fulfillment_time' => "$fulfillment_time AS fulfillment_time",
            'fulfillment_order' => "$fulfillment_order as fulfillment_order",
            'fulfillment_money' => "$fulfillment_money AS fulfillment_money",
            'fulfillment_total' => "$fulfillment_total AS fulfillment_total",
            'classification_management' => "$fulfillment_total AS fulfillment_total",
            'accumulated_order' => 'subtotal_order && total_order',
            'participation_order' => 'subtotal_order && total_order',
            'classification_order' => 'subtotal_order && total_order',
            'accumulated_invoice' => 'subtotal_invoice && total_invoice',
            'participation_invoice' => 'subtotal_invoice && total_invoice',
            'classification_invoice' => 'subtotal_invoice && total_invoice',
            'classification_general' => 'subtotal_invoice && total_invoice && subtotal_order && total_order',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametrso que van en el select del B2BiSiesa
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsSelectGraph($params) {                
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = "month_order as month";
                $selectYear = 'year_order as year';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = "month_invoice as month";
                $selectYear = 'year_invoice as year';
                break;
            default:
                $selectMonth = "month_default as month";
                $selectYear = 'year_default as year';
                break;
        }  
        $fulfillment_unit = "IFNULL(((SUM(quantity_delivery)/IFNULL(SUM(quantity_order),0))*100),0)";
//        $fulfillment_unit = "(CASE  
//                    WHEN ($fulfillment_unit) > 100  THEN 100
//                    WHEN ($fulfillment_unit) < 0 THEN 0
//                    ELSE ($fulfillment_unit) END)";
//        $fulfillment_references = "IFNULL((100 - (CAST(SUM(CASE WHEN f464_ind_estado = '2' THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN f464_ind_estado != '2' THEN 1 ELSE 0 END) AS DECIMAL(15,2)),0))*100),0)";
        $fulfillment_references = "(CASE WHEN (SUM(CASE WHEN quantity_order <> quantity_delivery THEN 1 ELSE 0 END) = SUM(total_ref_inc) AND SUM(quantity_delivery) = 0) THEN 0 ELSE IFNULL(100-(CAST(SUM(CASE WHEN quantity_order <> quantity_delivery THEN 1 ELSE 0 END)AS DECIMAL(15,2)) / total_references)*100,0) END)";
//        $fulfillment_references = "(CASE  
//                    WHEN $fulfillment_references > 100 THEN 100
//                    WHEN $fulfillment_references < 0 THEN 0
//                    ELSE $fulfillment_references END)";
//        $fulfillment_time = "IFNULL(((CAST(SUM(CASE WHEN date_delivery = date_invoice OR DATE_ADD(date_invoice, INTERVAL 1 DAY) = date_delivery THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN date_delivery = date_invoice OR DATE_ADD(date_invoice, INTERVAL 1 DAY) = date_delivery THEN 1 ELSE 0 END) + SUM(CASE WHEN date_delivery > DATE_ADD(date_invoice, INTERVAL 1 DAY) THEN 1 ELSE 0 END)  AS DECIMAL(15,2)),0))*100),0)";
        $fulfillment_time = 'IFNULL(((CAST(SUM(CASE WHEN date_delivery <= DATE_ADD(date_invoice, INTERVAL 1 DAY) THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN date_delivery <= DATE_ADD(date_invoice, INTERVAL 1 DAY) THEN 1 ELSE 0 END) +  SUM(CASE WHEN date_delivery > DATE_ADD(date_invoice, INTERVAL 1 DAY)  THEN 1 ELSE 0 END)   AS DECIMAL(15,2)),0))*100),0)';
//        $fulfillment_time = "(CASE  
//                    WHEN $fulfillment_time > 100  THEN 100
//                    WHEN $fulfillment_time < 0 THEN 0
//                    ELSE $fulfillment_time END)";
        $fulfillment_order = "IFNULL((100 - (CAST(SUM(CASE WHEN quantity_delivery < quantity_order THEN 1 ELSE 0 END) AS DECIMAL(15,2)) / IFNULL(CAST(SUM(CASE WHEN quantity_delivery = quantity_order THEN 1 ELSE 0 END) AS DECIMAL(15,2)),0))*100),0)";
//        $fulfillment_order = "(CASE  
//                    WHEN $fulfillment_order > 100  THEN 100
//                    WHEN $fulfillment_order < 0 THEN 0
//                    ELSE $fulfillment_order END)";
        $fulfillment_money = "IFNULL(((SUM(unit_value_order*quantity_invoice)/IFNULL(SUM(quantity_delivery*unit_value_order),0))*100),0)";
//        $fulfillment_money = "(CASE  
//                    WHEN $fulfillment_money > 100  THEN 100
//                    WHEN $fulfillment_money < 0 THEN 0
//                    ELSE $fulfillment_money END)";
        $fulfillment_total = '(('.$fulfillment_time.' + '.$fulfillment_references.')*0.3)'
                    .'+(('.$fulfillment_unit.'+'.$fulfillment_money.')*0.15)'
                    .'+('.$fulfillment_order.'*0.1)';
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'document_type_order',
            'document_type_invoice' => 'document_type_invoice',
            'number_order' => 'number_order',
            'date_order' => 'date_order',
            'number_invoice' => 'number_invoice',
            'date_invoice' => 'date_invoice',
            'date_delivery' => 'date_delivery',
            'number_delivery' => 'number_delivery',
            'status_delivery' => 'status_delivery',
            'reason_delivery' => 'reason_delivery',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'quantity_order' => 'quantity_order',
            'unit_value_order' => 'unit_value_order',
            'quantity_invoice' => 'quantity_invoice',
            'unit_value_invoice' => 'unit_value_invoice',
            'quantity_delivery' => 'quantity_delivery',
            'subtotal_order' => 'subtotal_order',
            'subtotal_invoice' => 'subtotal_invoice',
            'operation_center' => 'operation_center',
            'fulfillment_unit' => "$fulfillment_unit AS fulfillment_unit",
            'fulfillment_references' => "$fulfillment_references AS fulfillment_references",
            'fulfillment_time' => "$fulfillment_time AS fulfillment_time",
            'fulfillment_order' => "$fulfillment_order as fulfillment_order",
            'fulfillment_money' => "$fulfillment_money AS fulfillment_money",
            'fulfillment_total' => "$fulfillment_total AS fulfillment_total",
            'classification_management' => "$fulfillment_total AS fulfillment_total",
            'accumulated_order' => 'subtotal_order && total_order',
            'participation_order' => 'subtotal_order && total_order',
            'classification_order' => 'subtotal_order && total_order',
            'accumulated_invoice' => 'subtotal_invoice && total_invoice',
            'participation_invoice' => 'subtotal_invoice && total_invoice',
            'classification_invoice' => 'subtotal_invoice && total_invoice',
            'classification_general' => 'subtotal_invoice && total_invoice && subtotal_order && total_order',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsGroupBy($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = "month_order";
                $selectYear = 'year_order';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = "month_invoice";
                $selectYear = 'year_invoice';
                break;
            default:
                $selectMonth = "month_default";
                $selectYear = 'year_default';
                break;
        }      
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'document_type_order',
            'document_type_invoice' => 'document_type_invoice',
            'number_order' => 'number_order',
            'date_order' => 'date_order',
            'number_invoice' => 'number_invoice',
            'date_invoice' => 'date_invoice',
            'date_delivery' => 'date_delivery',
            'number_delivery' => 'number_delivery',
            'status_delivery' => 'status_delivery',
            'reason_delivery' => 'reason_delivery',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'operation_center' => 'operation_center',
            'quantity_order' => 'quantity_order',
            'unit_value_order' => 'unit_value_order',
            'quantity_invoice' => 'quantity_invoice',
            'unit_value_invoice' => 'unit_value_invoice',
            'quantity_delivery' => 'quantity_delivery',
            'fulfillment_references' => 'total_references',
            'fulfillment_money' => 'total_unit_value_invoice',
            'fulfillment_total' => 'total_references',
            'classification_management' => 'total_references',
            'accumulated_order' => 'subtotal_order,total_order',
            'participation_order' => 'subtotal_order,total_order',
            'classification_order' => 'subtotal_order,total_order',
            'accumulated_invoice' => 'subtotal_invoice,total_invoice',
            'participation_invoice' => 'subtotal_invoice,total_invoice',
            'classification_invoice' => 'subtotal_invoice,total_invoice',
            'classification_general' => 'subtotal_invoice,total_invoice,subtotal_invoice,total_invoice',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsGroupByGraph($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = "month_order";
                $selectYear = 'year_order';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = "month_invoice";
                $selectYear = 'year_invoice';
                break;
            default:
                $selectMonth = "month_default";
                $selectYear = 'year_default';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'document_type_order',
            'document_type_invoice' => 'document_type_invoice',
            'number_order' => 'number_order',
            'date_order' => 'date_order',
            'number_invoice' => 'number_invoice',
            'date_invoice' => 'date_invoice',
            'date_delivery' => 'date_delivery',
            'number_delivery' => 'number_delivery',
            'status_delivery' => 'status_delivery',
            'reason_delivery' => 'reason_delivery',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'operation_center' => 'operation_center',
            'quantity_order' => 'quantity_order',
            'unit_value_order' => 'unit_value_order',
            'quantity_invoice' => 'quantity_invoice',
            'unit_value_invoice' => 'unit_value_invoice',
            'quantity_delivery' => 'quantity_delivery',
            'fulfillment_references' => 'total_references',
            'fulfillment_money' => 'total_unit_value_invoice',
            'fulfillment_total' => 'total_references',
            'classification_management' => 'total_references',
            'accumulated_order' => 'subtotal_order,total_order',
            'participation_order' => 'subtotal_order,total_order',
            'classification_order' => 'subtotal_order,total_order',
            'accumulated_invoice' => 'subtotal_invoice,total_invoice',
            'participation_invoice' => 'subtotal_invoice,total_invoice',
            'classification_invoice' => 'subtotal_invoice,total_invoice',
            'classification_general' => 'subtotal_invoice,total_invoice,subtotal_invoice,total_invoice',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsOrderBy($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = "month_order";
                $selectYear = 'year_order';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = "month_invoice";
                $selectYear = 'year_invoice';
                break;
            default:
                $selectMonth = "month_default";
                $selectYear = 'year_default';
                break;
        }     
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'document_type_order',
            'document_type_invoice' => 'document_type_invoice',
            'number_order' => 'number_order',
            'date_order' => 'date_order',
            'number_invoice' => 'number_invoice',
            'date_invoice' => 'date_invoice',
            'date_delivery' => 'date_delivery',
            'number_delivery' => 'number_delivery',
            'status_delivery' => 'status_delivery',
            'reason_delivery' => 'reason_delivery',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'quantity_order' => 'quantity_order',
            'unit_value_order' => 'unit_value_order',
            'quantity_invoice' => 'quantity_invoice',
            'unit_value_invoice' => 'unit_value_invoice',
            'quantity_delivery' => 'quantity_delivery',
            'operation_center' => 'operation_center',
            'participation_order' => 'sum(quantity_order*unit_value_order) desc',
            'classification_order' => 'sum(quantity_order*unit_value_order) desc',
            'participation_invoice' => 'sum(quantity_invoice*unit_value_invoice) desc',
            'classification_invoice' => 'sum(quantity_invoice*unit_value_invoice) desc',
            'classification_general' => 'sum(quantity_order*unit_value_order) desc &&'
                .'sum(quantity_invoice*unit_value_invoice) desc',            
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsOrderByGraph($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = "month_order";
                $selectYear = 'year_order';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = "month_invoice";
                $selectYear = 'year_invoice';
                break;
            default:
                $selectMonth = "month_default";
                $selectYear = 'year_default';
                break;
        }     
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'document_type_order',
            'document_type_invoice' => 'document_type_invoice',
            'number_order' => 'number_order',
            'date_order' => 'date_order',
            'number_invoice' => 'number_invoice',
            'date_invoice' => 'date_invoice',
            'date_delivery' => 'date_delivery',
            'number_delivery' => 'number_delivery',
            'status_delivery' => 'status_delivery',
            'reason_delivery' => 'reason_delivery',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'quantity_order' => 'quantity_order',
            'unit_value_order' => 'unit_value_order',
            'quantity_invoice' => 'quantity_invoice',
            'unit_value_invoice' => 'unit_value_invoice',
            'quantity_delivery' => 'quantity_delivery',
            'operation_center' => 'operation_center',
            'participation_order' => 'sum(quantity_order*unit_value_order) desc',
            'classification_order' => 'sum(quantity_order*unit_value_order) desc',
            'participation_invoice' => 'sum(quantity_invoice*unit_value_invoice) desc',
            'classification_invoice' => 'sum(quantity_invoice*unit_value_invoice) desc',
            'classification_general' => 'sum(quantity_order*unit_value_order) desc &&'
                .'sum(quantity_invoice*unit_value_invoice) desc',            
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Combina los parametros y ejecuta el query
     * 
     * @param array $listDefault
     * @param array $params
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _queryExec($listDefault, $params){
        $helperReport = new HelperReport($listDefault);
		$months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 
            'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
        /**
         * No se manejan las funciones de graficas por separado ya que 
         * manejan los mismos filtros y variables 
         */
        $tmpSelect = $helperReport->getListParams($this->_paramsSelect($listDefault));
        if(!isset($tmpSelect['classification_general'])){
            if(!isset($tmpSelect['classification_order']) 
                && !isset($tmpSelect['participation_order'])
                && !isset($tmpSelect['accumulated_order'])
                && !isset($tmpSelect['subtotal_order'])){
                $tmpSelect[] = '0 as subtotal_order';
            }
            if(!isset($tmpSelect['classification_invoice']) 
                    && !isset($tmpSelect['participation_invoice'])
                    && !isset($tmpSelect['accumulated_invoice'])
                    && !isset($tmpSelect['subtotal_invoice'])){
                $tmpSelect[] = '0 as subtotal_invoice';
            }
        } 
        $tmpString = implode('&&', array_unique($tmpSelect));
        $explode = explode('&&', $tmpString);
        $trim = array_map('trim', $explode);
        $select = implode(',', array_unique($trim));
        //----------------------------------------------------------------------
        $tmpGroupBy = $helperReport->getListParams($this->_paramsGroupBy($listDefault));
        $groupBy = 'GROUP BY '.implode(',', array_unique($tmpGroupBy));
        //----------------------------------------------------------------------
        $tmpOrderBy = $helperReport->getListParams($this->_paramsOrderBy($listDefault));
        if(isset($tmpOrderBy['classification_order'])){
            $orderClass['classification_order'] = $tmpOrderBy['classification_order'];
            unset($tmpOrderBy['classification_order']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['participation_order'])){
            $orderClass['participation_order'] = $tmpOrderBy['participation_order'];
            unset($tmpOrderBy['participation_order']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['accumulated_order'])){
            $orderClass['accumulated_order'] = $tmpOrderBy['accumulated_order'];
            unset($tmpOrderBy['accumulated_order']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['classification_invoice'])){
            $orderClass['classification_invoice'] = $tmpOrderBy['classification_invoice'];
            unset($tmpOrderBy['classification_invoice']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['participation_invoice'])){
            $orderClass['participation_invoice'] = $tmpOrderBy['participation_invoice'];
            unset($tmpOrderBy['participation_invoice']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['accumulated_invoice'])){
            $orderClass['accumulated_invoice'] = $tmpOrderBy['accumulated_invoice'];
            unset($tmpOrderBy['accumulated_invoice']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        
        $tmpString = implode('&&', array_unique($tmpOrderBy));
        $explode = explode('&&', $tmpString);
        $trim = array_map('trim', $explode);
        $orderBy = 'ORDER BY '.implode(',', array_unique($trim));
        
        
        $tmpWhere = $tmpDates = [];
        $tmpHaving = [];
        $dateEnd = date('Y-m-d');                
        $dateIn = date('Y-m-d', mktime(0, 0, 0, date('m'), 1, date('Y')));
        $this->load($params);
        //Condiciones where ----------------------------------------------------
        
        if($this->document_type_order != "") 
            $tmpWhere[] = " document_type_order = '$this->document_type_order'";
        if($this->document_type_invoice != "") 
            $tmpWhere[] = " document_type_invoice = '$this->document_type_invoice'";
        if($this->number_order != "") 
            $tmpWhere[] = " number_order LIKE '%$this->number_order%'";
        if($this->date_order != ""){             
            list($dateIn, $dateEnd) = explode(' - ', $this->date_order);
            $tmpWhere[] = " date_order BETWEEN '$dateIn' AND '$dateEnd'";                      
        }else{            
            if($this->month == '' && $this->year == '' 
                    && $this->date_invoice == '' && $this->date_delivery == ""){
                $dateEnd = date('Y-m-d');                
                $dateIn = date('Y-m-d', mktime(0, 0, 0, date('m'), 1, date('Y')));            
                $tmpDates[] = " date_order BETWEEN '$dateIn' AND '$dateEnd'";                      
            }            
        }
        if($this->number_invoice != "") 
            $tmpWhere[] = "number_invoice LIKE '%$this->number_invoice%'";
        if($this->date_invoice != ""){             
            list($dateIn, $dateEnd) = explode(' - ', $this->date_invoice);
            $tmpWhere[] = " date_invoice BETWEEN '$dateIn' AND '$dateEnd'";                      
        }else{            
            if($this->month == '' && $this->year == '' 
                    && $this->date_order == '' && $this->date_delivery == ""){
                $dateEnd = date('Y-m-d');                
                $dateIn = date('Y-m-d', mktime(0, 0, 0, date('m'), 1, date('Y')));            
                $tmpWhere[] = " date_invoice BETWEEN '$dateIn' AND '$dateEnd'";                      
            }            
        }
        if($this->date_delivery != ""){             
            list($dateIn, $dateEnd) = explode(' - ', $this->date_delivery);
            $tmpWhere[] = " date_delivery BETWEEN '$dateIn' AND '$dateEnd'";                      
        }else{            
            if($this->month == '' && $this->year == '' 
                    && $this->date_order == '' && $this->date_invoice == ''){
                $dateEnd = date('Y-m-d');                
                $dateIn = date('Y-m-d', mktime(0, 0, 0, date('m'), 1, date('Y')));            
                $tmpWhere[] = " date_delivery BETWEEN '$dateIn' AND '$dateEnd'";                      
            }            
        }
        if($this->number_delivery != "") 
            $tmpWhere[] = " number_delivery LIKE '%$this->number_delivery%'";
        if($this->status_delivery != "") 
            $tmpWhere[] = " status_delivery = $this->status_delivery";
        if($this->reason_delivery != "") 
            $tmpWhere[] = " reason_delivery LIKE '%$this->reason_delivery%'";
        if($this->nit != "") 
            $tmpWhere[] = " nit LIKE '%$this->nit%'";
        if($this->business_name != "") 
            $tmpWhere[] = " business_name LIKE '%$this->business_name%'";
        if($this->branch_code != "") 
            $tmpWhere[] = " business_name = '$this->branch_code'";
        if($this->branch_name != "") 
            $tmpWhere[] = " branch_name LIKE '%$this->branch_name%'";
        if($this->reference != "") 
            $tmpWhere[] = " reference = '$this->reference'";
        if($this->description != "") 
            $tmpWhere[] = " description LIKE '%$this->description%'";
        if($this->quantity_order != "") 
            $tmpHaving[] = " SUM(quantity_order) = '$this->quantity_order'";
        if($this->unit_value_order != "") 
            $tmpHaving[] = " SUM(unit_value_order) = '$this->unit_value_order'";
        if($this->quantity_invoice != "") 
            $tmpHaving[] = " SUM(quantity_invoice) = '$this->quantity_invoice'";
        if($this->unit_value_invoice != "") 
            $tmpHaving[] = " SUM(unit_value_invoice) = '$this->unit_value_invoice'";
        if($this->quantity_delivery != "") 
            $tmpHaving[] = " SUM(quantity_delivery) = '$this->quantity_delivery'";
        if($this->subtotal_order != "") 
            $tmpHaving[] = " SUM(quantity_order*unit_value_order) = '$this->subtotal_order'";
        if($this->subtotal_invoice != "") 
            $tmpHaving[] = " SUM(quantity_invoice*unit_value_order) = '$this->subtotal_invoice'";
        if($this->operation_center != "") 
            $tmpHaving[] = " operation_center = '$this->operation_center'";       
        if($this->month != "" && !empty($this->month)){
            if(is_array($this->month)){
                $dateIn = date('Y-m-d', mktime(0, 0, 0, (min($this->month)+1), 1, date('Y')));
                $dateEnd = date('Y-m-t', mktime(0, 0, 0, (max($this->month)+1), 1, date('Y')));
                $tempMes = [];
                if(is_array($this->month) && count($this->month)>0){
                    foreach ($this->month as $value){
                       $tempMes[] = $value +1; 
                    }
                    $tmpWhere[] = "month_order IN('"
                            .implode("','",$tempMes)."')";
                }
            }else{
                if($this->year == "" ){
                    $tmpWhere[] = " year_order = ".date('Y');
                }else{
                    $tmpWhere[] = " year_order = ".$this->year;
                }
				$tmpWhere[] = " month_order like '%".$months[$this->month-1]."%'";
				
            }
            
            
        }                                       
        if($this->year != "" && !empty($this->year)){
            $tmpWhere[] = " year_order = ".$this->year; 
            if($this->month == "" ){
                $tmpWhere[] = " month_order = ".date('m');
            }else{
                $tmpWhere[] = " month_order = ".$this->month;
            }
        }
        
        $tmpWhere = array_unique($tmpWhere);
        $where = (count($tmpWhere)>0) ? ' WHERE '.implode(" AND ", $tmpWhere): "";
        $having = (count($tmpHaving)>0) ? ' HAVING '.implode(" AND ", $tmpHaving): "";
        
        $arrayResult = DataFulfillmentClient::getData($select, $where, $groupBy, 
                $orderBy, $having);
//        if(isset($tmpOrderBy['classification_order']) 
//                || isset($tmpOrderBy['participation_order'])
//                || isset($tmpOrderBy['accumulated_order'])
//                || isset($tmpOrderBy['classification_invoice']) 
//                || isset($tmpOrderBy['participation_invoice'])
//                || isset($tmpOrderBy['accumulated_invoice'])){
//            $arrayResult = ReportSiesa::reportFulfillmentClient($select, $where, 
//                $groupBy, $orderBy, $having, $dateIn, $dateEnd, true);
//        }else{
//            $arrayResult = ReportSiesa::reportFulfillmentClient($select, $where, 
//                $groupBy, $orderBy, $having, $dateIn, $dateEnd);
//        }
        
        return $arrayResult;
    }
    
    /**
     * Genera los  resultados dinamicos para el reporte
     * 
     * @param array $listDefault
     * @param array $params
     * @param array $preview
     * 
     * @return \yii\data\ArrayDataProvider
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function reportFulfillment($listDefault, $params, $preview = false) {
        $arrayResult = $this->_queryExec($listDefault, $params);   
        # Validamos si se presentan todos los datos ----------------------------
        $paramShowAll = '_tog';
        $exportAll = 'all';
        $pagination = ['pageSize' => 30];
        foreach ($_GET as $key => $value) {
            if (strpos($key, $paramShowAll) !== false) {
                if ($value == $exportAll) {
                    $pagination = false;
                }
            }
        }        
        # ----------------------------------------------------------------------        
        if($preview){
            $sort = false;
        }else{
            $sort = [ 'attributes' =>explode(',', $listDefault)];
        }        
        # ----------------------------------------------------------------------        
        return new ArrayDataProvider([
            'allModels' => $arrayResult,
            'sort' => $sort,
            'pagination' => $pagination
        ]);
    }
    
    /**
     * Genera los datos para el grafico dinamico
     * 
     * @param type $dataEjex
     * @param type $dataEjey
     * @param type $params
     * 
     * @return \yii\data\ArrayDataProvider
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function reportGraph($dataEjex, $dataEjey, $params, $type) {
        $listDefault = $dataEjex.','.$dataEjey;
        $months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 
            'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
        # ----------------------------------------------------------------------
        $listParams = $this->listParams();
        $result = $this->_queryExec($listDefault, $params); 
      
        # ----------------------------------------------------------------------         
        $groupEjex = explode(',', $dataEjex);
        $keyInit = $groupEjex[0];
        unset($groupEjex[0]);
        if(count($groupEjex)>0){
            $arrayResult = ArrayHelper::index($result, $keyInit, $groupEjex);
        }else{
            $arrayResult = ArrayHelper::index($result, $keyInit);
        } 
        #-----------------------------------------------------------------------
        $data = [];
        $data['x'] = [];
        $data['y'] = [];
        $categories = [];
        
        if(count($arrayResult)>0){ 
            $resultsDataY = [];
            $tempEjeY = explode(',', $dataEjey);
            $helperReport = new HelperReport;
            $helperReport->recursiveWalk($categories, $arrayResult, $resultsDataY, $tempEjeY);
            #-------------------------------------------------------------------
            foreach ($resultsDataY as $key => $value) { 
                switch ($key) {
                    case ('quantity_order'):
                    case ('unit_value_order'):
                    case ('quantity_invoice'):
                    case ('unit_value_invoice'):
                    case ('quantity_delivery'):
                    case ('subtotal_order'):
                    case ('subtotal_invoice'):
                    case ('fulfillment_unit'):
                    case ('fulfillment_references'):
                    case ('fulfillment_time'):
                    case ('fulfillment_order'):
                    case ('fulfillment_money'):
                    case ('fulfillment_total'):
                        $name = 'Suma('.$listParams[$key]['content'].')'; 
                        break;
                    default:
                        $name = 'Cant('.$listParams[$key]['content'].')';                        
                        break;
                }
                $data['y'][] = [
                    'type' => $type,  
                    'name'=>$name, 
                    'data'=> array_column($value, $key)];
            }
        } 
        #-----------------------------------------------------------------------
        $response = [
            'lang' => [
                'downloadJPEG' => 'Descargar en JPG',
                'downloadPDF' => 'Descargar en PDF',
                'downloadPNG' => 'Descargar en PNG',
                'downloadSVG' => 'Descargar en SVG',
                'printChart' => 'Imprimir',
                'resetZoom' => 'Reestablecer',
                'resetZoomTitle' => 'Reestablecer 1:1',
            ],
            'chart' => [
                'renderTo' => 'chart-graficas',   
                'height' => '800',
                'zoomType' => 'xy',      
                'responsive'=>[
                    'rules'=>[
                        'condition'=>[
                            //'maxWidth'=>1200
                        ],
                        'chartOptions'=>[
                            'legend'=>['enabled'=>false]
                        ]
                    ]
                ]
            ],
            'exporting' => [
                //'scale' => '4',   
                //'width' => '900',   
                'sourceWidth' => '1000',   
                //'printMaxWidth' => '1000',   
            ],
            'id' => 'chart-g',
            'title' => ['text' => NULL],            
            'plotOptions' => [
                'column' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],
                    'center' => ['50%', '50%'],                    
                    'enableMouseTracking' => false,                    
                ],               
                'area' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],                    
                ],                                            
                'line' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],                    
                ],                                            
            ],
            'xAxis' => [
                //'title' => ['text' => $listParams[$dataEjex]['content']],
                'labels' => ['rotation' => '-90'],
                'categories' => $categories,               
            ],
            'legend'=>[
                    'layout' => 'vertical',
                    'align' => 'left',
                    'verticalAlign' => 'middle'
            ],
            'yAxis' => [
               'title' => ['text' => '']
            ],
            'series' => $data['y']
        ];
        return json_encode($response, JSON_NUMERIC_CHECK);
    }
    
    /**
     * 
     * @param type $params
     * @return type
     */
    public function clearParams($params)
    {
        $arrayDelete = [
            'accumulated_order',
            'participation_order',
            'classification_order',
            'accumulated_invoice',
            'participation_invoice',
            'classification_invoice',
            'classification_general',
        ];
        foreach ($arrayDelete as $element) {
            unset($params[$element]); 
        }
        return $params;
    }
}
