<?php

namespace app\models;

use Yii;
use yii\helpers\ArrayHelper;
use app\components\ReportSiesa;
use yii\data\ArrayDataProvider;
use app\components\HelperReport;
use kartik\grid\GridView;
use kartik\select2\Select2;
use app\models\BeforeModel;

/**
 * This is the model class for table "report_fulfillment_client".
 *
 * @property integer $id
 * @property string $name
 * @property string $paramsAdd
 * @property string $paramsDefault
 * @property string $filter
 * @property string $ejex
 * @property string $ejey
 * @property string $type
 * @property string $created
 * @property string $created_by
 * @property string $updated
 * @property string $updated_by
 * @property integer $user_id
 *
 * @property CmpUser $user
 */
class Fulfillmentclient extends BeforeModel
{
    public $document_type_order;
    public $document_type_invoice;
    public $number_order;
    public $date_order;
    public $number_invoice;
    public $date_invoice;
    public $number_delivery;
    public $status_delivery;
    public $reason_delivery;
    public $nit;
    public $business_name;
    public $branch_code;
    public $branch_name;
    public $reference;
    public $description;
    public $quantity_order;
    public $unit_value_order;
    public $quantity_invoice;
    public $unit_value_invoice;
    public $quantity_delivery;
    public $subtotal_order;
    public $subtotal_invoice;
    public $operation_center;
    public $fulfillment_unit;
    public $fulfillment_references;
    public $fulfillment_time;
    public $fulfillment_order;
    public $fulfillment_money;
    public $fulfillment_total;
    public $classification_order;
    public $accumulated_order;
    public $participation_order;
    public $classification_invoice;
    public $accumulated_invoice;
    public $participation_invoice;
    public $classification_general;
    public $classification_management;
    public $month;
    public $year;
    
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'report_fulfillment_client';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['name', 'user_id'], 'required', 'on' => ['create', 'update']],
            [['user_id'], 'required', 'on' => ['preview']],
            [['paramsAdd', 'paramsDefault', 'filter', 'ejex', 'ejey'], 'string'],
            //[['created', 'updated'], 'safe'],
            [['user_id'], 'integer'],
            [['name', 'created_by', 'updated_by'], 'string', 'max' => 150],
            [['type'], 'string', 'max' => 50],
            [['user_id'], 'exist', 'skipOnError' => true, 'targetClass' => Cmpuser::className(), 'targetAttribute' => ['user_id' => 'usr_user_ID']],
            [['document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice', 'classification_management',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice','participation_invoice',
                'classification_general','month','year'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'paramsAdd' => Yii::t('app', 'Params Add'),
            'paramsDefault' => Yii::t('app', 'Params Default'),
            'filter' => Yii::t('app', 'Filter'),
            'ejex' => Yii::t('app', 'Ejex'),
            'ejey' => Yii::t('app', 'Ejey'),
            'type' => Yii::t('app', 'Type'),
            'created' => Yii::t('app', 'Created'),
            'created_by' => Yii::t('app', 'Created By'),
            'updated' => Yii::t('app', 'Updated'),
            'updated_by' => Yii::t('app', 'Updated By'),
            'user_id' => Yii::t('app', 'User ID'),
        ];
    }
    
    public function scenarios()
    {
        $scenarios = parent::scenarios();        
        $scenarios['create'] = ['name', 'paramsDefault', 'user_id',
                'document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice',
                'participation_invoice','classification_general','month','year',
                'classification_management'];        
        $scenarios['update'] = ['name', 'paramsDefault', 'user_id',
                'document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice',
                'participation_invoice','classification_general','month','year',
                'classification_management'];        
        $scenarios['preview'] = ['user_id',
                'document_type_order', 'document_type_invoice','number_order',
                'date_order','number_invoice',
                'date_invoice','number_delivery','status_delivery',
                'reason_delivery','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_order',
                'unit_value_order','quantity_invoice','unit_value_invoice',
                'quantity_delivery','subtotal_order','subtotal_invoice',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_order','fulfillment_money',
                'fulfillment_total','classification_order',
                'accumulated_order','participation_order',
                'classification_invoice','accumulated_invoice','participation_invoice',
                'classification_general','month','year','classification_management'];        
        return $scenarios;
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUser()
    {
        return $this->hasOne(Cmpuser::className(), ['usr_user_ID' => 'user_id']);
    }
    
    /**
     * Listado de los parametros por defecto sin espacios
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsDefault() {
        $list = 'nit,business_name,branch_code,branch_name,reference,description';
        return str_replace(' ', '', $list);
    }

    /**
     * Listado de los parametros adicionales sin espacios
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsAdd() {
        $list = 'document_type_order,number_order,date_order,number_invoice,'
                . 'date_invoice,number_delivery,status_delivery,'
                . 'reason_delivery,quantity_order,unit_value_order,'
                . 'quantity_invoice,unit_value_invoice,quantity_delivery,'
                . 'subtotal_order,subtotal_invoice,operation_center,'
                . 'fulfillment_unit,fulfillment_references,fulfillment_time,'
                . 'fulfillment_order,fulfillment_money,fulfillment_total,'
                . 'classification_order,accumulated_order,'
                . 'participation_order,classification_invoice,'
                . 'accumulated_invoice,participation_invoice,classification_general,'
                . 'month,year,classification_management';
        return str_replace(' ', '', $list);
    }
    
    
    /**
     * Lisrados de parametros configurables en el reporte
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParams() {
        return [
            'document_type_order' => ['content' => Yii::t('app', 'Document Type Order')],
            'document_type_invoice' => ['content' => Yii::t('app', 'Document Type Invoice')],
            'number_order' => ['content' => Yii::t('app', 'Number Order')],
            'date_order' => ['content' => Yii::t('app', 'Date Order')],
            'number_invoice' => ['content' => Yii::t('app', 'Number Invoice')],
            'date_invoice' => ['content' => Yii::t('app', 'Date Invoice')],
            'number_delivery' => ['content' => Yii::t('app', 'Number Delivery')],
            'status_delivery' => ['content' => Yii::t('app', 'Status Delivery')],
            'reason_delivery' => ['content' => Yii::t('app', 'Reason Delivery')],
            'nit' => ['content' => Yii::t('app', 'Nit')],
            'business_name' => ['content' => Yii::t('app', 'Business Name')],
            'branch_code' => ['content' => Yii::t('app', 'Branch Code')],
            'branch_name' => ['content' => Yii::t('app', 'Branch Name')],
            'reference' => ['content' => Yii::t('app', 'Reference')],
            'description' => ['content' => Yii::t('app', 'Description')],
            'quantity_order' => ['content' => Yii::t('app', 'Quantity Order')],
            'quantity_invoice' => ['content' => Yii::t('app', 'Quantity Invoice')],
            'quantity_delivery' => ['content' => Yii::t('app', 'Quantity Delivery')],
            'unit_value_order' => ['content' => Yii::t('app', 'Unit Value Order')],
            'unit_value_invoice' => ['content' => Yii::t('app', 'Unit Value Invoice')],
            'subtotal_order' => ['content' => Yii::t('app', 'Subtotal Order')],
            'subtotal_invoice' => ['content' => Yii::t('app', 'Subtotal Invoice')],
            'operation_center' => ['content' => Yii::t('app', 'Operation Center')],
            'fulfillment_unit' => ['content' => Yii::t('app', 'Fulfillment Unit')],
            'fulfillment_references' => ['content' => Yii::t('app', 'Fulfillment References')],
            'fulfillment_time' => ['content' => Yii::t('app', 'Fulfillment Time')],
            'fulfillment_order' => ['content' => Yii::t('app', 'Fulfillment Order')],
            'fulfillment_money' => ['content' => Yii::t('app', 'Fulfillment Money')],
            'fulfillment_total' => ['content' => Yii::t('app', 'Fulfillment Total')],
            'participation_order' => ['content' => Yii::t('app', 'Participation Order')],
            'accumulated_order' => ['content' => Yii::t('app', 'Accumulated Order')],
            'classification_order' => ['content' => Yii::t('app', 'Classification Order')],
            'participation_invoice' => ['content' => Yii::t('app', 'Participation Invoice')],
            'accumulated_invoice' => ['content' => Yii::t('app', 'Accumulated Invoice')],
            'classification_invoice' => ['content' => Yii::t('app', 'Classification Invoice')],
            'classification_general' => ['content' => Yii::t('app', 'Classification General')],
            'classification_management' => ['content' => Yii::t('app', 'Classification Managment')],
            'month' => ['content' => Yii::t('app', 'Month')],
            'year' => ['content' => Yii::t('app', 'Year')],
            'date' => ['content' => Yii::t('app', 'Date')],
        ];
    }
    
    /**
     * Metodo que retorna el listado de las columnas para el grid
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsGrid() {
        # Traemos todos los meses para el filtro -------------------------------
        $months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 
            'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
  
        return [
            'document_type_order' => [
                'attribute' => 'document_type_order',
                'label' => Yii::t('app', 'Document Type Order'),
            ],            
            'document_type_invoice' => [
                'attribute' => 'document_type_invoice',
                'label' => Yii::t('app', 'Document Type Invoice'),
            ],            
            'number_order' => [
                'attribute' => 'number_order',
                'label' => Yii::t('app', 'Number Order'),
            ], 
            'date_order' => [
                'attribute' => 'date_order',
                'label' => Yii::t('app', 'Date Order'),
                'filterType' => GridView::FILTER_DATE_RANGE,
                'filterWidgetOptions' => [
                    'options' => ['placeholder' => 'Rango Fechas', 'readonly'=>true],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'locale'=>[                            
                            'format' => 'DD-MM-YYYY',
                            'separator'=>' - ',
                        ],                        
                    ],
                ],                
                'width' => '200px',
            ],
            'number_invoice' => [
                'attribute' => 'number_invoice',
                'label' => Yii::t('app', 'Number Invoice'),
            ], 
            'date_invoice' => [
                'attribute' => 'date_invoice',
                'label' => Yii::t('app', 'Date Invoice'),
                'filterType' => GridView::FILTER_DATE_RANGE,
                'filterWidgetOptions' => [
                    'options' => ['placeholder' => 'Rango Fechas', 'readonly'=>true],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'locale'=>[                            
                            'format' => 'DD-MM-YYYY',
                            'separator'=>' - ',
                        ],                        
                    ],
                ],                
                'width' => '200px',
            ],
            'number_delivery' => [
                'attribute' => 'number_delivery',
                'label' => Yii::t('app', 'Number Delivery'),
            ],            
            'status_delivery' => [
                'attribute' => 'status_delivery',
                'label' => Yii::t('app', 'Status Delivery'),
            ],            
            'reason_delivery' => [
                'attribute' => 'reason_delivery',
                'label' => Yii::t('app', 'Reason Delivery'),
            ],                     
            'nit' => [
                'attribute' => 'nit',
                'label' => Yii::t('app', 'Nit'),
            ],            
            'business_name' => [
                'attribute' => 'business_name',
                'label' => Yii::t('app', 'Business Name'),
            ],            
            'branch_code' => [
                'attribute' => 'branch_code',
                'label' => Yii::t('app', 'Branch Code'),
            ],            
            'branch_name' => [
                'attribute' => 'branch_name',
                'label' => Yii::t('app', 'Branch Name'),
            ],            
            'reference' => [
                'attribute' => 'reference',
                'label' => Yii::t('app', 'Reference'),
            ],
            'description' => [
                'attribute' => 'description',
                'label' => Yii::t('app', 'Description'),
            ],
            'quantity_order' => [
                'attribute' => 'quantity_order',
                'label' => Yii::t('app', 'Quantity Order'),
                'value' => function($data){
                    return number_format($data['quantity_order']);
                }
            ],
            'unit_value_order' => [
                'attribute' => 'unit_value_order',
                'label' => Yii::t('app', 'Unit Value Order'),
                'value' => function($data){
                    return '$ '.number_format($data['unit_value_order']);
                }
            ],
            'quantity_invoice' => [
                'attribute' => 'quantity_invoice',
                'label' => Yii::t('app', 'Quantity Invoice'),
                'value' => function($data){
                    return number_format($data['quantity_invoice']);
                }
            ],
            'unit_value_invoice' => [
                'attribute' => 'unit_value_invoice',
                'label' => Yii::t('app', 'Unit Value Invoice'),
                'value' => function($data){
                    return '$ '.number_format($data['unit_value_invoice']);
                }
            ],
            'quantity_delivery' => [
                'attribute' => 'quantity_delivery',
                'label' => Yii::t('app', 'Quantity Delivery'),
                'value' => function($data){
                    return number_format($data['quantity_delivery']);
                }
            ],
            'subtotal_order' => [
                'attribute' => 'subtotal_order',
                'label' => Yii::t('app', 'Subtotal Order'),
                'value' => function($data){
                    return '$ '.number_format($data['subtotal_order']);
                }
            ],
            'subtotal_invoice' => [
                'attribute' => 'subtotal_invoice',
                'label' => Yii::t('app', 'Subtotal Invoice'),
                'value' => function($data){
                    return '$ '.number_format($data['subtotal_invoice']);
                }
            ],
            'operation_center' => [
                'attribute' => 'operation_center',
                'label' => Yii::t('app', 'Operation Center'),
            ],
            'fulfillment_unit' => [
                'attribute' => 'fulfillment_unit',
                'label' => Yii::t('app', 'Fulfillment Unit'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_unit'], 2);
                }
            ],
            'fulfillment_references' => [
                'attribute' => 'fulfillment_references',
                'label' => Yii::t('app', 'Fulfillment References'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_references'], 2);
                }
            ],
            'fulfillment_time' => [
                'attribute' => 'fulfillment_time',
                'label' => Yii::t('app', 'Fulfillment Time'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_time'], 2);
                }
            ],
            'fulfillment_order' => [
                'attribute' => 'fulfillment_order',
                'label' => Yii::t('app', 'Fulfillment Order'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_order'], 2);
                },
            ],
            'fulfillment_money' => [
                'attribute' => 'fulfillment_money',
                'label' => Yii::t('app', 'Fulfillment Money'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_money'], 2);
                },
            ],
            'fulfillment_total' => [
                'attribute' => 'fulfillment_total',
                'label' => Yii::t('app', 'Fulfillment Total'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_total'], 2);
                },
            ],
            'classification_management' => [
                'attribute' => 'classification_management',
                'label' => Yii::t('app', 'Classification Managment'),
                'filter'=>false,
                'value' => function($data){
                    return ($data['fulfillment_total'] >= 90 )
                            ? Yii::t('app', 'Trustworthy') : Yii::t('app', 'No Trustworthy');
                },
            ],
            'classification_general' => [
                'attribute' => 'classification_general',
                'filter' => false,
                'label' => Yii::t('app', 'Classification General'),
                'value' => function($data) use (&$genAccClassOrder, 
                        &$genAccClassInvoice){
                    $genAccClassOrder = ($data['subtotal_order']/$data['total_order'])*100+ $genAccClassOrder;
                    $classOrder = ($genAccClassOrder <= 80 )?'A':(($genAccClassOrder <= 95)?'B':'C');
                    
                    $genAccClassInvoice = ($data['subtotal_invoice']/$data['total_invoice'])*100+ $genAccClassInvoice;
                    $classInvoice = ($genAccClassInvoice <= 80 )?'A':(($genAccClassInvoice <= 95)?'B':'C');
                    
                    $classAbc = Classificationabc::findOne(['abc_cost'=>$classOrder, 'abc_margin'=>$classInvoice]);
                    return (isset($classAbc->abc_classification)? $classAbc->abc_classification : null);
                    
                },
            ],
            'classification_order' => [
                'attribute' => 'classification_order',
                'filter' => false,
                'label' => Yii::t('app', 'Classification Order'),
                'value' => function($data) use (&$accClassOrder){
                    $accClassOrder = ($data['subtotal_order']/$data['total_order'])*100+ $accClassOrder;
                    return ($accClassOrder <= 80 )?'A':(($accClassOrder <= 95)?'B':'C');
                },
            ],
            'accumulated_order' => [
                'attribute' => 'accumulated_order',
                'filter' => false,
                'label' => Yii::t('app', 'Accumulated Order'),
                'value' => function($data) use (&$accOrder){
                    $accOrder = ($data['subtotal_order']/$data['total_order'])*100+ $accOrder;
                    return number_format($accOrder,2);
                },
            ],
            'participation_order' => [
                'attribute' => 'participation_order',
                'filter' => false,
                'label' => Yii::t('app', 'Participation Order'),
                'value' => function($data){
                    return number_format(($data['subtotal_order']/$data['total_order'])*100,2);
                },
            ],
            'classification_invoice' => [
                'attribute' => 'classification_invoice',
                'filter' => false,
                'label' => Yii::t('app', 'Classification Invoice'),
                'value' => function($data) use (&$accClassInvoice){
                    $accClassInvoice = ($data['subtotal_invoice']/$data['total_invoice'])*100+ $accClassInvoice;
                    return ($accClassInvoice <= 80 )?'A':(($accClassInvoice <= 95)?'B':'C');
                },
            ],
            'accumulated_invoice' => [
                'attribute' => 'accumulated_invoice',
                'filter' => false,
                'label' => Yii::t('app', 'Accumulated Invoice'),
                'value' => function($data) use (&$accInvoice){
                    $accInvoice = ($data['subtotal_invoice']/$data['total_invoice'])*100+ $accInvoice;
                    return number_format($accInvoice,2);
                },
            ],
            'participation_invoice' => [
                'attribute' => 'participation_invoice',
                'filter' => false,
                'label' => Yii::t('app', 'Participation Invoice'),
                'value' => function($data){
                    return number_format(($data['subtotal_invoice']/$data['total_invoice'])*100,2);
                },
            ],
            'month' =>
            [                
                'attribute' => 'month',
                'label' => Yii::t('app', 'Month'),
                'width' => '150px',
                'filter'=>$months, 
                'filterType'=>  GridView::FILTER_SELECT2,
                'filterWidgetOptions'=>[
                    'options' => ['multiple' => true],
                    'theme' => Select2::THEME_BOOTSTRAP,
                    'pluginOptions'=>['allowClear'=>true,'tags' => true,],
                ],
//                'value' => function($model) use($months){            
//                    return isset($months[$model['month']-1]) ? $months[$model['month']-1] : null;
//                },                                
                'group'=>true, 
                'groupedRow'=>false,
                'subGroupOf'=>'year',
            ],
            'year' => [                
                'attribute' => 'year',
                'label' => Yii::t('app', 'Year'),
                'value' => 'year',                                
                'group'=>true, 
                'groupedRow'=>false,
                'filter'=>array_combine(range(date('Y'), date('Y')-5),range(date('Y'), date('Y')-5))                
            ],
        ];
    }
    
    /**
     * Retorna los parametrso que van en el select del B2BiSiesa
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsSelect($params) {  
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                //$selectMonth = 'MONTH(f430_fecha_ts_cumplido) as month';
                $selectMonth = "DATENAME(M, DATEADD(M, MONTH(f430_fecha_ts_cumplido), -1)) as month";
                $selectYear = 'YEAR(f430_fecha_ts_cumplido) as year';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                //$selectMonth = 'MONTH(f350_fecha) as month';
                $selectMonth = "DATENAME(M, DATEADD(M, MONTH(f350_fecha), -1)) as month";
                $selectYear = 'YEAR(f350_fecha) as year';
                break;
            default:
                //$selectMonth = 'MONTH(f430_fecha_ts_cumplido) as month';
                $selectMonth = "DATENAME(M, DATEADD(M, MONTH(f430_fecha_ts_cumplido), -1)) as month";
                $selectYear = 'YEAR(f430_fecha_ts_cumplido) as year';
                break;
        }  
        $fulfillment_unit = "ISNULL(((SUM(cantidad_entregada)/nullif(SUM(f431_cant1_pedida),0))*100),0)";
        $fulfillment_unit = "(CASE  
                    WHEN ($fulfillment_unit) > 100  THEN 100
                    WHEN ($fulfillment_unit) < 0 THEN 0
                    ELSE ($fulfillment_unit) END)";
        $fulfillment_references = "ISNULL((100 - (CAST(SUM(CASE WHEN f464_ind_estado = '2' THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN f464_ind_estado != '2' THEN 1 ELSE 0 END) AS float),0))*100),0)";
        $fulfillment_references = "(CASE  
                    WHEN $fulfillment_references > 100 THEN 100
                    WHEN $fulfillment_references < 0 THEN 0
                    ELSE $fulfillment_references END)";
        $fulfillment_time = "ISNULL(((CAST(SUM(CASE WHEN f464_fecha_ts_cierre = f350_fecha OR DATEADD(DAY, 1, f350_fecha) = f464_fecha_ts_cierre THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN f464_fecha_ts_cierre = f350_fecha OR DATEADD(DAY, 1, f350_fecha) = f464_fecha_ts_cierre THEN 1 ELSE 0 END) + SUM(CASE WHEN f464_fecha_ts_cierre > DATEADD(DAY, 1, f350_fecha) THEN 1 ELSE 0 END)  AS float),0))*100),0)";
        $fulfillment_time = "(CASE  
                    WHEN $fulfillment_time > 100  THEN 100
                    WHEN $fulfillment_time < 0 THEN 0
                    ELSE $fulfillment_time END)";
        $fulfillment_order = "ISNULL((100 - (CAST(SUM(CASE WHEN cantidad_entregada < f431_cant1_pedida THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN cantidad_entregada = f431_cant1_pedida THEN 1 ELSE 0 END) AS float),0))*100),0)";
        $fulfillment_order = "(CASE  
                    WHEN $fulfillment_order > 100  THEN 100
                    WHEN $fulfillment_order < 0 THEN 0
                    ELSE $fulfillment_order END)";
        $fulfillment_money = "ISNULL(((SUM(f431_precio_unitario_base*f431_cant1_facturada)/nullif(SUM(cantidad_entregada*f431_precio_unitario_base),0))*100),0)";
        $fulfillment_money = "(CASE  
                    WHEN $fulfillment_money > 100  THEN 100
                    WHEN $fulfillment_money < 0 THEN 0
                    ELSE $fulfillment_money END)";
        $fulfillment_total = '(('.$fulfillment_time.' + '.$fulfillment_references.')*0.3)'
                    .'+(('.$fulfillment_unit.'+'.$fulfillment_money.')*0.15)'
                    .'+('.$fulfillment_order.'*0.1)';
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'f430_id_tipo_docto AS document_type_order',
            'document_type_invoice' => 'f350_id_tipo_docto AS document_type_invoice',
            'number_order' => 'f430_consec_docto AS number_order',
            'date_order' => 'f430_fecha_ts_cumplido AS date_order',
            'number_invoice' => 'f350_consec_docto AS number_invoice',
            'date_invoice' => 'f350_fecha AS date_invoice',
            'number_delivery' => 'f463_consec_docto AS number_delivery',
            'status_delivery' => 'f464_ind_estado AS status_delivery',
            'reason_delivery' => 'f464_notas AS reason_delivery',
            'nit' => 'F200_NIT AS nit',
            'business_name' => 'LTRIM(RTRIM(f200_razon_social)) AS business_name',
            'branch_code' => 'LTRIM(RTRIM(f461_id_sucursal_fact)) AS branch_code',
            'branch_name' => 'f201_descripcion_sucursal AS branch_name',
            'reference' => 'LTRIM(RTRIM(f120_referencia)) AS reference',
            'description' => 'LTRIM(RTRIM(f120_descripcion)) AS description',
            'quantity_order' => 'SUM(f431_cant1_pedida) AS quantity_order',
            'unit_value_order' => 'f431_precio_unitario_base AS unit_value_order',
            'quantity_invoice' => 'SUM(f431_cant1_facturada) AS quantity_invoice',
            'unit_value_invoice' => 'f431_precio_unitario_base AS unit_value_invoice',
            'quantity_delivery' => 'SUM(cantidad_entregada) AS quantity_delivery',
            'subtotal_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'subtotal_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'operation_center' => 'f460_id_co_docto as operation_center',
//            'fulfillment_unit' => '(SUM(cantidad_entregada)/nullif(SUM(f431_cant1_pedida),0))*100 AS fulfillment_unit',
//            'fulfillment_references' => "100 - (CAST(SUM(CASE WHEN f464_ind_estado = '2' THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN f464_ind_estado != '2' THEN 1 ELSE 0 END) AS float),0))*100 as fulfillment_references",
//            'fulfillment_time' => 'ISNULL(100 - (CAST(SUM(CASE WHEN DATEADD(DAY, 1, f350_fecha) < f463_fecha THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN DATEADD(DAY, 1, f350_fecha) >= f463_fecha THEN 1 ELSE 0 END) AS float),0))*100, 0) as fulfillment_time',
//            'fulfillment_order' => "100 - (CAST(SUM(CASE WHEN cantidad_entregada < f431_cant1_pedida THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN cantidad_entregada = f431_cant1_pedida THEN 1 ELSE 0 END) AS float),0))*100 as fulfillment_order",
//            'fulfillment_money' => '(SUM(f431_precio_unitario_base*f431_cant1_facturada)/nullif(SUM(cantidad_entregada*f431_precio_unitario_base),0))*100 AS fulfillment_money',
            'fulfillment_unit' => "$fulfillment_unit AS fulfillment_unit",
            'fulfillment_references' => "$fulfillment_references AS fulfillment_references",
            'fulfillment_time' => "$fulfillment_time AS fulfillment_time",
            'fulfillment_order' => "$fulfillment_order as fulfillment_order",
            'fulfillment_money' => "$fulfillment_money AS fulfillment_money",
            'fulfillment_total' => "$fulfillment_total AS fulfillment_total",
            'classification_management' => "$fulfillment_total AS fulfillment_total",
            'accumulated_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'participation_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'classification_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'accumulated_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'participation_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'classification_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'classification_general' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order &&'
                .'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametrso que van en el select del B2BiSiesa
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsSelectGraph($params) {                
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                //$selectMonth = 'MONTH(f430_fecha_ts_cumplido) as month';
                $selectMonth = "DATENAME(M, DATEADD(M, MONTH(f430_fecha_ts_cumplido), -1)) as month";
                $selectYear = 'YEAR(f430_fecha_ts_cumplido) as year';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                //$selectMonth = 'MONTH(f350_fecha) as month';
                $selectMonth = "DATENAME(M, DATEADD(M, MONTH(f350_fecha), -1)) as month";
                $selectYear = 'YEAR(f350_fecha) as year';
                break;
            default:
                //$selectMonth = 'MONTH(f430_fecha_ts_cumplido) as month';
                $selectMonth = "DATENAME(M, DATEADD(M, MONTH(f430_fecha_ts_cumplido), -1)) as month";
                $selectYear = 'YEAR(f430_fecha_ts_cumplido) as year';
                break;
        }  
        $fulfillment_unit = "ISNULL(((SUM(cantidad_entregada)/nullif(SUM(f431_cant1_pedida),0))*100),0)";
        $fulfillment_unit = "(CASE  
                    WHEN ($fulfillment_unit) > 100  THEN 100
                    WHEN ($fulfillment_unit) < 0 THEN 0
                    ELSE ($fulfillment_unit) END)";
        $fulfillment_references = "ISNULL((100 - (CAST(SUM(CASE WHEN f464_ind_estado = '2' THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN f464_ind_estado != '2' THEN 1 ELSE 0 END) AS float),0))*100),0)";
        $fulfillment_references = "(CASE  
                    WHEN $fulfillment_references > 100 THEN 100
                    WHEN $fulfillment_references < 0 THEN 0
                    ELSE $fulfillment_references END)";
        $fulfillment_time = "ISNULL(((CAST(SUM(CASE WHEN f464_fecha_ts_cierre = f350_fecha OR DATEADD(DAY, 1, f350_fecha) = f464_fecha_ts_cierre THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN f464_fecha_ts_cierre = f350_fecha OR DATEADD(DAY, 1, f350_fecha) = f464_fecha_ts_cierre THEN 1 ELSE 0 END) + SUM(CASE WHEN f464_fecha_ts_cierre > DATEADD(DAY, 1, f350_fecha) THEN 1 ELSE 0 END)  AS float),0))*100),0)";
        $fulfillment_time = "(CASE  
                    WHEN $fulfillment_time > 100  THEN 100
                    WHEN $fulfillment_time < 0 THEN 0
                    ELSE $fulfillment_time END)";
        $fulfillment_order = "ISNULL((100 - (CAST(SUM(CASE WHEN cantidad_entregada < f431_cant1_pedida THEN 1 ELSE 0 END) AS float) / nullif(CAST(SUM(CASE WHEN cantidad_entregada = f431_cant1_pedida THEN 1 ELSE 0 END) AS float),0))*100),0)";
        $fulfillment_order = "(CASE  
                    WHEN $fulfillment_order > 100  THEN 100
                    WHEN $fulfillment_order < 0 THEN 0
                    ELSE $fulfillment_order END)";
        $fulfillment_money = "ISNULL(((SUM(f431_precio_unitario_base*f431_cant1_facturada)/nullif(SUM(cantidad_entregada*f431_precio_unitario_base),0))*100),0)";
        $fulfillment_money = "(CASE  
                    WHEN $fulfillment_money > 100  THEN 100
                    WHEN $fulfillment_money < 0 THEN 0
                    ELSE $fulfillment_money END)";
        $fulfillment_total = '(('.$fulfillment_time.' + '.$fulfillment_references.')*0.3)'
                    .'+(('.$fulfillment_unit.'+'.$fulfillment_money.')*0.15)'
                    .'+('.$fulfillment_order.'*0.1)';
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'f430_id_tipo_docto AS document_type_order',
            'document_type_invoice' => 'f350_id_tipo_docto AS document_type_invoice',
            'number_order' => 'f430_consec_docto AS number_order',
            'date_order' => 'f430_fecha_ts_cumplido AS date_order',
            'number_invoice' => 'f350_consec_docto AS number_invoice',
            'date_invoice' => 'f350_fecha AS date_invoice',
            'number_delivery' => 'f463_consec_docto AS number_delivery',
            'status_delivery' => 'f464_ind_estado AS status_delivery',
            'reason_delivery' => 'f464_notas AS reason_delivery',
            'nit' => 'LTRIM(RTRIM(F200_NIT)) AS nit',
            'business_name' => 'LTRIM(RTRIM(f200_razon_social)) AS business_name',
            'branch_code' => 'f461_id_sucursal_fact AS branch_code',
            'branch_name' => 'f201_descripcion_sucursal AS branch_name',
            'reference' => 'f120_referencia AS reference',
            'description' => 'f120_descripcion AS description',
            'quantity_order' => 'SUM(f431_cant1_pedida) AS quantity_order',
            'unit_value_order' => 'f431_precio_unitario_base AS unit_value_order',
            'quantity_invoice' => 'SUM(f431_cant1_facturada) AS quantity_invoice',
            'unit_value_invoice' => 'f431_vlr_bruto AS unit_value_invoice',
            'quantity_delivery' => 'SUM(cantidad_entregada) AS quantity_delivery',
            'subtotal_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'subtotal_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'operation_center' => 'f460_id_co_docto as operation_center',
            'fulfillment_unit' => "$fulfillment_unit AS fulfillment_unit",
            'fulfillment_references' => "$fulfillment_references AS fulfillment_references",
            'fulfillment_time' => "$fulfillment_time AS fulfillment_time",
            'fulfillment_order' => "$fulfillment_order as fulfillment_order",
            'fulfillment_money' => "$fulfillment_money AS fulfillment_money",
            'fulfillment_total' => "$fulfillment_total AS fulfillment_total",
            'classification_management' => "$fulfillment_total AS fulfillment_total",
            'accumulated_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'participation_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'classification_order' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order',
            'accumulated_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'participation_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'classification_invoice' => 'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'classification_general' => 'SUM(f431_cant1_pedida*f431_precio_unitario_base) AS subtotal_order &&'
                .'SUM(f431_precio_unitario_base*f431_cant1_facturada) AS subtotal_invoice',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsGroupBy($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = 'MONTH(f350_fecha)';
                $selectYear = 'YEAR(f350_fecha)';
                break;
            default:
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'f430_id_tipo_docto',
            'document_type_invoice' => 'f350_id_tipo_docto',
            'number_order' => 'f430_consec_docto',
            'date_order' => 'f430_fecha_ts_cumplido',
            'number_invoice' => 'f350_consec_docto',
            'date_invoice' => 'f350_fecha',
            'number_delivery' => 'f463_consec_docto',
            'status_delivery' => 'f464_ind_estado',
            'reason_delivery' => 'f464_notas',
            'nit' => 'F200_NIT',
            'business_name' => 'f200_razon_social',
            'branch_code' => 'f461_id_sucursal_fact',
            'branch_name' => 'f201_descripcion_sucursal',
            'reference' => 'f120_referencia',
            'description' => 'f120_descripcion',
            'quantity_order' => 'f431_cant1_pedida',
            'unit_value_order' => 'f431_precio_unitario_base',
            'quantity_invoice' => 'f431_cant1_facturada',
            'unit_value_invoice' => 'f431_vlr_bruto',
            'quantity_delivery' => 'cantidad_entregada',
            'operation_center' => 'f460_id_co_docto',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsGroupByGraph($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = 'MONTH(f350_fecha)';
                $selectYear = 'YEAR(f350_fecha)';
                break;
            default:
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'f430_id_tipo_docto',
            'document_type_invoice' => 'f350_id_tipo_docto',
            'number_order' => 'f430_consec_docto',
            'date_order' => 'f430_fecha_ts_cumplido',
            'number_invoice' => 'f350_consec_docto',
            'date_invoice' => 'f350_fecha',
            'number_delivery' => 'f463_consec_docto',
            'status_delivery' => 'f464_ind_estado',
            'reason_delivery' => 'f464_notas',
            'nit' => 'F200_NIT',
            'business_name' => 'f200_razon_social',
            'branch_code' => 'f461_id_sucursal_fact',
            'branch_name' => 'f201_descripcion_sucursal',
            'reference' => 'f120_referencia',
            'description' => 'f120_descripcion',
            'quantity_order' => 'f431_cant1_pedida',
            'unit_value_order' => 'f431_precio_unitario_base',
            'quantity_invoice' => 'f431_cant1_facturada',
            'unit_value_invoice' => 'f431_vlr_bruto',
            'quantity_delivery' => 'cantidad_entregada',
            'operation_center' => 'f460_id_co_docto',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsOrderBy($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = 'MONTH(f350_fecha)';
                $selectYear = 'YEAR(f350_fecha)';
                break;
            default:
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'f430_id_tipo_docto',
            'document_type_invoice' => 'f350_id_tipo_docto',
            'number_order' => 'f430_consec_docto',
            'date_order' => 'f430_fecha_ts_cumplido',
            'number_invoice' => 'f350_consec_docto',
            'date_invoice' => 'f350_fecha',
            'number_delivery' => 'f463_consec_docto',
            'status_delivery' => 'f464_ind_estado',
            'reason_delivery' => 'f464_notas',
            'nit' => 'F200_NIT',
            'business_name' => 'f200_razon_social',
            'branch_code' => 'f461_id_sucursal_fact',
            'branch_name' => 'f201_descripcion_sucursal',
            'reference' => 'f120_referencia',
            'description' => 'f120_descripcion',
            'quantity_order' => 'f431_cant1_pedida',
            'unit_value_order' => 'f431_precio_unitario_base',
            'quantity_invoice' => 'f431_cant1_facturada',
            'unit_value_invoice' => 'f431_vlr_bruto',
            'quantity_delivery' => 'cantidad_entregada',
            'operation_center' => 'f460_id_co_docto',
            'participation_order' => 'sum(f431_cant1_pedida*f431_precio_unitario_base) desc',
            'classification_order' => 'sum(f431_cant1_pedida*f431_precio_unitario_base) desc',
            'participation_invoice' => 'sum(f431_precio_unitario_base*f431_cant1_facturada) desc',
            'classification_invoice' => 'sum(f431_precio_unitario_base*f431_cant1_facturada) desc',
            'classification_general' => 'sum(f431_cant1_pedida*f431_precio_unitario_base) desc &&'
                .'sum(f431_precio_unitario_base*f431_cant1_facturada) desc',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsOrderByGraph($params) {
        switch ($params) {
            case (strpos($params, 'date_order') !== false) :
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
            case (strpos($params, 'date_invoice') !== false) :
                $selectMonth = 'MONTH(f350_fecha)';
                $selectYear = 'YEAR(f350_fecha)';
                break;
            default:
                $selectMonth = 'MONTH(f430_fecha_ts_cumplido)';
                $selectYear = 'YEAR(f430_fecha_ts_cumplido)';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_order' => 'f430_id_tipo_docto',
            'document_type_invoice' => 'f350_id_tipo_docto',
            'number_order' => 'f430_consec_docto',
            'date_order' => 'f430_fecha_ts_cumplido',
            'number_invoice' => 'f350_consec_docto',
            'date_invoice' => 'f350_fecha',
            'number_delivery' => 'f463_consec_docto',
            'status_delivery' => 'f464_ind_estado',
            'reason_delivery' => 'f464_notas',
            'nit' => 'F200_NIT',
            'business_name' => 'f200_razon_social',
            'branch_code' => 'f461_id_sucursal_fact',
            'branch_name' => 'f201_descripcion_sucursal',
            'reference' => 'f120_referencia',
            'description' => 'f120_descripcion',
            'quantity_order' => 'f431_cant1_pedida',
            'unit_value_order' => 'f431_precio_unitario_base',
            'quantity_invoice' => 'f431_cant1_facturada',
            'unit_value_invoice' => 'f431_vlr_bruto',
            'quantity_delivery' => 'cantidad_entregada',
            'operation_center' => 'f460_id_co_docto',
            'participation_order' => 'sum(f431_cant1_pedida*f431_precio_unitario_base) desc',
            'classification_order' => 'sum(f431_cant1_pedida*f431_precio_unitario_base) desc',
            'participation_invoice' => 'sum(f431_precio_unitario_base*f431_cant1_facturada) desc',
            'classification_invoice' => 'sum(f431_precio_unitario_base*f431_cant1_facturada) desc',
            'classification_general' => 'sum(f431_cant1_pedida*f431_precio_unitario_base) desc &&'
                .'sum(f431_precio_unitario_base*f431_cant1_facturada) desc',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Combina los parametros y ejecuta el query
     * 
     * @param array $listDefault
     * @param array $params
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _queryExec($listDefault, $params){
        $helperReport = new HelperReport($listDefault);
        /**
         * No se manejan las funciones de graficas por separado ya que 
         * manejan los mismos filtros y variables 
         */
        $tmpSelect = $helperReport->getListParams($this->_paramsSelect($listDefault));
        if(!isset($tmpSelect['classification_general'])){
            if(!isset($tmpSelect['classification_order']) 
                && !isset($tmpSelect['participation_order'])
                && !isset($tmpSelect['accumulated_order'])
                && !isset($tmpSelect['subtotal_order'])){
                $tmpSelect[] = '0 as subtotal_order';
            }
            if(!isset($tmpSelect['classification_invoice']) 
                    && !isset($tmpSelect['participation_invoice'])
                    && !isset($tmpSelect['accumulated_invoice'])
                    && !isset($tmpSelect['subtotal_invoice'])){
                $tmpSelect[] = '0 as subtotal_invoice';
            }
        } 
        $tmpString = implode('&&', array_unique($tmpSelect));
        $explode = explode('&&', $tmpString);
        $trim = array_map('trim', $explode);
        $select = implode(',', array_unique($trim));
        //----------------------------------------------------------------------
        $tmpGroupBy = $helperReport->getListParams($this->_paramsGroupBy($listDefault));
        $groupBy = 'GROUP BY '.implode(',', array_unique($tmpGroupBy));
        //----------------------------------------------------------------------
        $tmpOrderBy = $helperReport->getListParams($this->_paramsOrderBy($listDefault));
        if(isset($tmpOrderBy['classification_order'])){
            $orderClass['classification_order'] = $tmpOrderBy['classification_order'];
            unset($tmpOrderBy['classification_order']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['participation_order'])){
            $orderClass['participation_order'] = $tmpOrderBy['participation_order'];
            unset($tmpOrderBy['participation_order']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['accumulated_order'])){
            $orderClass['accumulated_order'] = $tmpOrderBy['accumulated_order'];
            unset($tmpOrderBy['accumulated_order']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['classification_invoice'])){
            $orderClass['classification_invoice'] = $tmpOrderBy['classification_invoice'];
            unset($tmpOrderBy['classification_invoice']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['participation_invoice'])){
            $orderClass['participation_invoice'] = $tmpOrderBy['participation_invoice'];
            unset($tmpOrderBy['participation_invoice']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['accumulated_invoice'])){
            $orderClass['accumulated_invoice'] = $tmpOrderBy['accumulated_invoice'];
            unset($tmpOrderBy['accumulated_invoice']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        
        $tmpString = implode('&&', array_unique($tmpOrderBy));
        $explode = explode('&&', $tmpString);
        $trim = array_map('trim', $explode);
        $orderBy = 'ORDER BY '.implode(',', array_unique($trim));
        
        
        $tmpWhere = [];
        $tmpHaving = [];
        $dateEnd = date('d-m-Y');                
        $dateIn = date('d-m-Y', mktime(0, 0, 0, date('m'), 1, date('Y')));
        $this->load($params);
        //Condiciones where ----------------------------------------------------
        $tmpWhere[] = "f200_ind_cliente = 1";
        $tmpWhere[] = "f200_ind_estado = 1";
        //$tmpWhere[] = "f201_ind_estado_activo = 1";
        
        if($this->document_type_order != "") 
            $tmpWhere[] = "f430_id_tipo_docto = '$this->document_type_order'";
        if($this->document_type_invoice != "") 
            $tmpWhere[] = "f350_id_tipo_docto = '$this->document_type_invoice'";
        if($this->number_order != "") 
            $tmpWhere[] = "f430_consec_docto LIKE '%$this->number_order%'";
        if($this->date_order != ""){             
            list($dateIn, $dateEnd) = explode(' - ', $this->date_order);
            $tmpWhere[] = "f430_fecha_ts_cumplido BETWEEN '$dateIn' AND '$dateEnd'";                      
        }else{            
            if($this->month == '' && $this->year == '' 
                    && $this->date_invoice == ''){
                $dateEnd = date('d-m-Y');                
                $dateIn = date('d-m-Y', mktime(0, 0, 0, date('m'), 1, date('Y')));            
                $tmpWhere[] = "f430_fecha_ts_cumplido BETWEEN '$dateIn' AND '$dateEnd'";                      
            }            
        }
        if($this->number_invoice != "") 
            $tmpWhere[] = "f350_consec_docto LIKE '%$this->number_invoice%'";
        if($this->date_invoice != ""){             
            list($dateIn, $dateEnd) = explode(' - ', $this->date_invoice);
            $tmpWhere[] = " f350_fecha BETWEEN '$dateIn' AND '$dateEnd'";                      
        }else{            
            if($this->month == '' && $this->year == '' 
                    && $this->date_order == ''){
                $dateEnd = date('d-m-Y');                
                $dateIn = date('d-m-Y', mktime(0, 0, 0, date('m'), 1, date('Y')));            
                $tmpWhere[] = " f350_fecha BETWEEN '$dateIn' AND '$dateEnd'";                      
            }            
        }
        if($this->number_delivery != "") 
            $tmpWhere[] = " f463_consec_docto LIKE '%$this->number_delivery%'";
        if($this->status_delivery != "") 
            $tmpWhere[] = " f464_ind_estado = $this->status_delivery";
        if($this->reason_delivery != "") 
            $tmpWhere[] = " f464_notas LIKE '%$this->reason_delivery%'";
        if($this->nit != "") 
            $tmpWhere[] = " F200_NIT LIKE '%$this->nit%'";
        if($this->business_name != "") 
            $tmpWhere[] = " f200_razon_social LIKE '%$this->business_name%'";
        if($this->branch_code != "") 
            $tmpWhere[] = " f461_id_sucursal_fact = '$this->branch_code'";
        if($this->branch_name != "") 
            $tmpWhere[] = " f201_descripcion_sucursal LIKE '%$this->branch_name%'";
        if($this->reference != "") 
            $tmpWhere[] = " f120_referencia = '$this->reference'";
        if($this->description != "") 
            $tmpWhere[] = " f120_descripcion LIKE '%$this->description%'";
        if($this->quantity_order != "") 
            $tmpHaving[] = " SUM(f431_cant1_pedida) = '$this->quantity_order'";
        if($this->unit_value_order != "") 
            $tmpHaving[] = " SUM(f431_precio_unitario_base) = '$this->unit_value_order'";
        if($this->quantity_invoice != "") 
            $tmpHaving[] = " SUM(f431_cant1_facturada) = '$this->quantity_invoice'";
        if($this->unit_value_invoice != "") 
            $tmpHaving[] = " SUM(f431_vlr_bruto) = '$this->unit_value_invoice'";
        if($this->quantity_delivery != "") 
            $tmpHaving[] = " SUM(cantidad_entregada) = '$this->quantity_delivery'";
        if($this->subtotal_order != "") 
            $tmpHaving[] = " SUM(f431_cant1_pedida*f431_precio_unitario_base) = '$this->subtotal_order'";
        if($this->subtotal_invoice != "") 
            $tmpHaving[] = " SUM(f431_precio_unitario_base*f431_cant1_facturada) = '$this->subtotal_invoice'";
        if($this->operation_center != "") 
            $tmpHaving[] = " f460_id_co_docto = '$this->operation_center'";       
        if($this->month != "" && !empty($this->month)){
            $dateIn = date('d-m-Y', mktime(0, 0, 0, (min($this->month)+1), 1, date('Y')));
            $dateEnd = date('t-m-Y', mktime(0, 0, 0, (max($this->month)+1), 1, date('Y')));
            $tempMes = [];
            if(is_array($this->month) && count($this->month)>0){
                foreach ($this->month as $value){
                   $tempMes[] = $value +1; 
                }
                $tmpWhere[] = "CONVERT(VARCHAR,MONTH(f430_fecha_ts_cumplido)) IN('"
                        .implode("','",$tempMes)."')";
            }                                       
        }                                       
        if($this->year != "" && !empty($this->year)){
            $dateIn = date('d-m-Y', mktime(0, 0, 0, 1, 1, $this->year));
            $dateEnd = date('t-m-Y', mktime(0, 0, 0, 12, 31, $this->year));
            $tempAnio = explode(',', $this->year); 
            $tmpWhere[] = "CONVERT(VARCHAR,YEAR(f430_fecha_ts_cumplido)) IN('"
                    .implode("','",$tempAnio)."')"; 
        }
         
        $where = (count($tmpWhere)>0) ? 'WHERE '.implode(" AND ", $tmpWhere): "";
        $having = (count($tmpHaving)>0) ? 'HAVING '.implode(" AND ", $tmpHaving): "";
        if(isset($tmpOrderBy['classification_order']) 
                || isset($tmpOrderBy['participation_order'])
                || isset($tmpOrderBy['accumulated_order'])
                || isset($tmpOrderBy['classification_invoice']) 
                || isset($tmpOrderBy['participation_invoice'])
                || isset($tmpOrderBy['accumulated_invoice'])){
            $arrayResult = ReportSiesa::reportFulfillmentClient($select, $where, 
                $groupBy, $orderBy, $having, $dateIn, $dateEnd, true);
        }else{
            $arrayResult = ReportSiesa::reportFulfillmentClient($select, $where, 
                $groupBy, $orderBy, $having, $dateIn, $dateEnd);
        }
        
        return $arrayResult;
    }
    
    /**
     * Genera los  resultados dinamicos para el reporte
     * 
     * @param array $listDefault
     * @param array $params
     * @param array $preview
     * 
     * @return \yii\data\ArrayDataProvider
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function reportFulfillment($listDefault, $params, $preview = false) {
        $arrayResult = $this->_queryExec($listDefault, $params);   
        # Validamos si se presentan todos los datos ----------------------------
        $paramShowAll = '_tog';
        $exportAll = 'all';
        $pagination = ['pageSize' => 30];
        foreach ($_GET as $key => $value) {
            if (strpos($key, $paramShowAll) !== false) {
                if ($value == $exportAll) {
                    $pagination = false;
                }
            }
        }        
        # ----------------------------------------------------------------------        
        if($preview){
            $sort = false;
        }else{
            $sort = [ 'attributes' =>explode(',', $listDefault)];
        }        
        # ----------------------------------------------------------------------        
        return new ArrayDataProvider([
            'allModels' => $arrayResult,
            'sort' => $sort,
            'pagination' => $pagination
        ]);
    }
    
    /**
     * Genera los datos para el grafico dinamico
     * 
     * @param type $dataEjex
     * @param type $dataEjey
     * @param type $params
     * 
     * @return \yii\data\ArrayDataProvider
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function reportGraph($dataEjex, $dataEjey, $params, $type) {
        $listDefault = $dataEjex.','.$dataEjey;
        $months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 
            'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
        # ----------------------------------------------------------------------
        $listParams = $this->listParams();
        $result = $this->_queryExec($listDefault, $params); 
        # ----------------------------------------------------------------------         
        $groupEjex = explode(',', $dataEjex);
        $keyInit = $groupEjex[0];
        unset($groupEjex[0]);
        if(count($groupEjex)>0){
            $arrayResult = ArrayHelper::index($result, $keyInit, $groupEjex);
        }else{
            $arrayResult = ArrayHelper::index($result, $keyInit);
        } 
        #-----------------------------------------------------------------------
        $data = [];
        $data['x'] = [];
        $data['y'] = [];
        $categories = [];
        
        if(count($arrayResult)>0){ 
            $resultsDataY = [];
            $tempEjeY = explode(',', $dataEjey);
            $helperReport = new HelperReport;
            $helperReport->recursiveWalk($categories, $arrayResult, $resultsDataY, $tempEjeY);
            #-------------------------------------------------------------------
            foreach ($resultsDataY as $key => $value) { 
                switch ($key) {
                    case ('quantity_order'):
                    case ('unit_value_order'):
                    case ('quantity_invoice'):
                    case ('unit_value_invoice'):
                    case ('quantity_delivery'):
                    case ('subtotal_order'):
                    case ('subtotal_invoice'):
                    case ('fulfillment_unit'):
                    case ('fulfillment_references'):
                    case ('fulfillment_time'):
                    case ('fulfillment_order'):
                    case ('fulfillment_money'):
                    case ('fulfillment_total'):
                        $name = 'Suma('.$listParams[$key]['content'].')'; 
                        break;
                    default:
                        $name = 'Cant('.$listParams[$key]['content'].')';                        
                        break;
                }
                $data['y'][] = [
                    'type' => $type,  
                    'name'=>$name, 
                    'data'=> array_column($value, $key)];
            }
        } 
        #-----------------------------------------------------------------------
        $response = [
            'lang' => [
                'downloadJPEG' => 'Descargar en JPG',
                'downloadPDF' => 'Descargar en PDF',
                'downloadPNG' => 'Descargar en PNG',
                'downloadSVG' => 'Descargar en SVG',
                'printChart' => 'Imprimir',
                'resetZoom' => 'Reestablecer',
                'resetZoomTitle' => 'Reestablecer 1:1',
            ],
            'chart' => [
                'renderTo' => 'chart-graficas',   
                'height' => '800',
                'zoomType' => 'xy',      
                'responsive'=>[
                    'rules'=>[
                        'condition'=>[
                            //'maxWidth'=>1200
                        ],
                        'chartOptions'=>[
                            'legend'=>['enabled'=>false]
                        ]
                    ]
                ]
            ],
            'exporting' => [
                //'scale' => '4',   
                //'width' => '900',   
                'sourceWidth' => '1000',   
                //'printMaxWidth' => '1000',   
            ],
            'id' => 'chart-g',
            'title' => ['text' => NULL],            
            'plotOptions' => [
                'column' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],
                    'center' => ['50%', '50%'],                    
                    'enableMouseTracking' => false,                    
                ],               
                'area' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],                    
                ],                                            
                'line' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],                    
                ],                                            
            ],
            'xAxis' => [
                //'title' => ['text' => $listParams[$dataEjex]['content']],
                'labels' => ['rotation' => '-90'],
                'categories' => $categories,               
            ],
            'legend'=>[
                    'layout' => 'vertical',
                    'align' => 'left',
                    'verticalAlign' => 'middle'
            ],
            'yAxis' => [
               'title' => ['text' => '']
            ],
            'series' => $data['y']
        ];
        return json_encode($response, JSON_NUMERIC_CHECK);
    }
    
    /**
     * 
     * @param type $params
     * @return type
     */
    public function clearParams($params)
    {
        $arrayDelete = [
            'accumulated_order',
            'participation_order',
            'classification_order',
            'accumulated_invoice',
            'participation_invoice',
            'classification_invoice',
            'classification_general',
        ];
        foreach ($arrayDelete as $element) {
            unset($params[$element]); 
        }
        return $params;
    }
}
