<?php

namespace app\models;

use Yii;
use yii\helpers\ArrayHelper;
use app\components\ReportSiesa;
use yii\data\ArrayDataProvider;
use app\components\HelperReport;
use kartik\grid\GridView;
use kartik\select2\Select2;
use app\models\Classificationabc;
use app\components\Util;

/**
 * This is the model class for table "report_fulfillment_client".
 *
 * @property integer $id
 * @property string $name
 * @property string $paramsAdd
 * @property string $paramsDefault
 * @property string $filter
 * @property string $ejex
 * @property string $ejey
 * @property string $type
 * @property string $created
 * @property string $created_by
 * @property string $updated
 * @property string $updated_by
 * @property integer $user_id
 *
 * @property Cmpuser $user
 */
class Fulfillmentprovider extends \yii\db\ActiveRecord
{
    public $document_type_purchase;
    public $document_type_entry;
    public $number_purchase;
    public $date_purchase;
    public $number_entry;
    public $date_entry;
    public $status_purchase;
    public $nit;
    public $business_name;
    public $branch_code;
    public $branch_name;
    public $reference;
    public $description;
    public $quantity_purchase;
    public $unit_value_purchase;
    public $quantity_entry;
    public $unit_value_entry;
    public $subtotal_purchase;
    public $subtotal_entry;
    public $operation_center;
    public $fulfillment_unit;
    public $fulfillment_references;
    public $fulfillment_time;
    public $fulfillment_purchase;
    public $fulfillment_money;
    public $fulfillment_total;
    public $classification_purchase;
    public $accumulated_purchase;
    public $participation_purchase;
    public $classification_entry;
    public $accumulated_entry;
    public $participation_entry;
    public $classification_general;
    public $classification_management;
    public $month;
    public $year;
    
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'report_fulfillment_provider';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['name', 'user_id'], 'required', 'on' => ['create', 'update']],
            [['user_id'], 'required', 'on' => ['preview']],
            [['paramsAdd', 'paramsDefault', 'filter', 'ejex', 'ejey'], 'string'],
            //[['created', 'updated'], 'safe'],
            [['user_id', 'year'], 'integer'],
            [['name', 'created_by', 'updated_by'], 'string', 'max' => 150],
            [['type'], 'string', 'max' => 50],
            [['user_id'], 'exist', 'skipOnError' => true, 'targetClass' => Cmpuser::className(), 'targetAttribute' => ['user_id' => 'usr_user_ID']],
            [['document_type_purchase', 'document_type_entry','number_purchase',
                'date_purchase','number_entry',
                'date_entry','status_purchase','nit','business_name','branch_code',
                'branch_name','reference','description','quantity_purchase',
                'unit_value_purchase','quantity_entry','unit_value_entry',
                'subtotal_purchase','subtotal_entry','participation_purchase',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_purchase','fulfillment_money',
                'fulfillment_total','classification_purchase','month','year',
                'accumulated_purchase','classification_entry',
                'accumulated_entry','participation_entry',
                'classification_general','classification_management'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'paramsAdd' => Yii::t('app', 'Params Add'),
            'paramsDefault' => Yii::t('app', 'Params Default'),
            'filter' => Yii::t('app', 'Filter'),
            'ejex' => Yii::t('app', 'Ejex'),
            'ejey' => Yii::t('app', 'Ejey'),
            'type' => Yii::t('app', 'Type'),
            'created' => Yii::t('app', 'Cretaed'),
            'created_by' => Yii::t('app', 'Created By'),
            'updated' => Yii::t('app', 'Updated'),
            'updated_by' => Yii::t('app', 'Updated By'),
            'user_id' => Yii::t('app', 'User ID'),
        ];
    }
    
    public function scenarios()
    {
        $scenarios = parent::scenarios();        
        $scenarios['create'] = ['name', 'paramsDefault', 'user_id',
                'document_type_purchase', 'document_type_entry','number_purchase',
                'date_purchase','number_entry','classification_general',
                'date_entry','status_purchase','classification_entry',
                'accumulated_entry','participation_entry',
                'nit','business_name','branch_code','accumulated_purchase',
                'branch_name','reference','description','quantity_purchase',
                'unit_value_purchase','quantity_entry','unit_value_entry',
                'subtotal_purchase','subtotal_entry','participation_purchase',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_purchase','fulfillment_money',
                'fulfillment_total','classification_purchase','month','year',
                'classification_management'];        
        $scenarios['update'] = ['name', 'paramsDefault', 'user_id',
                'document_type_purchase', 'document_type_entry','number_purchase',
                'date_purchase','number_entry','classification_entry',
                'accumulated_entry','participation_entry','classification_general',
                'date_entry','status_purchase','accumulated_purchase',
                'nit','business_name','branch_code','participation_purchase',
                'branch_name','reference','description','quantity_purchase',
                'unit_value_purchase','quantity_entry','unit_value_entry',
                'subtotal_purchase','subtotal_entry','classification_management',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_purchase','fulfillment_money',
                'fulfillment_total','classification_purchase','month','year'];        
        $scenarios['preview'] = ['user_id',
                'document_type_purchase', 'document_type_entry','number_purchase',
                'date_purchase','number_entry','classification_entry',
                'accumulated_entry','participation_entry','classification_general',
                'date_entry','status_purchase','accumulated_purchase',
                'nit','business_name','branch_code','participation_purchase',
                'branch_name','reference','description','quantity_purchase',
                'unit_value_purchase','quantity_entry','unit_value_entry',
                'subtotal_purchase','subtotal_entry','classification_management',
                'operation_center','fulfillment_unit','fulfillment_references',
                'fulfillment_time','fulfillment_purchase','fulfillment_money',
                'fulfillment_total','classification_purchase','month','year'];        
        return $scenarios;
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUser()
    {
        return $this->hasOne(Cmpuser::className(), ['usr_user_ID' => 'user_id']);
    }
    
    /**
     * Listado de los parametros por defecto sin espacios
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsDefault() {
        $list = 'nit,business_name,branch_code,branch_name,reference,description';
        return str_replace(' ', '', $list);
    }

    /**
     * Listado de los parametros adicionales sin espacios
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsAdd() {
        $list = 'document_type_purchase,number_purchase,date_purchase,number_entry,'
                . 'date_entry,status_purchase,'
                . 'quantity_purchase,unit_value_purchase,'
                . 'quantity_entry,unit_value_entry,'
                . 'subtotal_purchase,subtotal_entry,operation_center,'
                . 'fulfillment_unit,fulfillment_references,fulfillment_time,'
                . 'fulfillment_purchase,fulfillment_money,fulfillment_total,'
                . 'participation_purchase,accumulated_purchase,'
                . 'classification_purchase,classification_entry,'
                . 'accumulated_entry,participation_entry,classification_general,'
                . 'month,year,classification_management';
        return str_replace(' ', '', $list);
    }
    
    
    /**
     * Lisrados de parametros configurables en el reporte
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParams() {
        return [
            'document_type_purchase' => ['content' => Yii::t('app', 'Document Type Purchase')],
            'document_type_entry' => ['content' => Yii::t('app', 'Document Type Entry')],
            'number_purchase' => ['content' => Yii::t('app', 'Number Purchase')],
            'date_purchase' => ['content' => Yii::t('app', 'Date Purchase')],
            'number_entry' => ['content' => Yii::t('app', 'Number Entry')],
            'date_entry' => ['content' => Yii::t('app', 'Date Entry')],
            'status_purchase' => ['content' => Yii::t('app', 'Status Purchase')],
            'nit' => ['content' => Yii::t('app', 'Nit')],
            'business_name' => ['content' => Yii::t('app', 'Business Name')],
            'branch_code' => ['content' => Yii::t('app', 'Branch Code')],
            'branch_name' => ['content' => Yii::t('app', 'Branch Name')],
            'reference' => ['content' => Yii::t('app', 'Reference')],
            'description' => ['content' => Yii::t('app', 'Description')],
            'quantity_purchase' => ['content' => Yii::t('app', 'Quantity Purchase')],
            'quantity_entry' => ['content' => Yii::t('app', 'Quantity Entry')],
            'unit_value_purchase' => ['content' => Yii::t('app', 'Unit Value Purchase')],
            'unit_value_entry' => ['content' => Yii::t('app', 'Unit Value Entry')],
            'subtotal_purchase' => ['content' => Yii::t('app', 'Subtotal Purchase')],
            'subtotal_entry' => ['content' => Yii::t('app', 'Subtotal Entry')],
            'operation_center' => ['content' => Yii::t('app', 'Operation Center')],
            'fulfillment_unit' => ['content' => Yii::t('app', 'Fulfillment Unit')],
            'fulfillment_references' => ['content' => Yii::t('app', 'Fulfillment References')],
            'fulfillment_time' => ['content' => Yii::t('app', 'Fulfillment Time')],
            'fulfillment_purchase' => ['content' => Yii::t('app', 'Fulfillment Purchase')],
            'fulfillment_money' => ['content' => Yii::t('app', 'Fulfillment Money')],
            'fulfillment_total' => ['content' => Yii::t('app', 'Fulfillment Total')],
            'participation_purchase' => ['content' => Yii::t('app', 'Participation Purchase')],
            'accumulated_purchase' => ['content' => Yii::t('app', 'Accumulated Purchase')],
            'classification_purchase' => ['content' => Yii::t('app', 'Classification Purchase')],
            'participation_entry' => ['content' => Yii::t('app', 'Participation Entry')],
            'accumulated_entry' => ['content' => Yii::t('app', 'Accumulated Entry')],
            'classification_entry' => ['content' => Yii::t('app', 'Classification Entry')],
            'classification_general' => ['content' => Yii::t('app', 'Classification General')],
            'classification_management' => ['content' => Yii::t('app', 'Classification Managment')],
            'month' => ['content' => Yii::t('app', 'Month')],
            'year' => ['content' => Yii::t('app', 'Year')],
            'date' => ['content' => Yii::t('app', 'Date')],
        ];
    }
    
    /**
     * Metodo que retorna el listado de las columnas para el grid
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function listParamsGrid() {
        # Traemos todos los meses para el filtro -------------------------------
        $months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 
            'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
        $accClassPurchase = $accPurchase = 0;
        $accClassEntry = $accEntry = 0;
        $genAccClassPurchase = $genAccPurchase = 0;
        $genAccClassEntry = $genAccEntry = 0;
        return [
            'document_type_purchase' => [
                'attribute' => 'document_type_purchase',
                'label' => Yii::t('app', 'Document Type Purchase'),
            ],            
            'document_type_entry' => [
                'attribute' => 'document_type_entry',
                'label' => Yii::t('app', 'Document Type Entry'),
            ],            
            'number_purchase' => [
                'attribute' => 'number_purchase',
                'label' => Yii::t('app', 'Number Purchase'),
            ], 
            'date_purchase' => [
                'attribute' => 'date_purchase',
                'label' => Yii::t('app', 'Date Purchase'),
                'filterType' => GridView::FILTER_DATE_RANGE,
                'filterWidgetOptions' => [
                    'options' => ['placeholder' => 'Rango Fechas', 'readonly'=>true],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'locale'=>[                            
                            'format' => 'DD-MM-YYYY',
                            'separator'=>' - ',
                        ],                        
                    ],
                ],                
                'width' => '200px',
            ],
            'number_entry' => [
                'attribute' => 'number_entry',
                'label' => Yii::t('app', 'Number Entry'),
            ], 
            'date_entry' => [
                'attribute' => 'date_entry',
                'label' => Yii::t('app', 'Date Entry'),
                'filterType' => GridView::FILTER_DATE_RANGE,
                'filterWidgetOptions' => [
                    'options' => ['placeholder' => 'Rango Fechas', 'readonly'=>true],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'locale'=>[                            
                            'format' => 'DD-MM-YYYY',
                            'separator'=>' - ',
                        ],                        
                    ],
                ],                
                'width' => '200px',
            ],           
            'status_purchase' => [
                'attribute' => 'status_purchase',
                'label' => Yii::t('app', 'Status Purchase'),
            ],                                 
            'nit' => [
                'attribute' => 'nit',
                'label' => Yii::t('app', 'Nit'),
            ],            
            'business_name' => [
                'attribute' => 'business_name',
                'label' => Yii::t('app', 'Business Name'),
            ],            
            'branch_code' => [
                'attribute' => 'branch_code',
                'label' => Yii::t('app', 'Branch Code'),
            ],            
            'branch_name' => [
                'attribute' => 'branch_name',
                'label' => Yii::t('app', 'Branch Name'),
            ],            
            'reference' => [
                'attribute' => 'reference',
                'label' => Yii::t('app', 'Reference'),
            ],
            'description' => [
                'attribute' => 'description',
                'label' => Yii::t('app', 'Description'),
            ],
            'quantity_purchase' => [
                'attribute' => 'quantity_purchase',
                'label' => Yii::t('app', 'Quantity Purchase'),
                'value' => function($data){
                    return number_format($data['quantity_purchase']);
                }
            ],
            'unit_value_purchase' => [
                'attribute' => 'unit_value_purchase',
                'label' => Yii::t('app', 'Unit Value Purchase'),
                'value' => function($data){
                    return '$ '.number_format($data['unit_value_entry']);
                }
            ],
            'quantity_entry' => [
                'attribute' => 'quantity_entry',
                'label' => Yii::t('app', 'Quantity Entry'),
                'value' => function($data){
                    return number_format($data['quantity_entry']);
                }
            ],
            'unit_value_entry' => [
                'attribute' => 'unit_value_entry',
                'label' => Yii::t('app', 'Unit Value Entry'),
                'value' => function($data){
                    return '$ '.number_format($data['unit_value_entry']);
                }
            ],
            'subtotal_purchase' => [
                'attribute' => 'subtotal_purchase',
                'label' => Yii::t('app', 'Subtotal Purchase'),
                'value' => function($data){
                    return '$ '.number_format($data['subtotal_purchase']);
                }
            ],
            'subtotal_entry' => [
                'attribute' => 'subtotal_entry',
                'label' => Yii::t('app', 'Subtotal Entry'),
                'value' => function($data){
                    return '$ '.number_format($data['subtotal_entry']);
                }
            ],
            'operation_center' => [
                'attribute' => 'operation_center',
                'label' => Yii::t('app', 'Operation Center'),
            ],
            'fulfillment_unit' => [
                'attribute' => 'fulfillment_unit',
                'label' => Yii::t('app', 'Fulfillment Unit'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_unit'], 2);
                }
            ],
            'fulfillment_references' => [
                'attribute' => 'fulfillment_references',
                'label' => Yii::t('app', 'Fulfillment References'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_references'], 2);
                }
            ],
            'fulfillment_time' => [
                'attribute' => 'fulfillment_time',
                'label' => Yii::t('app', 'Fulfillment Time'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_time'], 2);
                }
            ],
            'fulfillment_purchase' => [
                'attribute' => 'fulfillment_purchase',
                'label' => Yii::t('app', 'Fulfillment Purchase'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_purchase'], 2);
                },
            ],
            'fulfillment_money' => [
                'attribute' => 'fulfillment_money',
                'label' => Yii::t('app', 'Fulfillment Money'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_money'], 2);
                },
            ],
            'fulfillment_total' => [
                'attribute' => 'fulfillment_total',
                'label' => Yii::t('app', 'Fulfillment Total'),
                'filter' => false,
                'value' => function($data){
                    return '% '.number_format($data['fulfillment_total'], 2);
                },
            ],
            'classification_management' => [
                'attribute' => 'classification_management',
                'label' => Yii::t('app', 'Classification Managment'),
                'filter'=>false,
                'value' => function($data){
                    return ($data['fulfillment_total'] >= 90 )? Yii::t('app', 'Trustworthy') 
                            :(($data['fulfillment_total'] < 90 && $data['fulfillment_total'] >= 70)
                            ? Yii::t('app', 'To develop') : Yii::t('app', 'No Trustworthy'));
                },
            ],
            'classification_general' => [
                'attribute' => 'classification_general',
                'filter' => false,
                'label' => Yii::t('app', 'Classification General'),
                'value' => function($data) use (&$genAccClassPurchase, 
                        &$genAccClassEntry){
                    $genAccClassPurchase = ($data['subtotal_purchase']/$data['total_purchase'])*100+ $genAccClassPurchase;
                    $classPurchase = ($genAccClassPurchase <= 80 )?'A':(($genAccClassPurchase <= 95)?'B':'C');
                    
                    $genAccClassEntry = ($data['subtotal_entry']/$data['total_entry'])*100+ $genAccClassEntry;
                    $classEntry = ($genAccClassEntry <= 80 )?'A':(($genAccClassEntry <= 95)?'B':'C');
                    
                    $classAbc = Classificationabc::findOne(['abc_cost'=>$classPurchase, 'abc_margin'=>$classEntry]);
                    return (isset($classAbc->abc_classification)? $classAbc->abc_classification : null);
                    
                },
            ],
            'classification_purchase' => [
                'attribute' => 'classification_purchase',
                'filter' => false,
                'label' => Yii::t('app', 'Classification Purchase'),
                'value' => function($data) use (&$accClassPurchase){
                    $accClassPurchase = ($data['subtotal_purchase']/$data['total_purchase'])*100+ $accClassPurchase;
                    return ($accClassPurchase <= 80 )?'A':(($accClassPurchase <= 95)?'B':'C');
                },
            ],
            'accumulated_purchase' => [
                'attribute' => 'accumulated_purchase',
                'filter' => false,
                'label' => Yii::t('app', 'Accumulated Purchase'),
                'value' => function($data) use (&$accPurchase){
                    $accPurchase = ($data['subtotal_purchase']/$data['total_purchase'])*100+ $accPurchase;
                    return number_format($accPurchase,2);
                },
            ],
            'participation_purchase' => [
                'attribute' => 'participation_purchase',
                'filter' => false,
                'label' => Yii::t('app', 'Participation Purchase'),
                'value' => function($data){
                    return number_format(($data['subtotal_purchase']/$data['total_purchase'])*100,2);
                },
            ],
            'classification_entry' => [
                'attribute' => 'classification_entry',
                'filter' => false,
                'label' => Yii::t('app', 'Classification Entry'),
                'value' => function($data) use (&$accClassEntry){
                    $accClassEntry = ($data['subtotal_entry']/$data['total_entry'])*100+ $accClassEntry;
                    return ($accClassEntry <= 80 )?'A':(($accClassEntry <= 95)?'B':'C');
                },
            ],
            'accumulated_entry' => [
                'attribute' => 'accumulated_entry',
                'filter' => false,
                'label' => Yii::t('app', 'Accumulated Entry'),
                'value' => function($data) use (&$accEntry){
                    $accEntry = ($data['subtotal_entry']/$data['total_entry'])*100+ $accEntry;
                    return number_format($accEntry,2);
                },
            ],
            'participation_entry' => [
                'attribute' => 'participation_entry',
                'filter' => false,
                'label' => Yii::t('app', 'Participation Entry'),
                'value' => function($data){
                    return number_format(($data['subtotal_entry']/$data['total_entry'])*100,2);
                },
            ],
            'month' => [                
                'attribute' => 'month',
                'label' => Yii::t('app', 'Month'),
                'width' => '150px',
                'filter'=>$months, 
                'filterType'=>  GridView::FILTER_SELECT2,
                'filterWidgetOptions'=>[
                    'options' => ['multiple' => true],
                    'theme' => Select2::THEME_BOOTSTRAP,
                    'pluginOptions'=>['allowClear'=>true,'tags' => true,],
                ],
//                'value' => function($model) use($months){            
//                    return isset($months[$model['month']-1]) ? $months[$model['month']-1] : null;
//                },                                
                'group'=>true, 
                'groupedRow'=>false,
                'subGroupOf'=>'year',
            ],
            'year' => [                
                'attribute' => 'year',
                'label' => Yii::t('app', 'Year'),
                'value' => 'year',                                
                'group'=>true, 
                'groupedRow'=>false,  
                'filter'=>array_combine(range(date('Y'), date('Y')-5),range(date('Y'), date('Y')-5))
            ],
        ];
    }
    
    /**
     * Retorna los parametrso que van en el select del B2BiSiesa
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsSelect($params) {  
        switch ($params) {
            case (strpos($params, 'date_entry') !== false) :
                $selectMonth = 'month_entry as month';
                $selectYear = 'year_entry as year';
                break;
            default:
                $selectMonth = 'month_purchase as month';
                $selectYear = 'year_purchase as year';
                break;
        } 
        $fulfillment_unit = 'IFNULL(((SUM(quantity_entry)/IFNULL(SUM(quantity_purchase),0))*100),0)';
        $fulfillment_unit = "(CASE  
                    WHEN ($fulfillment_unit) > 100  THEN 100
                    WHEN ($fulfillment_unit) < 0 THEN 0
                    ELSE ($fulfillment_unit) END)";
        $fulfillment_references = "(CASE WHEN (SUM(CASE WHEN quantity_purchase <> quantity_entry THEN 1 ELSE 0 END) = SUM(total_ref_inc) AND SUM(quantity_entry) = 0) THEN 0 ELSE IFNULL(100-(CAST(SUM(CASE WHEN quantity_purchase <> quantity_entry THEN 1 ELSE 0 END)AS decimal(15,2)) / total_references)*100,0) END)";
        $fulfillment_references = "(CASE  
                    WHEN $fulfillment_references > 100 THEN 100
                    WHEN $fulfillment_references < 0 THEN 0
                    ELSE $fulfillment_references END)";
        $fulfillment_time = 'IFNULL(((CAST(SUM(CASE WHEN date_entry <= DATE_ADD(date_purchase, INTERVAL IFNULL(time_delivery,1) DAY) THEN 1 ELSE 0 END) AS decimal(15,2)) / IFNULL(CAST(SUM(CASE WHEN date_entry <= DATE_ADD(date_purchase, INTERVAL IFNULL(time_delivery,1) DAY) THEN 1 ELSE 0 END) +  SUM(CASE WHEN date_entry > DATE_ADD(date_purchase, INTERVAL IFNULL(time_delivery,1) DAY)  THEN 1 ELSE 0 END)   AS decimal(15,2)),0))*100),0)';
        $fulfillment_time = "(CASE  
                    WHEN $fulfillment_time > 100  THEN 100
                    WHEN $fulfillment_time < 0 THEN 0
                    ELSE $fulfillment_time END)";
        $fulfillment_purchase = "IFNULL((100 - (CAST(SUM(CASE WHEN quantity_purchase < quantity_entry THEN 1 ELSE 0 END) AS decimal(15,2)) / IFNULL(CAST(SUM(CASE WHEN quantity_entry = quantity_purchase THEN 1 ELSE 0 END) AS decimal(15,2)),0))*100),0)";
        $fulfillment_purchase = "(CASE  
                    WHEN $fulfillment_purchase > 100  THEN 100
                    WHEN $fulfillment_purchase < 0 THEN 0
                    ELSE $fulfillment_purchase END)";
        $fulfillment_money = "IFNULL((CAST(SUM(subtotal_entry) AS decimal(15,2)) / CAST(IFNULL(SUM(subtotal_purchase),0) AS decimal(15,2)))*100,0)";
        $fulfillment_money = "(CASE  
                    WHEN $fulfillment_money > 100  THEN 100
                    WHEN $fulfillment_money < 0 THEN 0
                    ELSE $fulfillment_money END)";
        $fulfillment_total = '(('.$fulfillment_time.' + '.$fulfillment_references.')*0.3)'
                    .'+(('.$fulfillment_unit.'+'.$fulfillment_money.')*0.15)'
                    .'+('.$fulfillment_purchase.'*0.1)';
        # ----------------------------------------------------------------------
        return [
            'document_type_purchase' => 'document_type_purchase',
            'document_type_entry' => 'document_type_entry',
            'number_purchase' => 'number_purchase',
            'date_purchase' => 'date_purchase',
            'number_entry' => 'number_entry',
            'date_entry' => 'date_entry',
            'status_purchase' => 'status_purchase',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'quantity_purchase' => 'quantity_purchase',
            'unit_value_purchase' => 'unit_value_purchase',
            'quantity_entry' => 'quantity_entry',
            'unit_value_entry' => 'unit_value_entry',
            'subtotal_purchase' => 'subtotal_purchase',
            'subtotal_entry' => 'subtotal_entry',
            'operation_center' => 'operation_center',
            'fulfillment_unit' => "$fulfillment_unit AS fulfillment_unit",
            'fulfillment_references' => "$fulfillment_references AS fulfillment_references",
            'fulfillment_time' => "$fulfillment_time AS fulfillment_time",
            'fulfillment_purchase' => "$fulfillment_purchase as fulfillment_purchase",
            'fulfillment_money' => "$fulfillment_money AS fulfillment_money",
            'fulfillment_total' => "$fulfillment_total AS fulfillment_total",
            'classification_management' => "$fulfillment_total AS fulfillment_total",
            'accumulated_purchase' => 'subtotal_purchase && total_purchase',
            'participation_purchase' => 'subtotal_purchase && total_purchase',
            'classification_purchase' => 'subtotal_purchase && total_purchase',
            'accumulated_entry' => 'subtotal_entry && total_entry',
            'participation_entry' => 'subtotal_entry && total_entry',
            'classification_entry' => 'subtotal_entry && total_entry',
            'classification_general' => 'subtotal_entry && total_entry && subtotal_entry && total_entry',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametrso que van en el select del B2BiSiesa
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsSelectGraph($params) {                
        switch ($params) {
            case (strpos($params, 'date_entry') !== false) :
                $selectMonth = 'month_entry as month';
                $selectYear = 'year_entryn as year';
                break;
            default:
                $selectMonth = 'month_purchase as month';
                $selectYear = 'year_purchase as year';
                break;
        } 
        $fulfillment_unit = 'IFNULL(((SUM(quantity_entry)/IFNULL(SUM(quantity_purchase),0))*100),0)';
        $fulfillment_unit = "(CASE  
                    WHEN ($fulfillment_unit) > 100  THEN 100
                    WHEN ($fulfillment_unit) < 0 THEN 0
                    ELSE ($fulfillment_unit) END)";
        $fulfillment_references = "(CASE WHEN (SUM(CASE WHEN quantity_purchase <> quantity_entry THEN 1 ELSE 0 END) = SUM(total_ref_inc) AND SUM(quantity_entry) = 0) THEN 0 ELSE IFNULL(100-(CAST(SUM(CASE WHEN quantity_purchase <> quantity_entry THEN 1 ELSE 0 END)AS decimal(15,2)) / total_references)*100,0) END)";
        $fulfillment_references = "(CASE  
                    WHEN $fulfillment_references > 100 THEN 100
                    WHEN $fulfillment_references < 0 THEN 0
                    ELSE $fulfillment_references END)";
        $fulfillment_time = 'IFNULL(((CAST(SUM(CASE WHEN date_entry <= DATE_ADD(date_purchase, INTERVAL IFNULL(time_delivery,1) DAY) THEN 1 ELSE 0 END) AS decimal(15,2)) / IFNULL(CAST(SUM(CASE WHEN date_entry <= DATE_ADD(date_purchase, INTERVAL IFNULL(time_delivery,1) DAY) THEN 1 ELSE 0 END) +  SUM(CASE WHEN date_entry > DATE_ADD(date_purchase, INTERVAL IFNULL(time_delivery,1) DAY)  THEN 1 ELSE 0 END)   AS decimal(15,2)),0))*100),0)';
        $fulfillment_time = "(CASE  
                    WHEN $fulfillment_time > 100  THEN 100
                    WHEN $fulfillment_time < 0 THEN 0
                    ELSE $fulfillment_time END)";
        $fulfillment_purchase = "IFNULL((100 - (CAST(SUM(CASE WHEN quantity_purchase < quantity_entry THEN 1 ELSE 0 END) AS decimal(15,2)) / IFNULL(CAST(SUM(CASE WHEN quantity_entry = quantity_purchase THEN 1 ELSE 0 END) AS decimal(15,2)),0))*100),0)";
        $fulfillment_purchase = "(CASE  
                    WHEN $fulfillment_purchase > 100  THEN 100
                    WHEN $fulfillment_purchase < 0 THEN 0
                    ELSE $fulfillment_purchase END)";
        $fulfillment_money = "IFNULL((CAST(SUM(subtotal_entry) AS decimal(15,2)) / CAST(IFNULL(SUM(subtotal_purchase),0) AS decimal(15,2)))*100,0)";
        $fulfillment_money = "(CASE  
                    WHEN $fulfillment_money > 100  THEN 100
                    WHEN $fulfillment_money < 0 THEN 0
                    ELSE $fulfillment_money END)";
        $fulfillment_total = '(('.$fulfillment_time.' + '.$fulfillment_references.')*0.3)'
                    .'+(('.$fulfillment_unit.'+'.$fulfillment_money.')*0.15)'
                    .'+('.$fulfillment_purchase.'*0.1)';
        # ----------------------------------------------------------------------
        return [
            'document_type_purchase' => 'document_type_purchase',
            'document_type_entry' => 'document_type_entry',
            'number_purchase' => 'number_purchase',
            'date_purchase' => 'date_purchase',
            'number_entry' => 'number_entry',
            'date_entry' => 'date_entry',
            'status_purchase' => 'status_purchase',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'quantity_purchase' => 'quantity_purchase',
            'unit_value_purchase' => 'unit_value_purchase',
            'quantity_entry' => 'quantity_entry',
            'unit_value_entry' => 'unit_value_entry',
            'subtotal_purchase' => 'subtotal_purchase',
            'subtotal_entry' => 'subtotal_entry',
            'operation_center' => 'operation_center',
            'fulfillment_unit' => "$fulfillment_unit AS fulfillment_unit",
            'fulfillment_references' => "$fulfillment_references AS fulfillment_references",
            'fulfillment_time' => "$fulfillment_time AS fulfillment_time",
            'fulfillment_purchase' => "$fulfillment_purchase as fulfillment_purchase",
            'fulfillment_money' => "$fulfillment_money AS fulfillment_money",
            'fulfillment_total' => "$fulfillment_total AS fulfillment_total",
            'classification_management' => "$fulfillment_total AS fulfillment_total",
            'accumulated_purchase' => 'subtotal_purchase && total_purchase',
            'participation_purchase' => 'subtotal_purchase && total_purchase',
            'classification_purchase' => 'subtotal_purchase && total_purchase',
            'accumulated_entry' => 'subtotal_entry && total_entry',
            'participation_entry' => 'subtotal_entry && total_entry',
            'classification_entry' => 'subtotal_entry && total_entry',
            'classification_general' => 'subtotal_entry && total_entry && subtotal_entry && total_entry',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsGroupBy($params) {
        switch ($params) {
            case (strpos($params, 'date_purchase') !== false) :
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
            case (strpos($params, 'date_entry') !== false) :
                $selectMonth = 'month_entry';
                $selectYear = 'year_entry';
                break;
            default:
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_purchase' => 'document_type_purchase',
            'document_type_entry' => 'document_type_entry',
            'number_purchase' => 'number_purchase',
            'date_purchase' => 'date_purchase',
            'number_entry' => 'number_entry',
            'date_entry' => 'date_entry',
            'status_purchase' => 'status_purchase',
            'nit' => 'nit',
            'time_delivery' => 'time_delivery',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'operation_center' => 'operation_center',
            'quantity_purchase' => 'quantity_purchase',
            'unit_value_purchase' => 'unit_value_purchase',
            'quantity_entry' => 'quantity_entry',
            'unit_value_entry' => 'unit_value_entry',
            'fulfillment_references' => 'total_references',
            'fulfillment_money' => 'total_unit_value_purchase',
            'fulfillment_total' => 'total_references',
            'classification_management' => 'total_references',
            'accumulated_purchase' => 'subtotal_purchase,total_purchase',
            'participation_purchase' => 'subtotal_purchase,total_purchase',
            'classification_purchase' => 'subtotal_purchase,total_purchase',
            'accumulated_entry' => 'subtotal_entry,total_entry',
            'participation_entry' => 'subtotal_entry,total_entry',
            'classification_entry' => 'subtotal_entry,total_entry',
            'classification_general' => 'subtotal_entry,total_entry,subtotal_entry,total_entry',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsGroupByGraph($params) {
        switch ($params) {
            case (strpos($params, 'date_purchase') !== false) :
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
            case (strpos($params, 'date_entry') !== false) :
                $selectMonth = 'month_entry';
                $selectYear = 'year_entry';
                break;
            default:
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_purchase' => 'document_type_purchase',
            'document_type_entry' => 'document_type_entry',
            'number_purchase' => 'number_purchase',
            'date_purchase' => 'date_purchase',
            'number_entry' => 'number_entry',
            'date_entry' => 'date_entry',
            'status_purchase' => 'status_purchase',
            'nit' => 'nit',
            'time_delivery' => 'time_delivery',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'operation_center' => 'operation_center',
            'quantity_purchase' => 'quantity_purchase',
            'unit_value_purchase' => 'unit_value_purchase',
            'quantity_entry' => 'quantity_entry',
            'unit_value_entry' => 'unit_value_entry',
            'fulfillment_references' => 'total_references',
            'fulfillment_money' => 'total_unit_value_purchase',
            'fulfillment_total' => 'total_references',
            'classification_management' => 'total_references',
            'accumulated_purchase' => 'subtotal_purchase,total_purchase',
            'participation_purchase' => 'subtotal_purchase,total_purchase',
            'classification_purchase' => 'subtotal_purchase,total_purchase',
            'accumulated_entry' => 'subtotal_entry,total_entry',
            'participation_entry' => 'subtotal_entry,total_entry',
            'classification_entry' => 'subtotal_entry,total_entry',
            'classification_general' => 'subtotal_entry,total_entry,subtotal_entry,total_entry',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsOrderBy($params) {
        switch ($params) {
            case (strpos($params, 'date_purchase') !== false) :
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
            case (strpos($params, 'date_entry') !== false) :
                $selectMonth = 'month_entry';
                $selectYear = 'year_entry';
                break;
            default:
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
        }    
        # ----------------------------------------------------------------------
        return [
            'document_type_purchase' => 'document_type_purchase',
            'document_type_entry' => 'document_type_entry',
            'number_purchase' => 'number_purchase',
            'date_purchase' => 'date_purchase',
            'number_entry' => 'number_entry',
            'date_entry' => 'date_entry',
            'status_purchase' => 'status_purchase',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'operation_center' => 'operation_center',
            'participation_purchase' => 'sum(quantity_purchase*unit_value_purchase) desc',
            'classification_purchase' => 'sum(quantity_purchase*unit_value_purchase) desc',
            'participation_entry' => 'sum(quantity_entry*unit_value_entry) desc',
            'classification_entry' => 'sum(quantity_entry*unit_value_entry) desc',
            'classification_general' => 'sum(quantity_purchase*unit_value_purchase) desc &&'
                .'sum(quantity_entry*unit_value_entry) desc',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Retorna los parametros que van el el Group By de B2BiSiesa
     * 
     * @return type
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _paramsOrderByGraph($params) {
        switch ($params) {
            case (strpos($params, 'date_purchase') !== false) :
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
            case (strpos($params, 'date_entry') !== false) :
                $selectMonth = 'month_entry';
                $selectYear = 'year_entry';
                break;
            default:
                $selectMonth = 'month_purchase';
                $selectYear = 'year_purchase';
                break;
        }     
        # ----------------------------------------------------------------------
        return [
            'document_type_purchase' => 'document_type_purchase',
            'document_type_entry' => 'document_type_entry',
            'number_purchase' => 'number_purchase',
            'date_purchase' => 'date_purchase',
            'number_entry' => 'number_entry',
            'date_entry' => 'date_entry',
            'status_purchase' => 'status_purchase',
            'nit' => 'nit',
            'business_name' => 'business_name',
            'branch_code' => 'branch_code',
            'branch_name' => 'branch_name',
            'reference' => 'reference',
            'description' => 'description',
            'operation_center' => 'operation_center',
            'participation_purchase' => 'sum(quantity_purchase*unit_value_purchase) desc',
            'classification_purchase' => 'sum(quantity_purchase*unit_value_purchase) desc',
            'participation_entry' => 'sum(quantity_entry*unit_value_entry) desc',
            'classification_entry' => 'sum(quantity_entry*unit_value_entry) desc',
            'classification_general' => 'sum(quantity_purchase*unit_value_purchase) desc &&'
                .'sum(quantity_entry*unit_value_entry) desc',
            'year' => $selectYear,
            'month' => $selectMonth,
        ];
    }
    
    /**
     * Combina los parametros y ejecuta el query
     * 
     * @param array $listDefault
     * @param array $params
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _queryExec($listDefault, $params){
        $helperReport = new HelperReport($listDefault);
        /**
         * No se manejan las funciones de graficas por separado ya que 
         * manejan los mismos filtros y variables 
         */
        $tmpSelect = $helperReport->getListParams($this->_paramsSelect($listDefault));
        $tmpSelect = self::addPrefix($tmpSelect,'dp.');
        if(!isset($tmpSelect['classification_general'])){
            if(!isset($tmpSelect['classification_purchase']) 
                && !isset($tmpSelect['participation_purchase'])
                && !isset($tmpSelect['accumulated_purchase'])
                && !isset($tmpSelect['subtotal_purchase'])){
                $tmpSelect[] = '0 as subtotal_purchase';
            }
            if(!isset($tmpSelect['classification_entry']) 
                    && !isset($tmpSelect['participation_entry'])
                    && !isset($tmpSelect['accumulated_entry'])
                    && !isset($tmpSelect['subtotal_entry'])){
                $tmpSelect[] = '0 as subtotal_entry';
            }
        } 
        
        $tmpString = implode('&&', array_unique($tmpSelect));
        $explode = explode('&&', $tmpString);
        $trim = array_map('trim', $explode);
        $select = implode(',', array_unique($trim));
        //----------------------------------------------------------------------
        $tmpGroupBy = $helperReport->getListParams($this->_paramsGroupBy($listDefault));
        $tmpGroupBy = self::addPrefix($tmpGroupBy,'dp.');
        $groupBy = 'GROUP BY '.implode(',', array_unique($tmpGroupBy));
        //----------------------------------------------------------------------
        $tmpOrderBy = $helperReport->getListParams($this->_paramsOrderBy($listDefault));
        $tmpOrderBy = self::addPrefix($tmpOrderBy, 'dp.');

        if(isset($tmpOrderBy['classification_purchase'])){
            $orderClass['classification_purchase'] = $tmpOrderBy['classification_purchase'];
            unset($tmpOrderBy['classification_purchase']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['participation_purchase'])){
            $orderClass['participation_purchase'] = $tmpOrderBy['participation_purchase'];
            unset($tmpOrderBy['participation_purchase']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['accumulated_purchase'])){
            $orderClass['accumulated_purchase'] = $tmpOrderBy['accumulated_purchase'];
            unset($tmpOrderBy['accumulated_purchase']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['classification_entry'])){
            $orderClass['classification_entry'] = $tmpOrderBy['classification_entry'];
            unset($tmpOrderBy['classification_entry']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['participation_entry'])){
            $orderClass['participation_entry'] = $tmpOrderBy['participation_entry'];
            unset($tmpOrderBy['participation_entry']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        if(isset($tmpOrderBy['accumulated_entry'])){
            $orderClass['accumulated_entry'] = $tmpOrderBy['accumulated_entry'];
            unset($tmpOrderBy['accumulated_entry']); 
            $tmpOrderBy = $orderClass + $tmpOrderBy;
        }
        
        $tmpString = implode('&&', array_unique($tmpOrderBy));
        $explode = explode('&&', $tmpString);
        $trim = array_map('trim', $explode);
        $orderBy = 'ORDER BY '.implode(',', array_unique($trim));
        
        $tmpWhere = [];
        $tmpHaving = [];
        $this->load($params);
        //Condiciones where ----------------------------------------------------
        
        if($this->document_type_purchase != "") 
            $tmpWhere[] = "document_type_purchase = '$this->document_type_purchase'";
        if($this->document_type_entry != "") 
            $tmpWhere[] = "document_type_entry = '$this->document_type_entry'";
        if($this->number_purchase != "") 
            $tmpWhere[] = "number_purchase LIKE '%$this->number_purchase%'";
        if($this->date_purchase != ""){             
            list($dateIn, $dateEnd) = explode(' - ', $this->date_purchase);
            $tmpWhere[] = "date_purchase BETWEEN '$dateIn' AND '$dateEnd'";                      
        }else{            
            if($this->month == '' && $this->year == '' 
                    && $this->date_entry == ''){
                $dateEnd = date('Y-m-d');                
                $dateIn = date('Y-m-d', mktime(0, 0, 0, date('m'), 1, date('Y')));            
                $tmpWhere[] = "date_purchase BETWEEN '$dateIn' AND '$dateEnd'";                      
            }            
        }
        if($this->number_entry != "") 
            $tmpWhere[] = "number_entry LIKE '%$this->number_entry%'";
        if($this->date_entry != ""){             
            list($dateIn, $dateEnd) = explode(' - ', $this->date_entry);
            $tmpWhere[] = " date_entry BETWEEN '$dateIn' AND '$dateEnd'";                      
        }else{            
            if($this->month == '' && $this->year == '' 
                    && $this->date_purchase == ''){
                $dateEnd = date('Y-m-d');                
                $dateIn = date('Y-m-d', mktime(0, 0, 0, date('m'), 1, date('Y')));            
                $tmpWhere[] = " date_entry BETWEEN '$dateIn' AND '$dateEnd'";                      
            }            
        }
        if($this->status_purchase != "") 
            $tmpWhere[] = " status_purchase = $this->status_purchase";
        if($this->nit != "") 
            $tmpWhere[] = " dp.nit LIKE '%$this->nit%'";
        if($this->business_name != "") 
            $tmpWhere[] = " dp.business_name LIKE '%$this->business_name%'";
        if($this->branch_code != "") 
            $tmpWhere[] = " branch_code = '$this->branch_code'";
        if($this->branch_name != "") 
            $tmpWhere[] = " branch_name LIKE '%$this->branch_name%'";
        if($this->reference != "") 
            $tmpWhere[] = " reference = '$this->reference'";
        if($this->description != "") 
            $tmpWhere[] = " description LIKE '%$this->description%'";
        if($this->quantity_purchase != "") 
            $tmpHaving[] = " SUM(quantity_purchase) = '$this->quantity_purchase'";
        if($this->unit_value_purchase != "") 
            $tmpHaving[] = " SUM(unit_value_purchase) = '$this->unit_value_purchase'";
        if($this->quantity_entry != "") 
            $tmpHaving[] = " SUM(quantity_entry) = '$this->quantity_entry'";
        if($this->unit_value_entry != "") 
            $tmpHaving[] = " SUM(unit_value_entry) = '$this->unit_value_entry'";
        if($this->subtotal_purchase != "") 
            $tmpHaving[] = " SUM(quantity_purchase*unit_value_purchase) = '$this->subtotal_purchase'";
        if($this->subtotal_entry != "") 
            $tmpHaving[] = " SUM(unit_value_purchase*quantity_entry) = '$this->subtotal_entry'";
        if($this->operation_center != "") 
            $tmpWhere[] = " operation_center = '$this->operation_center'";       
        if($this->month != "") 
            $tempMes = [];
            if(is_array($this->month) && count($this->month)>0){
                foreach ($this->month as $value){
                   $tempMes[] = $value +1; 
                }
                //$tmpWhere[] = " CONVERT(VARCHAR,MONTH(date_purchase)) IN('"
                //        .implode("','",$tempMes)."')";
						
				$tmpWhere[] = " MONTH(date_purchase) IN('"
                        .implode("','",$tempMes)."')";
            }                                       
        if($this->year != ""){
            $tempAnio = explode(',', $this->year); 
            //$tmpWhere[] = " CONVERT(VARCHAR,YEAR(date_purchase)) IN('"
            //        .implode("','",$tempAnio)."')"; 
			$tmpWhere[] = " MONTH(date_purchase) IN('"
                        .implode("','",$tempMes)."')";
        }
         
        $where = (count($tmpWhere)>0) ? 'WHERE '.implode(" AND ", $tmpWhere): "";
        $having = (count($tmpHaving)>0) ? 'HAVING '.implode(" AND ", $tmpHaving): "";
        
        $arrayResult = DataFulfillmentProvider::getData($select, $where, 
                $groupBy, $orderBy, $having, true);
        
//        if(isset($tmpOrderBy['classification_purchase']) 
//                || isset($tmpOrderBy['participation_purchase'])
//                || isset($tmpOrderBy['accumulated_purchase'])
//                || isset($tmpOrderBy['classification_entry']) 
//                || isset($tmpOrderBy['participation_entry'])
//                || isset($tmpOrderBy['accumulated_entry'])){
//            $arrayResult = ReportSiesa::reportFulfillmentProvider($select, $where, 
//                $groupBy, $orderBy, $having, true);
//        }else{
//            $arrayResult = ReportSiesa::reportFulfillmentProvider($select, $where, 
//                $groupBy, $orderBy, $having);
//        }
        
        return $arrayResult;
    }
    
    /**
     * Genera los  resultados dinamicos para el reporte
     * 
     * @param array $listDefault
     * @param array $params
     * @param array $preview
     * 
     * @return \yii\data\ArrayDataProvider
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function reportFulfillment($listDefault, $params, $preview = false) {
        $arrayResult = $this->_queryExec($listDefault, $params);   
        # Validamos si se presentan todos los datos ----------------------------
        $paramShowAll = '_tog';
        $exportAll = 'all';
        $pagination = ['pageSize' => 30];
        foreach ($_GET as $key => $value) {
            if (strpos($key, $paramShowAll) !== false) {
                if ($value == $exportAll) {
                    $pagination = false;
                }
            }
        }        
        # ----------------------------------------------------------------------        
        if($preview){
            $sort = false;
        }else{
            $sort = [ 'attributes' =>explode(',', $listDefault)];
        }   
        # ----------------------------------------------------------------------        
        return new ArrayDataProvider([
            'allModels' => $arrayResult,
            'sort' => $sort,
            'pagination' => $pagination
        ]);
    }
    
    /**
     * Genera los datos para el grafico dinamico
     * 
     * @param type $dataEjex
     * @param type $dataEjey
     * @param type $params
     * 
     * @return \yii\data\ArrayDataProvider
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2019 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function reportGraph($dataEjex, $dataEjey, $params, $type) {
        $listDefault = $dataEjex.','.$dataEjey;
        $months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 
            'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
        # ----------------------------------------------------------------------
        $listParams = $this->listParams();
        $result = $this->_queryExec($listDefault, $params); 
        # ----------------------------------------------------------------------         
        $groupEjex = explode(',', $dataEjex);
        $keyInit = $groupEjex[0];
        unset($groupEjex[0]);
        if(count($groupEjex)>0){
            $arrayResult = ArrayHelper::index($result, $keyInit, $groupEjex);
        }else{
            $arrayResult = ArrayHelper::index($result, $keyInit);
        } 
        #-----------------------------------------------------------------------
        $data = [];
        $data['x'] = [];
        $data['y'] = [];
        $categories = [];
        
        if(count($arrayResult)>0){ 
            $resultsDataY = [];
            $tempEjeY = explode(',', $dataEjey);
            $helperReport = new HelperReport;
            $helperReport->recursiveWalk($categories, $arrayResult, $resultsDataY, $tempEjeY);
            #-------------------------------------------------------------------
            foreach ($resultsDataY as $key => $value) { 
                switch ($key) {
                    case ('quantity_purchase'):
                    case ('unit_value_purchase'):
                    case ('quantity_entry'):
                    case ('unit_value_entry'):
                    case ('subtotal_purchase'):
                    case ('subtotal_entry'):
                    case ('fulfillment_unit'):
                    case ('fulfillment_references'):
                    case ('fulfillment_time'):
                    case ('fulfillment_purchase'):
                    case ('fulfillment_money'):
                    case ('fulfillment_total'):
                        $name = 'Suma('.$listParams[$key]['content'].')'; 
                        break;
                    default:
                        $name = 'Cant('.$listParams[$key]['content'].')';                        
                        break;
                }
                $data['y'][] = [
                    'type' => $type,  
                    'name'=>$name, 
                    'data'=> array_column($value, $key)];
            }
        } 
        #-----------------------------------------------------------------------

        $response = [
            'lang' => [
                'downloadJPEG' => 'Descargar en JPG',
                'downloadPDF' => 'Descargar en PDF',
                'downloadPNG' => 'Descargar en PNG',
                'downloadSVG' => 'Descargar en SVG',
                'printChart' => 'Imprimir',
                'resetZoom' => 'Reestablecer',
                'resetZoomTitle' => 'Reestablecer 1:1',
            ],
            'chart' => [
                'renderTo' => 'chart-graficas',   
                'height' => '800',
                'zoomType' => 'xy',      
                'responsive'=>[
                    'rules'=>[
                        'condition'=>[
                            //'maxWidth'=>1200
                        ],
                        'chartOptions'=>[
                            'legend'=>['enabled'=>false]
                        ]
                    ]
                ]
            ],
            'exporting' => [
                //'scale' => '4',   
                //'width' => '900',   
                'sourceWidth' => '1000',   
                //'printMaxWidth' => '1000',   
            ],
            'id' => 'chart-g',
            'title' => ['text' => NULL],            
            'plotOptions' => [
                'column' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],
                    'center' => ['50%', '50%'],                    
                    'enableMouseTracking' => false,                    
                ],               
                'area' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],                    
                ],                                            
                'line' => [
                    'dataLabels' => [
                        'enabled'=>true,
                        'format'=>'{point.y:,.0f}',
                    ],                    
                ],                                            
            ],
            'xAxis' => [
                //'title' => ['text' => $listParams[$dataEjex]['content']],
                'labels' => ['rotation' => '-90'],
                'categories' => $categories,               
            ],
            'legend'=>[
                    'layout' => 'vertical',
                    'align' => 'left',
                    'verticalAlign' => 'middle'
            ],
            'yAxis' => [
               'title' => ['text' => '']
            ],
            'series' => $data['y']
        ];
        return json_encode($response, JSON_NUMERIC_CHECK);
    }   
    
    /**
     * 
     * @param type $params
     * @return type
     */
    public function clearParams($params)
    {
        $arrayDelete = [
            'accumulated_purchase',
            'participation_purchase',
            'classification_purchase',
            'accumulated_entry',
            'participation_entry',
            'classification_entry',
            'classification_general',
        ];
        foreach ($arrayDelete as $element) {
            unset($params[$element]); 
        }
        return $params;
    }
    
    public static function addPrefix($array, $prefix){
        if(is_array($array) && count($array)>0){
            foreach ($array as $key => &$value) {
                if(!is_numeric($value) && $key != 'fulfillment_unit' 
                        && $key != 'fulfillment_references'
                        && $key != 'fulfillment_time'
                        && $key != 'fulfillment_purchase'
                        && $key != 'fulfillment_money'
                        && $key != 'fulfillment_total'
                        && $key != 'accumulated_purchase'
                        && $key != 'accumulated_entry'
                        && $key != 'classification_management'
                        && $key != 'participation_purchase'
                        && $key != 'classification_purchase'
                        && $key != 'participation_entry'
                        && $key != 'classification_entry'
                        && $key != 'classification_general'
                    ){
                    $value = $prefix.$value;
                }
            }
        }
        return $array;
    }
}
