<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Fulfillmentprovision;

/**
 * FulfillmentprovisionSearch represents the model behind the search form of `app\models\Fulfillmentprovision`.
 */
class FulfillmentprovisionSearch extends Fulfillmentprovision
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'user_id'], 'integer'],
            [['name', 'paramsAdd', 'paramsDefault', 'filter', 'ejex', 'ejey', 'type', 'created', 'created_by', 'updated', 'updated_by'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Fulfillmentprovision::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'created' => $this->created,
            'updated' => $this->updated,
            'user_id' => $this->user_id,
        ]);

        $query->andFilterWhere(['like', 'name', $this->name])
            ->andFilterWhere(['like', 'paramsAdd', $this->paramsAdd])
            ->andFilterWhere(['like', 'paramsDefault', $this->paramsDefault])
            ->andFilterWhere(['like', 'filter', $this->filter])
            ->andFilterWhere(['like', 'ejex', $this->ejex])
            ->andFilterWhere(['like', 'ejey', $this->ejey])
            ->andFilterWhere(['like', 'type', $this->type])
            ->andFilterWhere(['like', 'created_by', $this->created_by])
            ->andFilterWhere(['like', 'updated_by', $this->updated_by]);

        return $dataProvider;
    }
}
