<?php

namespace app\models;

use Yii;
use yii\db\ActiveRecord;
use yii\db\Expression;
use yii\behaviors\BlameableBehavior;

/**
 * This is the model class for table "reports_references".
 *
 * @property int $id
 * @property string $reference
 * @property string $description
 * @property string $provider_id
 * @property string $provider_name
 * @property string $branch_office_id
 * @property string $branch_office_name
 * @property string $cellar
 * @property string $subtotal
 * @property string last_cost
 * @property string $margin
 * @property string $participation
 * @property string $quantity_existence
 * @property string $quantity_sold
 * @property string $quantity_op
 * @property string $quantity_available
 * @property string $quantity_previous
 * @property string $abc
 * @property string $measured_unit
 * @property string $created
 *
 * @property User $user
 */
class ReportsReferences extends ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'reports_references';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'reference', 'description'], 'required'],
            [['margin', 'participation', 'last_cost', 'quantity_previous', 'subtotal', 'quantity_existence', 'quantity_sold', 'quantity_op',
                'quantity_available', 'abc'], 'number'],
            [['description', 'provider_name', 'branch_office_name'], 'string', 'max' => 250],
            [['provider_id', 'branch_office_id', 'cellar', 'measured_unit'], 'string', 'max' => 45],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'reference' => ['content' => Yii::t('app', 'Reference')],
            'description' => ['content' => Yii::t('app', 'Description')],
            'provider_id' => ['content' => Yii::t('app', 'Provider ID')],
            'provider_name' => ['content' => Yii::t('app', 'Provider')],
            'branch_office_id' => ['content' => Yii::t('app', 'Branch Office')],
            'branch_office_name' => ['content' => Yii::t('app', 'Branch Office')],
            'cellar' => ['content' => Yii::t('app', 'Cellar')],
            'subtotal' => ['content' => Yii::t('app', 'Subtotal')],
            'margin' => ['content' => Yii::t('app', 'Margin')],
            'participation' => ['content' => Yii::t('app', 'Participation')],
            'quantity_existence' => ['content' => Yii::t('app', 'Quantity Inventory')],
            'quantity_sold' => ['content' => Yii::t('app', 'Quantity Sold')],
            'quantity_op' => ['content' => Yii::t('app', 'Quantity op')],
            'quantity_available' => ['content' => Yii::t('app', 'Quantity Available')],
            'abc' => ['content' => Yii::t('app', 'Abc Margin')],
            'measured_unit' => ['content' => Yii::t('app', 'Measured Unit')],
            'last_cost' => ['content' => Yii::t('app', 'Last Cost')],
            'quantity_previous' => ['content' => Yii::t('app', 'Quantity Previous')]
        ];
    }
}
