<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\web\JsExpression;
use kartik\depdrop\DepDrop;
use yii\helpers\Url;
use kartik\date\DatePicker;
use kartik\select2\Select2;

/* @var $this yii\web\View */
/* @var $model app\models\Differences */
/* @var $form yii\widgets\ActiveForm */
$branch = [];
?>

<div class="differences-form box box-solid">
    <div class="box-body">
        <div id="div-error" style="display: none">
            <button class="close" type="button" data-dismiss="alert" aria-hidden="true">×</button>
            <h4><i class="icon fa fa-ban"></i>Alerta!</h4>
            <div id="msg-alert"></div>
        </div>
        
        <?php $form = ActiveForm::begin(); ?>
        
        
        <div class="row">
            <div class="col-md-6">
                <?= $form->field($model, 'nit')->widget(Select2::classname(), [    
                //'initValueText' => $provider, 
                //'data' => Purchases::selectProviders(), 
                'options' => [
                    'placeholder' => 'Seleccione Proveedor...',
                ],
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions' => [
                    'allowClear' => true,
                    'language' => [
                        'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                    ],
                    'minimumInputLength' => 3,
                    'language' => 'es',
                    'ajax' => [
                        'url' => $url = Url::to(['purchases/getlistproviders']),
                        'dataType' => 'json',
                        'data' => new JsExpression('function(params) { return {q:params.term}; }'),                        
                    ],
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . '$("#differences-business_name").val(text); '
                        . 'return data.text; }'),
                ],
                ])->label(Yii::t('app', 'Nit - Razon social'));?>
                <?= $form->field($model, 'business_name')->hiddenInput()->label(false)->error(false); ?>
            </div>
            <div class="col-md-6">
                <?= $form->field($model, 'branch_code')->widget(DepDrop::classname(), [                    
                'type'=>DepDrop::TYPE_SELECT2, 
                'select2Options'=>[
                    'theme' => Select2::THEME_DEFAULT,
                    'pluginOptions'=>[
                        'allowClear'=>true, 
                        'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                        'templateResult' => new JsExpression('function(data) { return data.text; }'),
                        'templateSelection' => new JsExpression('function (data) { '
                            . 'tmpText = data.text;'
                            . 'text = tmpText.split(" - ")[1];'
                            . '$("#differences-branch_name").val(text); '
                            . 'return data.text; }'),
                    ],                            
                 ],
                'pluginOptions'=>[
                    'initialize' => true,
                    'initDepends'=>['purchases-nit'],
                    'depends'=>['purchases-nit'],
                    'placeholder' => 'Seleccione...',
                    'loadingText' => 'Buscando Sucursales...',
                    'url' => Url::to(['getlistbranchs', 'select'=>$branch])
                ]]);
                ?>

                <?= $form->field($model, 'branch_name')
                    ->hiddenInput()->label(false)->error(false); ?>
            </div>
        </div>

        <div class="form-group">
            <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>

    <?php ActiveForm::end(); ?>
    <div id="form-items"></div>
    </div>
</div>
<script>
</script>