<?php

use yii\helpers\Html;
use kartik\export\ExportMenu;
use kartik\grid\GridView;
use app\assets\PuglinsAsset;

/* @var $this yii\web\View */
/* @var $model app\models\Reportes */
/* @var $form yii\widgets\ActiveForm */

$btnRefress = Html::a("<i class='glyphicon glyphicon-refresh'></i> "
    .Yii::t('app', 'Refrescar'), 
    ($model->isNewRecord ? ['create'] : ['update', 'id'=>$model->id]), 
    ['class' => 'btn btn-default']);
?>

<?php
    //Listas sortable
    $gridColumns = $columns;
                                
    $fullExportMenu = ExportMenu::widget([
        'dataProvider' => $dataProvider,
        'columns' => $gridColumns,
        'columnSelectorOptions' => [
            'label' => Yii::t('app', 'Columnas'),
        ],
        'dropdownOptions' => [
            'label' => Yii::t('app', 'Exportar'),
            'class' => 'btn btn-default'
        ],
        //'fontAwesome' => true,
        'showConfirmAlert' => false,
        'target' => '_blank',
        'filename' => $this->title . '_' . date('Ymd'),
        'exportRequestParam' => 'exportar',
        'columnBatchToggleSettings' => [
            'label' => Yii::t('app', 'Todo')
        ],
        'exportConfig' => [
            ExportMenu::FORMAT_TEXT => false,
            ExportMenu::FORMAT_PDF => [
                'label' => Yii::t('app', 'PDF'),
                'iconOptions' => ['class' => 'text-danger'],
                //'linkOptions' => [],
                'showHeader' => true,
                'showPageSummary' => true,
                'showFooter' => true,
                'showCaption' => true,
                'options' => ['title' => Yii::t('app', 'Formato documento portable')],
                'alertMsg' => Yii::t('app', 'PDF generado para descargar.'),
                'filename' => 'PDF - ' . isset($model->name)? $model->name : '',
                'mime' => 'application/pdf',
                'extension' => 'pdf',
                'writer' => 'PDF',                
            ],
            ExportMenu::EXCEL => [
                'filename' => isset($model->name)? $model->name : '',               
            ],
            ExportMenu::FORMAT_HTML => false,
        ]
    ]);
?>
<div class="reportes-gridw box">     
    <?php
    $layout = <<< HTML
    <div class="box-header with-border" >
    {$fullExportMenu} {toggleData} {$btnRefress}
    </div>
        {summary}
    <div class="clearfix"></div>
        {items}
    {pager}
HTML;

    
    if($preview){
        $layout = <<< HTML
    <div class="box-header with-border" >    
    </div>
        {summary}
    <div class="clearfix"></div>
        {items}    
HTML;
    }
    ?>    
    <div class="box-body">
        <small>
            <?= GridView::widget([
                //'id' => 'data-ventas-maquinas',
                'dataProvider' => $dataProvider,
                'filterModel' => $reporteDinamico,
                'responsive' => true,
                'responsiveWrap' => false,
                'showPageSummary' => true,
                'resizableColumns'=>true, 
                'floatHeader'=>false,
                'floatHeaderOptions'=>['scrollingTop'=>'0'],
                'layout' => $layout,
                'toolbar'=> [            
                    '{export}',
                    '{toggleData}',
                ],                    
                'export'=>[
                    'fontAwesome'=>true
                ],   
        //        'floatHeader'=>true,
        //        'floatHeaderOptions'=>['scrollingTop'=>'0'],
                'exportConfig' => [            
                    GridView::EXCEL => true,
                    GridView::PDF => false
                ],
        //        'pjax' => true, // pjax is set to always true for this demo
        //        'pjaxSettings'=>['neverTimeout'=>true,],
                'columns' => $gridColumns,
            ]); ?>
        </small>
    </div>
</div>