<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\components\HelperReport;
use yii\helpers\ArrayHelper;

/* @var $this yii\web\View */
/* @var $searchModel app\models\FulfillmentproviderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Fulfillmentproviders');
$this->params['breadcrumbs'][] = $this->title;
$helperReport = new HelperReport;
?>
<div class="fulfillmentprovider-index box box-solid">
    
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Create Fulfillmentprovider'), ['create'], ['class' => 'btn btn-success']) ?>
        </p>
    </div>  
    <div class="box-body">
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'id',
            'name',
            //'filter:ntext',
            // 'ejex:ntext',
            // 'ejey:ntext',
            // 'type',
            // 'cretaed',
            // 'created_by',
            // 'updated',
            // 'updated_by',
            // 'user_id',
            [
                'attribute' => 'paramsDefault',
                'filter' => false,
                'value' => function($data) use ($helperReport){
                    $listParamsDefault = $helperReport->getTempList($data->paramsDefault, $data->listParams());
                    $arrayMap = ArrayHelper::map($listParamsDefault, 'content', 'content');
                    return implode(' , ', $arrayMap);
                }
            ],
            [
                'header' => 'Ver Reporte',                
                'format' => 'html',
                'contentOptions' => ['class' => 'text-center'],
                'value' => function($data){
                    return Html::a('<span class="fa fa-line-chart"></span>', ['update', 'id'=>$data->id], ['target'=>'_blank']);
                }
            ],
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
    </div>
</div>
