<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Pending */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Pendings'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="pending-view box box-solid">

    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </p>
    </div>  
    <div class="box-body">
        <?= DetailView::widget([
            'model' => $model,
            'attributes' => [
                'id',
                'nit',
                'business_name',
                'branch_name',
                'number_order',
                'reference',
                'description',
				'operation_center',
                [
                    'attribute' => 'quantity',  
                    'format'=>['decimal',0]
                ],
                [
                    'attribute' => 'cost',  
                    'format'=>['decimal',0]
                ],
                'reason',
                'detail:ntext',
                'responsable',
                'created',
                'created_by',
                'updated',
                'updated_by',
            ],
        ]) ?>
    </div>
</div>
