<?php

use kartik\export\ExportMenu;
use kartik\grid\GridView;
\yii\widgets\Pjax::begin();

if(empty($model->name) == TRUE){
    $name = 'Reporte';
}else{
    $name = $model->name;
}

$gridColumns = $columns;

$fullExportMenu = ExportMenu::widget([
    'dataProvider' => $dataProvider,
    'columns' => $gridColumns,
    'columnSelectorOptions' => [
        'label' => Yii::t('app', 'Columnas'),
    ],
    'dropdownOptions' => [
        'label' => Yii::t('app', 'Exportar'),
        'class' => 'btn btn-default'
    ],
    //'fontAwesome' => true,
    'showConfirmAlert' => false,
    'target' => '_blank',
    'filename' => $name . '_' . date('Ymd'),
    'exportRequestParam' => 'exportar',
    'columnBatchToggleSettings' => [
        'label' => Yii::t('app', 'Todo')
    ],
    'exportConfig' => [
        ExportMenu::FORMAT_TEXT => false,
        ExportMenu::FORMAT_PDF => [
            'label' => Yii::t('app', 'PDF'),
            'iconOptions' => ['class' => 'text-danger'],
            //'linkOptions' => [],
            'showHeader' => true,
            'showPageSummary' => true,
            'showFooter' => true,
            'showCaption' => true,
            'options' => ['title' => Yii::t('app', 'Formato documento portable')],
            'alertMsg' => Yii::t('app', 'PDF generado para descargar.'),
            'filename' => 'PDF - ' . $name,
            'mime' => 'application/pdf',
            'extension' => 'pdf',
            'writer' => 'PDF',
        ],
        ExportMenu::FORMAT_HTML => false,
    ]
]);

\yii\widgets\Pjax::end();
?>

<div class="reports-gridw box box-solid">
    <?php
    $layout = <<< HTML
    <div class="box-header with-border" >
    {$fullExportMenu} {toggleData} {$btnRefress}
    </div>
        {summary}
    <div class="clearfix"></div>
        {items}
    {pager}
HTML;
    ?>
    <div class="box-body">
        <small>
            <?php \yii\widgets\Pjax::begin(); ?>
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'filterModel' => $searchModel,
                'responsive' => true,
                'responsiveWrap' => false,
                'showPageSummary' => true,
                'resizableColumns'=>true,
                'floatHeader'=>false,
                'floatHeaderOptions'=>['scrollingTop'=>'0'],
                'layout' => $layout,
                'toolbar'=> [
                    '{export}',
                    '{toggleData}',
                ],
                'export'=>[
                    'fontAwesome'=>true
                ],
                'exportConfig' => [
                    GridView::EXCEL => true,
                    GridView::PDF => true
                ],
                'columns' => $gridColumns,
            ]); ?>
            <?php \yii\widgets\Pjax::end(); ?>
        </small>

        <input type="hidden" name="addParameters" value="<?php echo $valueListParametersAdd; ?>" />
        <input type="hidden" name="defaultParameters" value="<?php echo $valueListDefaultParameters; ?>" />
    </div>
</div>

<?php echo $this->render(
    '_graph', [
    'model' => $model,
    'listDefaultParameters' => $listDefaultParameters
]); ?>