<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \common\models\LoginForm */

$this->title = 'Action Button';

$fieldOptions1 = [
    'options' => ['class' => 'form-group has-feedback'],
    'inputTemplate' => "<i class='glyphicon glyphicon-envelope form-control-feedback'></i>{input}"
];

?>

<div class="login-box">
    <div class="login-logo">
        <?= \yii\helpers\Html::img('img/logo_familia.png', ['width'=>'200']) ?>        
    </div>
    <!-- /.login-logo -->
    <div class="box box-solid">
        <div class="box-header with-border">
            <h4 class="box-title" style="text-align: center">
                Para recuperar tu contrase&ntilde;a ingrese el correo  electr&oacute;nico</h4>
        </div>
        <div class="box-body">
            <div class="login-box-body">
                <?php
                foreach (Yii::$app->session->getAllFlashes() as $key => $message) {
                    echo '<div class="alert alert-' . $key . '">' . $message . '</div>';
                }
                ?>
                <?php $form = ActiveForm::begin(['id' => 'login-form',
                            'enableClientValidation' => false]); ?>
                <?=
                    $form
                    ->field($model, 'email', $fieldOptions1)
                    ->label(false)
                    ->textInput(['placeholder' => $model->getAttributeLabel('email')])
                ?>                
                                
                <div class="row">                                        
                    <div class="col-md-6">
                        <?= Html::submitButton('Enviar',
                                ['class' => 'btn btn-primary btn-block btn-flat',
                            'name' => 'login-button'])
                        ?>
                    </div>    
                    <div class="col-md-6">
                        <u><?= Html::a(Yii::t('app', 'Cancel'), ['login'], ['class' => 'lnk-cancel']) ?></u>
                    </div>
                </div>                
                <?php ActiveForm::end(); ?>
            </div>            
        </div>
    </div>    
</div><!-- /.login-box -->

