   
    /**
     * Presenta el boton liquidar
     * @returns {undefined}
     */
    function showBtnLiquidar(){
        $("#btnLiquidar").show();
    }
    
    /**
     * Esconde el boton liquidar
     * @returns {undefined}
     */
    function hideBtonLiquidar(){
        $("#btnLiquidar").hide();
    }
    
    /**
     * Muestra el icono de cargando
     * @returns {undefined}
     */
    function showLoading(){        
        $("#purchases-form").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
    }
    
    /**
     * Esconde el icono de cargando
     * @returns {undefined}
     */
    function hideLoading(){
        $(".overlay").remove();
    }
    
    /**
     * Muestra los errores
     * @returns {undefined}
     */
    function showError(msg) {
        if (msg === '' || !msg || msg === null) {            
            $("#msg-alert").html('');
            $("#div-error").removeClass('alert alert-danger alert-dismissible');
            $("#div-error").hide();            
        } else {            
            $("#msg-alert").html(msg);            
            $("#div-error").addClass('alert alert-danger alert-dismissible');
            $("#div-error").show();
            $('html, body').stop().animate({
                scrollTop: $("#div-error").offset().top - 50
            }, 1000);
        }
    }
    
    /**
     * Esconde los errores
     * @returns {undefined}
     */
    function cleanError(){
        showError('');
    }
        
    
    
    /**
     * Valida si se ingreso alguna cantidad 
     * @returns {undefined}     
     */
    function valItemSeleciconado(){
        var validador = false;
        $(".amount").each(function() {
            val = $(this).val();
            if (val > 0) {
                validador = true;
            }
        });        
        if(validador == false){
            showError('Seleccione una referencia');
            return false;
        }
        return true;
    }
    
    /**
     * Esconde los registros que no tengan cantidad             
     */
    function hideInputsEmpty(){    
        $('#requisition-nit').select2("enable",false);
        $('#requisition-code_branch').select2("enable",false);
        $('.accordion-content').each(function() { 
            var sw = 0;
            var data = $(this).find('.amount');            
            $(data).each(function() {
                val = $(this).val();                         
                stringTemp = $(this).attr('id');                 
                stringSplit = stringTemp.split('_');
                iden = stringSplit[2];
                //Validamos si tiene cantidad y escondemos los que no tengan ---                
                if (val == 0 || !this.value) {                                        
                    //Escondemos la fila ---------------------------------------
                    $('#' + iden + '_tr').hide();
                    $('#' + 'addInfo-' + iden).hide();                    
                    //Deshabilitamos cada input de la fila ---------------------
                    $('#' + iden + '_id').prop('disabled', 'disabled');
                    $('#' + iden + '_description').prop('disabled', 'disabled');
                    $('#orp_amount_' + iden ).prop('disabled', 'disabled');
                    $('#' + iden + '_inv').prop('disabled', 'disabled');
                    $('#' + iden + '_inv').prop('disabled', 'disabled');
                    $('#' + iden + '_cat').prop('disabled', 'disabled');
                    $('#' + iden + '_amount_request').prop('disabled', 'disabled');
                    $('#' + iden + '_unt_price').prop('disabled', 'disabled');
                    $('#' + iden + '_iva').prop('disabled', 'disabled');
                    $('#' + iden + '_unt_price_iva').prop('disabled', 'disabled');
                    $('#' + 'notas_' + iden ).prop('disabled', 'disabled');
                }else{
                    sw = 1;                    
                    $('#' + 'plus_' + iden).hide();
                    $('#' + iden + '_tr').show();
                    $('#' + 'addInfo-' + iden).show();
                    $('#' + iden + '_tr').removeAttr('class');
                    $(this).attr('readonly', 'readonly');
                    $('#' + 'notas_' + iden ).attr('readonly', 'readonly');
                }
                //$('#' + parentTr).removeAttr('class');
            });            
            //Escondemos la categoria ------------------------------------------ 
            if (sw === 0) {
                $(this).hide();                
            }else{
                var content = $(this).find('.panel-collapse');
                content.attr('aria-expanded', 'true');                    
                content.attr('style', '');                    
                content.addClass('in');
            }
        });
    }
    
    /**
     * Muestra las pestañas de cada categoria para seleccionar nuevos produstos
     * @returns {undefined}     
     */
    function showTabs(){
        $('.accordion-content').each(function() { 
            var sw = 0;
            var data = $(this).find('.amount');            
            $(data).each(function() {
                val = $(this).val();                                
                stringTemp = $(this).attr('id');                 
                stringSplit = stringTemp.split('_');
                iden = stringSplit[2];                
                //Mostramos la fila --------------------------------------------
                $('#' + iden + '_tr').show();
                $('#' + 'plus_' + iden).show();
                //Deshabilitamos cada input de la fila -------------------------
                $('#' + iden + '_id').removeAttr('disabled'); 
                $('#' + iden + '_description').removeAttr('disabled'); 
                $('#orp_amount_' + iden ).removeAttr('disabled'); 
                $('#' + iden + '_inv').removeAttr('disabled'); 
                $('#' + iden + '_inv').removeAttr('disabled'); 
                $('#' + iden + '_cat').removeAttr('disabled'); 
                $('#' + iden + '_amount_request').removeAttr('disabled'); 
                $('#' + iden + '_unt_price').removeAttr('disabled'); 
                $('#' + iden + '_iva').removeAttr('disabled'); 
                $('#' + iden + '_unt_price_iva').removeAttr('disabled'); 
                $(this).removeAttr('readonly');  
                $('#' + 'addInfo-' + iden).removeAttr('style'); 
                $('#' + 'notas_' + iden ).removeAttr('disabled');
                $('#' + 'notas_' + iden ).removeAttr('readonly');
                $('#' + 'addInfo-' + iden).attr('style', 'height: 0px;');  
            });            
            //Mostramos la categoria -------------------------------------------
            $(this).show(); 
            var content = $(this).find('.panel-collapse');
            content.attr('aria-expanded', 'false');                    
            content.attr('style', 'height: 0px;');                    
            content.removeClass('in');            
        });
    }    
    
    /**
     * 
     * @param {type} typeButtom
     * @param {type} url
     * @returns {undefined}
     */
    function buttomSend(typeButtom, url) {        
        $.ajax({url: url,
            type: "post",
            async: false,
            data: {type: typeButtom},
            success: function(data) {
                $("#buttom").html(data);
            }});
    }        
    
    
    
    /**
     * funcion que realiza los calculos de cada item 
     * @param {type} id
     * @param {type} ident
     * @returns {Boolean}     */                
    function calculate(id, ident) {        
        stringQuantity = $('#' + id).val();                 
        quantity = stringQuantity.replace(/[^0-9\.]/g, '');
        tempQuantity = parseInt(quantity);
        tempInvent = parseInt($('#' + ident + "_inv").val());
        invent = $('#' + ident + "_inv").val();
        priceUnt = $('#' + ident + "_unt_price").val();
        priceUntIva = $('#' + ident + "_unt_price_iva").val();
        valUnt = quantity * priceUnt;
        valUntIva = quantity * priceUntIva;
        //evita desborde de los precios ----------------------------------------
        if (valUnt.toString().length > 9 || valUntIva.toString().length > 9) {
            quantity = quantity.substr(0, 5);
            valUnt = quantity * priceUnt;
            valUntIva = quantity * priceUntIva;
            alert('El Número es muy extenso, por favor verifique la cantidad');
        }
        //Senala los items con cantidades en cero o vacio ----------------------
        if (quantity > 0) {
            $('#' + ident + '_tr').removeClass("danger");
            $('#' + ident + '_tr').attr('class', 'success');
        } else {
            $('#' + ident + '_tr').attr('class', 'danger');
        }
        //Sumatorias y formateo de resultados ----------------------------------
        $('#' + id).val(quantity);
        $('#' + ident + '_amount_request').val(tempQuantity);
        $('#' + ident + '_amount_request').number(tempQuantity);
        $('#' + ident + '-sub').html(valUnt);
        $('#' + ident + '-sub').number(valUnt);
        $('#' + ident + '_sub_input_id').val(valUnt);
        $('#' + ident + '_sub_input_id').number(valUnt);
        $('#' + ident + '-sub-iva').html(valUntIva);
        $('#' + ident + '-sub-iva').number(valUntIva);
        return false;
    }
    
    /**
     * Suma los datos de una columna en especifico 
     * @param {string} classDiv
     * @returns {suma|Number}     
     */
    function sumaColumn(classDiv) {
        suma = 0;
        $('' + classDiv + '').each(function() {
            val = jQuery(this).html();
            valInt = val.replace(/,/gi, '');
            suma = suma + parseInt(valInt);
        });
        return suma;
    }
    
    /**
     * Metodo para sacar la relacion 
     * de los calculos
     * @returns {undefined}     
     */
    function summary() {
        //Calculamos el subtotal de siesa --------------------------------------
        subUnt = sumaColumn('.sub_siesa');
        $('#total_neto_jdh').html('$ ' + $.number(subUnt));
        subUntIva = sumaColumn('.sub_iva_siesa');        
        $('#total_jdh').html('$ ' + $.number(subUntIva));
        totalIva = subUntIva - subUnt;        
        $('#total_iva_jdh').html('$ ' + $.number(totalIva));
        //Calculamos el subtotal de tecno --------------------------------------
        subUnt = sumaColumn('.sub_tecno');        
        $('#total_neto_tecno').html('$ ' + $.number(subUnt));
        subUntIva = sumaColumn('.sub_iva_tecno');        
        $('#total_tecno').html('$ ' + $.number(subUntIva));
        totalIva = subUntIva - subUnt;        
        $('#total_iva_tecno').html('$ ' + $.number(totalIva));
        //Calculamos el total del pedido ---------------------------------------
        subUnt = sumaColumn('.sub');        
        $('#total_neto').html('$ ' + $.number(subUnt));
        subUntIva = sumaColumn('.sub_iva');        
        $('#total').html('$ ' + $.number(subUntIva));
        totalIva = subUntIva - subUnt;        
        $('#total_iva').html('$ ' + $.number(totalIva));
        //$('#summary').show();
    }                                                 
    
    function enabledForm(idForm) {
        $('#' + idForm).find('input, textarea, select').removeAttr('disabled');
        $('#buttom').find('button').attr('disabled', 'disabled');
    }

    function submitForm(idForm) {
        form = $('#' + idForm);
        form.submit();
    }
    
    //--------------------------------------------------------------------------
    function validate() {
        $('#btn-summary').show();
        $('#btn-send').hide();
        if ($(".checkAsk").is(':checked')) {
            var pregun = confirm('Desea liquidar la orden?');
            if (!pregun) {
                    event.preventDefault();
                } else {
                    
            var totalPrecio = 0;
            var subtotal = 0;
            $(".checkAsk").each(
                function() {
                    reference = $(this).data("item");
                    if ($(this).is(':checked')) {
                        val = $('#item_' + reference).val();
                        precioUnitario = $('#unit_value_' + reference).val();
                        if (val == 0 || !this.value) {
                            $('#' + reference).hide();
                            $('#' + reference).find('input').attr('disabled', 'disabled');
                        } else {
                            if (precioUnitario == 0 || !this.value) {
                                $('#' + reference).hide();  
                                $('#' + reference).find('input').attr('disabled', 'disabled');
                            } else {
                                subtotal = $('#subtotal_'+reference).html();
                                var valIntSubTotal = subtotal.replace(/,/gi, '');
                                //totalPrecio = totalPrecio + parseInt(valIntSubTotal); 
                                totalPrecio = totalPrecio + parseFloat(valIntSubTotal); 
                                $('#div_suggested_' + reference).html(val);
                                $('#div_suggested_' + reference).number(val);
                                $('#div_suggested_' + reference).show();
                                $('#div_unit_value_' + reference).html(precioUnitario);
                                $('#div_unit_value_' + reference).number(precioUnitario);
                                $('#div_unit_value_' + reference).show();
                                    $('#item_' + reference).hide();
                                    $('#unit_value_' + reference).hide();
                                }
                            }
                        } else {
                            $('#' + reference).hide();
                            $('#' + reference).find('input').attr('disabled', 'disabled');
                        }
                    });
                $('#total').html(totalPrecio);
                $('#total').number(totalPrecio, 2);
                $('#btn-summary').hide();
                $('#btn-send').show();
                $('#tr-total').show();
                return true;
            }
        } else {
            alert('Seleccione una referencia');
        }
        total();
    }


    function edit() {
        jQuery(".checkAsk").each(
                function () {
                    reference = $(this).data("item");
                    $('#' + reference).show();
                    $('#div_suggested_' + reference).hide();
                    $('#div_unit_value_' + reference).hide();
                    $('#item_' + reference).show();
                    $('#unit_value_' + reference).show();
                    $('#' + reference).find('input').removeAttr('disabled');
                });
        $('#tr-total').show();
        $('#btn-summary').show();
        $('#btn-send').hide();
    }
    
    function calculateSuggested(id){        
        result = validateInput(id);        
        if(result === true){            
            parentTd = $('#' + id).parent();
            parentTr = parentTd.parent().attr('id');
            valorUnitario = $('#unit_value_'+parentTr).val();
            cantSugerida = $('#' + id).val();
			measured_unit = $('#measured_unit_'+parentTr).data("m_unit");
			if(measured_unit !== null && measured_unit !== ''){
				cantSugerida = cantSugerida * measured_unit;
			}
            subtotal = cantSugerida * valorUnitario;
			$('#units_' + parentTr).number(cantSugerida);
            $('#subtotal_' + parentTr).html(subtotal);
            $('#subtotal_' + parentTr).number(subtotal);
            //$('#subtotal_' + parentTr).number(subtotal, 2);
        }
        total();
    }
    
    function calculateUnitValue(id){                
        //result = validateInput(id);                  
        result = validateInputFloat(id);  
        if(result === true){            
            parentTd = $('#' + id).parent();
            parentTr = parentTd.parent().attr('id');
            cantSugerida = $('#item_'+parentTr).val();
            valorUnitario = $('#' + id).val();
			measured_unit = $('#measured_unit_'+parentTr).data("m_unit");
			if(measured_unit !== null && measured_unit !== ''){
				cantSugerida = cantSugerida * measured_unit;
			}
            subtotal = cantSugerida * valorUnitario; 
			$('#units_' + parentTr).number(cantSugerida);
            $('#subtotal_' + parentTr).html(subtotal);
            $('#subtotal_' + parentTr).number(subtotal);
            //$('#subtotal_' + parentTr).number(subtotal, 2);
        }
        total();
    }
    
    function validateInput(id) {
        var valueInput = $('#' + id).val();
        var intValue = valueInput.replace(/[^0-9]/g, '');
        $('#' + id).val(intValue);
        parentTd = $('#' + id).parent();
        parentTr = parentTd.parent().attr('id');
        if (intValue > 0) {            
            $('#' + parentTr).removeClass("danger");
        } else {
            $('#' + parentTr).attr('class', 'danger');
            return false;
        }
                
        if (intValue.length > 9 ) {            
            alert('El numero ingresado es muy extenso');
            return false;
        }
        total();
        return true;
    }
    
    function validateInputFloat(id) {
        var value = $('#' + id).val();        
        if(!value.match(/^[0-9]+(\.([0-9]{1,2})?)?$/)) {
            intValue = value.substring(0, value.length - 1);
        }else{
            intValue = value;
        }            
        
        $('#' + id).val(intValue);
        parentTd = $('#' + id).parent();
        parentTr = parentTd.parent().attr('id');
        if (intValue > 0) {            
            $('#' + parentTr).removeClass("danger");
            $('#chAsk_' + parentTr).prop("disabled", false);
        } else {            
            $('#' + parentTr).attr('class', 'danger');
            $('#subtotal_' + parentTr).html(0);
            $('#chAsk_' + parentTr).attr("checked", false);            
            $('#chAsk_' + parentTr).prop("disabled", true);            
            return false;
        }
                
        if (intValue.length > 10 ) {            
            alert('El numero ingresado es muy extenso');
            return false;
        }
        
        return true;
    }
    
    function emptyInput(id) {
        $('#' + id).val('');
        validateInput(id);
    }
    
    function emptyInputFloat(id) {
        $('#' + id).val('');
        validateInputFloat(id);
    }
	
	function disableButton(){
		$(this).prop('disabled', false);
	}
    
    function total(){
        var total = 0;
        $(".checkAsk").each(function() {               
        reference = $(this).data("item");
        if($("#"+this.id).is(':checked')){            
                valor = $("#subtotal_"+reference).text().replace(/,/g,"");
                total += parseFloat(valor);    
            }        
        });

        $("#total").html(total);
        $("#total").number(total, 2);        
    }