/*!
 * @package   yii2-grid
 * @author    Kartik Visweswaran <kartikv2@gmail.com>
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014 - 2019
 * @version   3.3.2
 *
 * Grid Export Validation Module for Yii's Gridview. Supports export of
 * grid data as CSV, HTML, or Excel.
 *
 * Author: Kartik Visweswaran
 * Copyright: 2014 - 2019, Kartik Visweswaran, Krajee.com
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */!function(f){"use strict";var m,r,e="urn:schemas-microsoft-com:office:";m={replaceAll:function(e,t,o){return e.split(t).join(o)},isEmpty:function(e,t){return null==e||0===e.length||t&&""===f.trim(e)},popupDialog:function(e,t,o,n){var i=screen.width/2-o/2;return window.open("",t,"",!0).close(),window.open(e,t,"toolbar=no, location=no, directories=no, status=yes, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width="+o+", height="+n+", top=60, left="+i)},slug:function(e){return e.toLowerCase().replace(/[^\w ]+/g,"").replace(/ +/g,"-")},templates:{html:'<!DOCTYPE html><meta http-equiv="Content-Type" content="text/html;charset={encoding}"/><meta http-equiv="X-UA-Compatible" content="IE=edge;chrome=1"/>{css}<style>.kv-wrap{padding:20px}</style><body class="kv-wrap">{data}</body>',pdf:"{before}\n{data}\n{after}",excel:'<html xmlns:o="'+e+'office" xmlns:x="'+e+'excel" xmlns="http://www.w3.org/TR/REC-html40"><head><meta http-equiv="Content-Type" content="text/html;charset={encoding}"/>{css}\x3c!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--\x3e</head><body>{data}</body></html>',popup:'<html style="display:table;width:100%;height:100%;"><title>Grid Export - &copy; Krajee</title><body style="display:table-cell;font-family:Helvetica,Arial,sans-serif;color:#888;font-weight:bold;line-height:1.4em;text-align:center;vertical-align:middle;width:100%;height:100%;padding:0 10px;">{msg}</body></html>'}},(r=function(e,t){var o=this,n=t.gridOpts,i=t.genOpts;o.$element=f(e),o.gridId=n.gridId,o.$grid=f("#"+o.gridId),o.dialogLib=t.dialogLib,o.messages=n.messages,o.target=n.target,o.exportConversions=n.exportConversions,o.showConfirmAlert=n.showConfirmAlert,o.action=n.action,o.bom=n.bom,o.encoding=n.encoding,o.module=n.module,o.filename=i.filename,o.expHash=i.expHash,o.showHeader=i.showHeader,o.showFooter=i.showFooter,o.showPageSummary=i.showPageSummary,o.$table=o.$grid.find(".kv-grid-table:first"),o.columns=o.showHeader?"td,th":"td",o.alertMsg=t.alertMsg,o.config=t.config,o.popup="",o.listen()}).prototype={constructor:r,getArray:function(e){var n=this,t=n.clean(e),i=[],r={};return void 0!==n.config.colHeads&&0<n.config.colHeads.length?i=n.config.colHeads:t.find("thead tr th").each(function(e){var t=f(this).text().trim(),o=m.slug(t);i[e]=!n.config.$h.slugColHeads||m.isEmpty(o)?"col_"+e:o}),t.find('tbody tr:has("td")').each(function(o){r[o]={},f(this).children("td").each(function(e){var t=i[e];r[o][t]=f(this).text().trim()})}),r},setPopupAlert:function(e){var t=this;if(void 0!==t.popup.document)if(arguments.length&&arguments[1]){var o=t.popup.document.getElementsByTagName("body");setTimeout(function(){o[0].innerHTML=e},1200)}else{var n=m.templates.popup.replace("{msg}",e);t.popup.document.write(n)}},processExport:function(e,t){var o=this;setTimeout(function(){m.isEmpty(t)?o[e]():o[e](t)},100)},listenClick:function(a){var s=this,l=1<arguments.length?arguments[1]:"",c=window[s.dialogLib];s.$element.off("click.gridexport").on("click.gridexport",function(t){if(t.stopPropagation(),t.preventDefault(),s.showConfirmAlert){var e=s.messages,o=m.isEmpty(s.alertMsg)?"":s.alertMsg,n=m.isEmpty(e.allowPopups)?"":e.allowPopups,i=m.isEmpty(e.confirmDownload)?"":e.confirmDownload,r="";if(r=o.length&&n.length?o+"\n\n"+n:!o.length&&n.length?n:o.length&&!n.length?o:"",i.length&&(r=r+"\n\n"+i),!m.isEmpty(r))return c.confirm(r,function(e){e&&s.processExport(a,l),t.preventDefault()}),!1}else s.processExport(a,l)})},listen:function(){var e=this;e.$element.hasClass("export-csv")&&e.listenClick("exportTEXT","csv"),e.$element.hasClass("export-txt")&&e.listenClick("exportTEXT","txt"),e.$element.hasClass("export-html")&&e.listenClick("exportHTML"),e.$element.hasClass("export-xls")&&e.listenClick("exportEXCEL"),e.$element.hasClass("export-json")&&e.listenClick("exportJSON"),e.$element.hasClass("export-pdf")&&e.listenClick("exportPDF")},clean:function(e){var t,o=this,n=o.$table.clone(),i=o.$element.data("cssStyles")||{},r=o.$table.closest(".kv-grid-container"),a=function(e){n.find(e+"."+o.gridId).remove()};"html"===e&&n.find(".kv-grid-boolean").remove(),(t=r.hasClass("kv-grid-wrapper")?r.closest(".floatThead-wrapper").find(".kv-thead-float thead"):r.find(".kv-thead-float thead")).length&&(t=t.clone(),n.find("thead").before(t).remove()),n.find("tr.filters").remove(),n.find("th").removeAttr("rowspan"),n.find("th").find("a").each(function(){f(this).contents().unwrap()}),n.find("form,input,textarea,select,script").remove(),n.find("[onclick]").removeAttr("onclick"),n.find('a[href*="javascript"]').attr("href","#"),o.showHeader||n.children("thead").remove(),o.showPageSummary||a(".kv-page-summary-container"),o.showFooter||a(".kv-footer-container"),o.showCaption||a(".kv-caption-container"),n.find(".skip-export").remove(),n.find(".skip-export-"+e).remove(),n.find(".strip-tags-export").each(function(){var e=f(this),t=e.text();e.html(t)});var s=n.html();return s=o.preProcess(s,e),n.html(s),f.each(i,function(e,t){n.find(e).each(function(){var e=f(this),o=e.attr("style")||"";f.each(t,function(e,t){o+=e+":"+t+";"}),o&&e.attr("style",o)})}),n},preProcess:function(e,t){var o,n,i,r=this.exportConversions,a=r.length,s=e,l="from_"+t,c="to_"+t;if(0<a)for(var p=0;p<a;p++)n=void 0!==(o=r[p])[l]?o[l]:void 0!==o.from?o.from:"",i=void 0!==o[c]?o[c]:void 0!==o.to?o.to:"",n.length&&i.length&&(s=m.replaceAll(s,n,i));return s},download:function(e,t){var o,n,i=this,r=i.$element,a=r.attr("data-mime")||"text/plain",s=window.yii,l=r.attr("data-hash")||"",c=r.attr("data-hash-export-config"),p=m.isEmpty(i.config)?{}:i.config,d=i.target,h=function(e,t){return f("<textarea/>",{name:e}).val(t).hide()};"json"===e&&p.jsonReplacer&&delete p.jsonReplacer,o=s?h(s.getCsrfParam()||"_csrf",s.getCsrfToken()||null):null,(n="_popup"===d)&&(d="kvDownloadDialog",i.popup=m.popupDialog("",d,350,120),i.popup.focus(),i.setPopupAlert(i.messages.downloadProgress)),f("<form/>",{action:i.action,target:d,method:"post",css:{display:"none"}}).append(h("export_filetype",e),h("export_filename",i.filename)).append(h("export_encoding",i.encoding),h("export_bom",i.bom?1:0)).append(h("export_content",t),h("module_id",i.module),o).append(h("export_mime",a),h("export_hash",l),h("hash_export_config",c)).append(h("export_config",JSON.stringify(p))).appendTo("body").submit().remove(),n&&i.setPopupAlert(i.messages.downloadComplete,!0)},exportHTML:function(){var e,t=this.clean("html"),o=this.config,n=o.cssFile?o.cssFile:[],i="";e=m.templates.html.replace("{encoding}",this.encoding),f.each(n,function(e,t){i+='<link href="'+t+'" rel="stylesheet" crossorigin="anonymous">\n'}),e=e.replace("{css}",i).replace("{data}",f("<div />").html(t).html()),this.download("html",e)},exportPDF:function(){var e=this,t=e.clean("pdf"),o=m.isEmpty(e.config.contentBefore)?"":e.config.contentBefore,n=m.isEmpty(e.config.contentAfter)?"":e.config.contentAfter,i=e.config.css,r=m.templates.pdf.replace("{css}",i).replace("{before}",o).replace("{after}",n).replace("{data}",f("<div />").html(t).html());e.download("pdf",r)},exportTEXT:function(e){var o=this,t=o.clean(e).find("tr:has("+o.columns+")"),n=String.fromCharCode(11),i=String.fromCharCode(0),r='"'+o.config.colDelimiter+'"',a='"'+o.config.rowDelimiter+'"',s='"'+t.map(function(e,t){return f(t).find(o.columns).map(function(e,t){return f(t).text().trim().replace(/"/g,'""')}).get().join(n)}).get().join(i).split(i).join(a).split(n).join(r)+'"';o.download(e,s)},exportJSON:function(){var e=this.getArray("json");e=JSON.stringify(e,this.config.jsonReplacer,this.config.indentSpace),this.download("json",e)},exportEXCEL:function(){var e,t,o=this,n=o.clean("xls"),i=o.config.cssFile&&o.config.cssFile.length?'<link href="'+o.config.cssFile+'" rel="stylesheet">':"";n.find("td[data-raw-value]").each(function(){((t=f(this)).css("mso-number-format")||0===t.css("mso-number-format")||"0"===t.css("mso-number-format"))&&t.html(t.attr("data-raw-value")).removeAttr("data-raw-value")}),e=m.templates.excel.replace("{encoding}",o.encoding).replace("{css}",i).replace("{worksheet}",o.config.worksheet).replace("{data}",f("<div />").html(n).html()).replace(/"/g,"'"),o.download("xls",e)}},f.fn.gridexport=function(n){var i=Array.apply(null,arguments);return i.shift(),this.each(function(){var e=f(this),t=e.data("gridexport"),o="object"==typeof n&&n;t||e.data("gridexport",t=new r(this,f.extend({},f.fn.gridexport.defaults,o,f(this).data()))),"string"==typeof n&&t[n].apply(t,i)})},f.fn.gridexport.defaults={dialogLib:"krajeeDialog"},f.fn.gridexport.Constructor=r}(window.jQuery);